// dp[] N^2 memory, O(N^4)   ( dp[i][j] = min bla bla see formulas below )
// 1) - for i,j search for best intervals k1=1..bestk1[i][j-1], k2=1..bestk2[i-1][j] => N^2*k^2 complexity (for k = some bitch)
// 2) - print best intervals and see that always k1==1 || k2==1 => N^2*k
// 3) - print best intervals again and see that i,j comes from either k1=bestk1[i][j-1]-1 || bestk1[i][j-1] && k2=1 
//        OR k1=1 && k2=bestk2[i-1][j]-1 || best[i-1][j] and reduce to N^2
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

#define MAXN 2048
int n,m,N,M,P,T,K;
int a[MAXN],b[MAXN];
LL dp[MAXN][MAXN];
int prevx[MAXN][MAXN],prevy[MAXN][MAXN];
int sa[MAXN],sb[MAXN];
LL ska[MAXN][MAXN],skb[MAXN][MAXN];

int main()
{
    scanf("%d%d",&N,&M);
    Repi(N) scanf("%d",a+i+1); Repi(M) scanf("%d",b+i+1);
    reverse(a+1,a+N+1); reverse(b+1,b+M+1);
    Repi(N) sa[i+1]=sa[i]+a[i+1]; Repi(M) sb[i+1]=sb[i]+b[i+1];
    
    memset(dp,127,sizeof(dp)); dp[0][0]=0;
    LL nd; int i1,j1;
    for (int i=1;i<=N;i++)
     for (int j=1;j<=M;j++)
      {
        i1=prevx[i-1][j]+1;
        j1=prevy[i][j-1]+1;
        for (int k1=MAX(i1-1,1);k1<=i1;k1++)
         {
             nd=dp[i-k1][j-1]+(LL)(sa[i]-sa[i-k1]-k1)*(sb[j]-sb[j-1]-1);
             if (nd<dp[i][j])
              {
                dp[i][j]=nd;
                prevx[i][j]=k1; prevy[i][j]=1;
              }
         }
        for (int k2=MAX(j1-1,1);k2<=j1;k2++)
         {
             nd=dp[i-1][j-k2]+(sa[i]-sa[i-1]-1)*(sb[j]-sb[j-k2]-k2);
             if (nd<dp[i][j])
              {
                dp[i][j]=nd;
                prevx[i][j]=1; prevy[i][j]=k2;
              }
         }
        
        //do this and see that always k1==1 || k2==1
    /*   for (int k1=1;k1<=i1;k1++)
          for (int k2=1;k2<=j1;k2++)
          {
           nd=dp[i-k1][j-k2]+(LL)(sa[i]-sa[i-k1]-k1)*(sb[j]-sb[j-k2]-k2);
           if (nd<dp[i][j])
            {
              dp[i][j]=nd;
              prev[i][j]=MP(k1,k2);
            }
          } 
        */
      }
    printf("%d\n",dp[N][M]);

    cout<<Time<<endl;
    return 0;
}
