//area of union of rectangles - NlogM !!!! using interval tree
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m,N;
struct node{ int st,len,sum,times; node *l,*r;
  node(){};
  node(int start,int N) { st=start,sum=times=0,len=N; l=r=NULL; };
 };


node *root;

inline void fixsum(node *tree)
{
	tree->sum=0;
	if (tree->l) tree->sum+=tree->l->sum;
	if (tree->r) tree->sum+=tree->r->sum;
}

void insert(node *tree,int a,int b)
{
	if (a<=tree->st && b>=tree->st+tree->len-1) 
	 { tree->sum=tree->len; tree->times++; return;}
	if (b<tree->st+tree->len/2)
	 {
			if (!tree->l) tree->l=new node(tree->st,tree->len/2);
			insert(tree->l,a,b);
	 }
	else
	if (a>=tree->st+tree->len/2)
	 {
			if (!tree->r) tree->r=new node(tree->st+tree->len/2,tree->len/2);
			insert(tree->r,a,b);
	 }
	else
	 {
	  if (!tree->l) tree->l=new node(tree->st,tree->len/2);
	  if (!tree->r) tree->r=new node(tree->st+tree->len/2,tree->len/2);
	  insert(tree->l,a,tree->st+tree->len/2-1);
	  insert(tree->r,tree->st+tree->len/2,b);
	 }
	if (!tree->times) fixsum(tree);
}

bool erase(node *tree,int a,int b) //assuming it has been previously inserted; returns 1 if tree was deleted or was not present at all
{
	if (!tree) return 1;
	if (a<=tree->st && b>=tree->st+tree->len-1) 
	 tree->times--; 
	else
	 if (b<tree->st+tree->len/2)
	  { if (erase(tree->l,a,b)) tree->l=0; }
	 else
	  if (a>=tree->st+tree->len/2)
	   { if (erase(tree->r,a,b)) tree->r=0; }
	  else
	   {
	    if (erase(tree->l,a,tree->st+tree->len/2-1)) tree->l=0;
	    if (erase(tree->r,tree->st+tree->len/2,b)) tree->r=0;
	   }
	if (!tree->times)
	 {
	  if (!tree->l && !tree->r && tree!=root) { delete tree; return 1; } //??? efficient?? !!
	  fixsum(tree);
	 }
    return 0;
}

int query(node *tree,int a,int b)
{
	if (!tree || b<tree->st || a>=tree->st+tree->len || a>b) return 0;
	if (tree->times) return min(b,tree->st+tree->len-1)-max(a,tree->st)+1;
	if (a<=tree->st && b>=tree->st+tree->len-1)
	 return tree->sum;
	return query(tree->l,a,b)+query(tree->r,a,b);
}

inline void spaces(int n) { Repi(n) cout<<" "; }
void print(node *tree,int lev)
{
	if (!tree) return;
	print(tree->r,lev+1);
	spaces(lev*5);
	cout<<"("<<tree->st<<","<<tree->st+tree->len-1<<")="<<tree->sum<<"x"<<tree->times<<"\n";
	print(tree->l,lev+1);
}

#define MAXN 1001000
pair<PI,PI> p[MAXN];
struct line{ int x,sy,ey; bool rem;
     line(){};
     line(int _x,int _sy,int _ey,bool _rem):x(_x),sy(_sy),ey(_ey),rem(_rem) {};
    };
bool operator<(line a,line b)
{
	if (a.x==b.x)
	 if (a.sy==b.sy)
	  if (a.ey==b.ey)
	   return a.rem<b.rem;
	  else return a.ey<b.ey;
	 else return a.sy<b.sy;
	return a.x<b.x;
}
line hah[MAXN];

int main()
{
    int i,j,k,l,maxy=0;
    
    scanf("%d",&n);
    Repi(n)
     {
      scanf("%d%d%d%d",&p[i].x.x,&p[i].x.y,&p[i].y.x,&p[i].y.y);
      hah[i*2]=line(p[i].x.x,p[i].x.y,p[i].y.y,0);
      hah[i*2+1]=line(p[i].y.x,p[i].x.y,p[i].y.y,1);
      maxy=max(maxy,p[i].y.y);
	 } 
     
    sort(hah,hah+n*2);
    
    N=1; while(N<=maxy) N*=2;
    root=new node(0,N);
    
    int lastx=hah[0].x;
    LL ans=0;
    for (int i=0;i<n*2;)
     {
			ans+=(LL)query(root,0,N-1)*(LL)(hah[i].x-lastx);
//			cout<<lastx<<" "<<hah[i].x<<" - "<<query(root,0,N-1)<<endl;
			lastx=hah[i].x;
			while (i<n*2 && hah[i].x==lastx)
			 {
					if (hah[i].rem) erase(root,hah[i].sy,hah[i].ey-1);
					else insert(root,hah[i].sy,hah[i].ey-1);
					i++;
			 }
	 }
	cout<<ans<<endl;

   cout<<(double)clock()/CLOCKS_PER_SEC<<endl;
    return 0;
}
