//pfs (modified dijkstra) - traverse vertices in increasing cost, which keeps all pairs<cost,time> for each vertex sorted by cost
//in order for the paths to each vertex to be minimal => these pairs should be also automatically sorted by time, but decreasing
//note that each vertex is traversed once for each minimal route to it
//note also that a similar idea with increasing-decreasing pairs was used in team, balkan 2004
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

int n,m,N,M,P,T,K,start,end;

#define MAXN 128
VI adj[MAXN];
VI cost[MAXN],tim[MAXN];
vector<PI> d[MAXN];
typedef pair<PI,int> tip;

inline bool stava(int v,const PI &A) //check whether we can add the new pair<cost,time> to vertex v as a minimal route
{
      // cout<<" try add "<<A.x<<" "<<A.y<<" to "<<v<<" : "; Repi(d[v].SZ) cout<<d[v][i].x<<" "<<d[v][i].y<<" ; "; cout<<endl;
       
       if (!d[v].SZ) {    //cout<<"   1\n"; 
                return 1; }
       PI &B=d[v][d[v].SZ-1];
       if (B.x==A.x) {    // cout<<"     0\n"; 
               return 0; }
     //  cout<<"     "<<(B.y>A.y)<<"\n";
       return B.y>A.y;
}

int main()
{
    int a,b,c,d,v; PI A;
    scanf("%d%d%d%d",&N,&M,&start,&end);
    Repi(M)
     {
           scanf("%d%d%d%d",&a,&b,&c,&d);
           cost[a].PB(c); cost[b].PB(c);
           adj[b].PB(a); adj[a].PB(b);
           tim[a].PB(d); tim[b].PB(d);
     }
     
    priority_queue<tip,vector<tip>,greater<tip> > q;
    tip tmp;
    q.push(MP(MP(0,0),start));
    while (!q.empty())
     {
          tmp=q.top(); q.pop();
          if (!stava(tmp.y,tmp.x)) continue;
          ::d[tmp.y].PB(tmp.x);
        //  cout<<"in "<<tmp.y<<" - "<<tmp.x.x<<" "<<tmp.x.y<<endl;
          Repi(adj[tmp.y].SZ)
           {
                             v=adj[tmp.y][i];
                             A=MP(tmp.x.x+cost[tmp.y][i],tmp.x.y+tim[tmp.y][i]);
                         //    cout<<" from "<<tmp.y<<" to "<<v<<" - "<<A.x<<" "<<A.y<<endl;
                             if (stava(v,A))
                                            q.push(MP(A,v));
           }
     }

    printf("%d\n",::d[end].SZ);   
    cout<<Time<<endl;  
    return 0;
}
