#include <cstdio>
#include <ctime>

#define min(a, b)						((a) < (b) ? (a) : (b))

typedef struct edge
{
	int v1, v2;
	int c, t;
};

const int MAX_V = 110;
const int MAX_E = 310;
const int MAX_C = 110 * 110;
const int INF = 1 << 25;

int V, E, START, END, ans;
int dp[MAX_V * MAX_C][MAX_V];
edge e[MAX_E];

void Read()
{
	scanf("%d %d %d %d", & V, & E, & START, & END);
	
	for(int i = 0; i < E; i ++)
	{
		scanf("%d %d %d %d", & e[i].v1, & e[i].v2, & e[i].c, & e[i].t);
	}
}

void Solve()
{
	for(int i = 0; i < MAX_C; i ++)
	{
		for(int j = 0; j < MAX_V; j ++)
		{
			dp[i][j] = INF;
		}
	}
	
	for(int i = 0; i < E; i ++)
	{
		if(e[i].v1 == START)
		{
			dp[e[i].c][e[i].v2] = min(dp[e[i].c][e[i].v2], e[i].t);
		}
		
		if(e[i].v2 == START)
		{
			dp[e[i].c][e[i].v1] = min(dp[e[i].c][e[i].v1], e[i].t);
		}
	}
	
	for(int cost = 0, ok = 0, last = INF; cost < MAX_C; cost ++, ok = 0)
	{
		while(!ok)
		{
			ok = true;
			
			for(int i = 0; i < E; i ++)
			{
				if(cost + e[i].c < MAX_C)
				{
					if(dp[cost][e[i].v2] + e[i].t < dp[cost + e[i].c][e[i].v1])
					{
						ok = false;
						dp[cost + e[i].c][e[i].v1] = dp[cost][e[i].v2] + e[i].t;
					}
					
					if(dp[cost][e[i].v1] + e[i].t < dp[cost + e[i].c][e[i].v2])
					{
						ok = false;
						dp[cost + e[i].c][e[i].v2] = dp[cost][e[i].v1] + e[i].t;
					}
				}
			}
		}
		
		if(dp[cost][END] < last)
		{
			ans ++;
			last = dp[cost][END];
		}
	}
}

void Write()
{
	printf("%d\n", ans);
}

int main()
{
	Read();
	
	Solve();
	
	Write();
	
	printf("MARTIN RUN TIME: %.5lf", clock() / double(CLOCKS_PER_SEC));
	
	return 0;
}
