//dijkstra in graph with vertices = vertex + entered speed
//optimization: if we've been in the same intersection with a higher speed and a lower/equal time, don't advance from it with current speed
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

int n,m,N,M,P,K;

double d[151][1024],reald[151][1024];
PI from[151][512];
VD L[151],V[151];
VI adj[151];
VI ans;
bool used[151][512];

typedef pair<double,PI> tip;

inline void push(double d[],int pos,double val)
{
       for(;pos;pos-=pos&(-pos))
        d[pos]=MIN(d[pos],val);
}

inline double qry(double d[],int pos)
{
       double ret=1e300;
       for(;pos<=512;pos+=pos&(-pos))
        ret=MIN(ret,d[pos]);
       return ret;
}

int main()
{
    int a,b,c,e;
    scanf("%d%d%d",&N,&M,&P);
    Repi(M)
     {
           scanf("%d%d%d%d",&a,&b,&c,&e);
           adj[a].PB(b);
           V[a].PB(c); 
           L[a].PB(e); 
     }
    
    memset(d,127,sizeof(d));
    memset(reald[P],127,sizeof(reald[P]));
    PQ<tip,vector<tip>,greater<tip> > q;
    tip tmp; int u,v,vv; int newv; double newtime;
    q.push(MP(0,MP(0,70))); from[0][70]=MP(-1,666); push(d[0],70,0);
    while (!q.empty())
     {
          tmp=q.top(); q.pop();
          u=tmp.y.x; vv=tmp.y.y;
          if (used[u][vv]) continue; used[u][vv]=1;
          reald[u][vv]=tmp.x;
       //   cout<<" in "<<u<<" "<<vv<<" - "<<tmp.x<<endl;
          Repi(adj[u].SZ)
           {
                         v=adj[u][i]; newv=(V[u][i])?V[u][i]:vv; newtime=tmp.x+L[u][i]/(double)newv;
                         if (qry(d[v],newv)>newtime)
                          {
                                //                cout<<"   from "<<u<<" "<<vv<<" to "<<v<<" "<<newv<<" - "<<newtime<<endl;
                                                q.push(MP(newtime,MP(v,newv)));
                                                from[v][newv]=MP(u,vv);
                                                push(d[v],newv,newtime);
                          }
           }
     }
   
    vv=0;
    Repi(501)
     if (reald[P][i]<reald[P][vv]) vv=i;
    PI cur=MP(P,vv);
    
    while (cur.y!=666)  //hope there will always be a route...
     { ans.PB(cur.x); cur=from[cur.x][cur.y]; }
    reverse(ans.begin(),ans.end());
    Repi(ans.SZ-1) printf("%d ",ans[i]); printf("%d\n",ans[ans.SZ-1]);
    
    cout<<Time<<endl;
    return 0;
}
