//solving second conjunctive normal form (2-CNF) (???) ; strongly connected components in directed graph ; topological sorting
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m;
PI a1[300000];
VI adj[1000100],radj[1000100];
bool used[1000100];

int order[1000100],oc;
void dfs1(int v)
{
	used[v]=1;
	Repi(adj[v].SZ)
	 if (!used[adj[v][i]])
	  dfs1(adj[v][i]);
	order[oc++]=v;
}


VI group[1000100]; int gc;
int pargr[1000100];
void dfs(int v)
{
	used[v]=1;
	pargr[v]=gc;
	group[gc].PB(v);
	Repi(radj[v].SZ)
	 if (!used[radj[v][i]])
	  dfs(radj[v][i]);
}

bool groupok[1000100];
set<int> par[1000100],chi[1000100];
set<int> enemies[1000100];
bool u[1000100];

void reject(int v)
{
	groupok[v]=0; u[v]=1;
	for (set<int>::IT it=par[v].begin(); it!=par[v].end(); it++)
	 if (!u[*it]) reject(*it);
}

int total=0;
void include(int v)
{
//	cout<<"INCL "<<v<<endl;
	u[v]=1;
	total+=group[v].SZ;
	for (set<int>::IT it=enemies[v].begin(); it!=enemies[v].end(); it++)
	 if (!u[*it])
	  reject(*it);
}

bool state[1000100];

void topsort(int v)
{
	used[v]=1;
	for (set<int>::IT it=chi[v].begin(); it!=chi[v].end(); it++)
	 if (!used[*it]) topsort(*it);
	order[oc++]=v;
}

int main()
{
    int i,j,k,l;
    scanf("%d%d",&n,&m);
    Repi(n)
     {
			int a,sa,b,sb;
			scanf("%d%d%d%d",&a,&sa,&b,&sb);
			a--; b--;
			a1[i]=MP(a*2+sa,b*2+sb);
			adj[(a*2+sa)^1].PB(b*2+sb); //if the opposite of a*2+sa is true (state[a]!=sa) => a*2+sa is not true => b*2+sb MUST be true (state[b]=sb)
			adj[(b*2+sb)^1].PB(a*2+sa); //and vice versa
			
			radj[b*2+sb].PB((a*2+sa)^1); //reverse edges for the strongly-connected-component algorithm
			radj[a*2+sa].PB((b*2+sb)^1);
	 }
    
//    Repi(2*m)     {		cout<<i<<" -> ";	Repj(adj[i].SZ) cout<<adj[i][j]<<" "; cout<<endl; }	cout<<endl;
    
    Repi(2*m)
     if (!used[i])
      dfs1(i);
    reverse(order,order+oc);
    
    memset(used,0,sizeof(used));
    Repi(2*m)
     if (!used[order[i]])
      {
			groupok[gc]=1;
			dfs(order[i]);
			gc++;
	  }

    //Repi(gc)     {			cout<<i<<" : "; Repj(group[i].SZ) cout<<group[i][j]<<" "; cout<<endl; 	 }

    Repi(2*m) //x*2 and x*2+1 cannot be both true
     if (pargr[i]==pargr[i^1]) reject(pargr[i]);
     else 
      {
			enemies[pargr[i]].insert(pargr[i^1]);
			enemies[pargr[i^1]].insert(pargr[i]);
	  }
	  
	int g1,g2;
	Repi(n) //at least one of the conditions for each channel must be satisfied => their opposites cannot be both satisfied
	 {
			g1=pargr[a1[i].x^1],g2=pargr[a1[i].y^1];
			if (g1==g2) reject(g1);
			else { enemies[g1].insert(g2); enemies[g2].insert(g1); }
	 }
	 
//    Repi(gc) cout<<groupok[i]<<" "; cout<<endl;

    Repi(2*m)
     {
	  g1=pargr[i];
      //if (groupok[g1]) - ina4e se preebava top sort-a
       Repj(adj[i].SZ)
        {
		 g2=pargr[adj[i][j]];
		 if (g1==g2) continue;
		 //if (!groupok[g2]) continue; - ina4e topsort fucks up
		 par[g2].insert(g1);
		 chi[g1].insert(g2);
		}
	 }
    
  //  Repi(gc) { cout<<i<<"("<<groupok[i]<<") => "; for (set<int>::IT it=chi[i].begin(); it!=chi[i].end(); it++) cout<<*it<<" "; cout<<endl; }
  //  Repi(gc) { cout<<i<<"("<<groupok[i]<<") !!! "; for (set<int>::IT it=enemies[i].begin(); it!=enemies[i].end(); it++) cout<<*it<<" "; cout<<endl; }
    
    memset(used,0,sizeof(used));
    oc=0;
    Repi(gc)
     if (!par[i].SZ)
      topsort(i);
    
    //Repi(oc) cout<<order[i]<<" "; cout<<endl;
    
    Repi(gc)
     if (!u[order[i]])
      include(order[i]);

    if (total<m)
     { printf("IMPOSSIBLE\n"); return 0; }
     
    Repi(gc)
     if (groupok[i])
      Repj(group[i].SZ)
       state[group[i][j]/2]=group[i][j]%2;
    
    Repi(m)
     printf("%d\n",state[i]);
     
    bool solok=1;
    Repi(n)
    {
	 int a=a1[i].x/2,sa=a1[i].x%2,b=a1[i].y/2,sb=a1[i].y%2;
     if (state[a]!=sa && state[b]!=sb)
      { solok=0; break; }
	}
	if (!solok) cout<<"GRE6EN OTGOVOR!!!!\n";
	else cout<<"OK! :)\n";
    
    return 0;
}
