//max flow min cut ; improved shortest path aka push relabel + next edge optimization
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 20000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m;
#define MAXN 512
int cost[MAXN][MAXN];
int source,sink;
VI adj[MAXN];

int pushrelabel()
{
	int q[MAXN],d[MAXN],p[MAXN],next[MAXN];
	bool u[MAXN];
	int v,w,cnt,augm,flow=0;
	
	Repi(n*2) d[i]=INF;
	d[sink]=0;
	q[0]=sink; memset(u,0,sizeof(u)); u[sink]=1;
	for (int s=0,e=1;s<e;s++)
	 {
			v=q[s];
			Repi(adj[v].SZ)
			 {
					w=adj[v][i]; if (u[w]) continue;
					d[w]=d[v]+1;
					u[w]=1;
					q[e++]=w;
			 }
	 }
	
	memset(next,0,sizeof(next));
	v=source; p[source]=-1;
	while (d[source]<n*2)
	 {
			for(;next[v]<adj[v].SZ;next[v]++)
			 {
			   int w=adj[v][next[v]];
			   if (cost[v][w] && d[w]==d[v]-1) break;
			 }
			 
			if (next[v]==adj[v].SZ)
			 {
					d[v]=INF;
					Repi(adj[v].SZ)
					 if (cost[v][adj[v][i]])
					  d[v]<?=d[adj[v][i]]+1;
					next[v]=0;
					if (v!=source) v=p[v];
					continue;
			 }
			p[adj[v][next[v]]]=v;
			v=adj[v][next[v]];
			if (v==sink)
			 {
					cnt=0;
					while (v!=-1) { q[cnt++]=v; v=p[v]; }
					reverse(q,q+cnt);
					augm=INF;
					Repi(cnt-1) augm<?=cost[q[i]][q[i+1]];
				//	Repi(cnt) cout<<q[i]/2+1<<" "; cout<<" -> "<<augm<<endl;
					Repi(cnt-1) { cost[q[i]][q[i+1]]-=augm; cost[q[i+1]][q[i]]+=augm; }
					flow+=augm;
					v=source;
				//	Repi(n*2) cout<<d[i]<<" "; cout<<endl;
			 }
	 }
	 return flow;
}

void addedge(int u,int v,int c)
{
	cost[u][v]=c;
	adj[u].PB(v); adj[v].PB(u);
	//cout<<u<<" -> "<<v<<" ("<<c<<")"<<endl;
}

VI ans;
void bfs()
{
	int q[MAXN];
	bool u[MAXN]; memset(u,0,sizeof(u));
	q[0]=source; u[source]=1;
	for (int s=0,e=1;s<e;s++)
	 {
			int v=q[s];
			Repi(adj[v].SZ)
			 if (!u[adj[v][i]] && cost[v][adj[v][i]])
			  {
					q[e++]=adj[v][i];
					u[adj[v][i]]=1;
			  }
	 }
	Repi(n)
	 if (u[i*2] && !u[i*2+1])
	  ans.PB(i+1);
}

int main()
{
    int i,j,k,l;
    scanf("%d%d%d%d",&n,&m,&source,&sink);
    source--; sink--;
    source*=2; sink*=2; sink++;
    Repi(n)
     {
			scanf("%d",&l);
			addedge(i*2,i*2+1,l);
	 }
	Repj(m)
	 {
			scanf("%d%d",&k,&l);
			k--; l--;
			addedge(k*2+1,l*2,INF);
			addedge(l*2+1,k*2,INF);
	 }
    
    pushrelabel();
    bfs();
    
    Repi(ans.SZ) cout<<ans[i]<<" "; cout<<endl;
    
    cout<<(double)clock()/CLOCKS_PER_SEC<<endl;
    return 0;
}
