// gaussian elimination in gf(2) 
// [a][b] = 1 iff switch b influences the state of bulb a ; [a][N+1] = 1 iff bulb a's state should be switched after all
// note: use bitset for fast row xor
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;
#define MAXN 1024
int n,m,N,M,P,T,K;
bitset<MAXN> g[MAXN];
int idx[MAXN]; bool init[MAXN];
VI adj[MAXN];

void printshit(int lev)
{
	for (int i=1;i<=N;i++)
	 {
			Repj(lev) cout<<" "; cout<<idx[i]<<": ";
			for (int j=1;j<=N;j++) cout<<g[i][j]; cout<<" "<<g[i][N+1]<<endl;
	 }
	cout<<endl;
}

bool swi[MAXN];

void gauss()
{
	for (int i=1;i<=N;i++)
	 {
			if (!g[i][i])
			 {
			  for (int j=i+1;j<=N;j++)
			   if (g[j][i]) { swap(g[i],g[j]); swap(idx[i],idx[j]);
			                  goto ok; }
			  continue;
			 }
			ok:;
			
			for (int j=i+1;j<=N;j++)
			 if (g[j][i])
			  g[j]^=g[i];
	 }
	
	for (int i=N;i;i--)
	 {
			swi[i]=g[i][N+1]&g[i][i];
			for (int j=i-1;j;j--)
			 g[j][N+1]=g[j][N+1]^(g[j][i]&swi[i]);
	 }
}

int ac;
int ans[MAXN];

bool check()
{
	ac=0; Repi(N) if (swi[i+1]) 
	 {  ans[ac++]=i+1;
	    Repj(adj[i+1].SZ)
				init[adj[i+1][j]]^=1;
	 }
	Repi(N) if (!init[i+1]) return 0; return 1;
}


int main()
{
	int a,b;
    scanf("%d",&N);
	for (int i=1;i<=N;i++) idx[i]=i;
    Repi(2*N-3)
     {
			scanf("%d%d",&a,&b);
			g[a][b]=g[b][a]=1;
			adj[a].PB(b); adj[b].PB(a);
	 }
	Repi(N)
	 scanf("%d",&a),init[i+1]=a,g[i+1][N+1]=!a,g[i+1][i+1]=1,adj[i+1].PB(i+1);
	 
	gauss();
	if (!check()) { printf("0\n"); return 0; }
    
    Repi(ac-1) printf("%d ",ans[i]); if (ac) printf("%d\n",ans[ac-1]);
     
    cout<<Time<<endl;
    return 0;
}
