//MY SOLUTION!!! :))) 
//separate the hull in 2 parts with two opposite points A,B
//for every line check whether it intersects AB
//if it doesn't, then the two points farthest from the line are located in opposite parts of the hull relating to AB
//not only that, but the graphics of oriented_distance() are like /\ and \/ in the two parts IF the line intersects the hull after all
//which means we can bsearch for the two points and tell whether they're located on the same side of the line
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
//#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

int n,m,N,M,P,T,K;

#define MAXN 100100
PD p[MAXN];
PD A,B;


inline int sign(double x){ return (x>0)-(x<0); }

inline double cp(const PD &A,const PD &B,const PD &C)
{	double dx1=B.x-A.x,dy1=B.y-A.y,dx2=C.x-A.x,dy2=C.y-A.y;
	return dx1*dy2-dx2*dy1; }


int sweephull(PD p[],int N)
{
	sort(p,p+N); int n=2;
	for (int i=2;i<N;i++)
	 {  while (n>1 && cp(p[n-2],p[n-1],p[i])>0) n--;
	    swap(p[i],p[n++]);	 }
    sort(p+n,p+N,greater<PD>());
    int m=n++; p[N]=p[0];
    for (int i=n;i<=N;i++)
     {
		while (n>m && cp(p[n-2],p[n-1],p[i])>0) n--;
	    swap(p[i],p[n++]);	 }
   return n;
}






double a,b,c;

inline double disttoline(int v)
{	 return p[v].x*a+p[v].y*b+c; }







bool brute(bool debug=0)
{
	a=A.y-B.y,b=B.x-A.x,c=A.x*B.y-B.x*A.y;
	for (int i=1;i<m;i++)
	 if (sign(cp(A,B,p[i]))!=sign(cp(A,B,p[0]))) 
	  {
//		    if (debug) cout<<"  "<<i<<" 0\n";
			return 1;
	  }
	return 0;
}

void brutanalno()
{
   while (scanf("%lf%lf%lf%lf",&A.x,&A.y,&B.x,&B.y)==4)
    {
					if (brute())
					 printf("BAD\n");
					else printf("GOOD\n");
	}
}








bool omgwtf()
{
	a=A.y-B.y,b=B.x-A.x,c=A.x*B.y-B.x*A.y;
	if (sign(disttoline(0))!=sign(disttoline(n))) return 1;
	
    int cur=1,l1=0,r1=n,l2=n,r2=m,mid; while (disttoline(cur)==disttoline(0)) cur++;
    double d1,d2,dd1,dd2;
    if (disttoline(0)<disttoline(cur)) swap(l1,l2),swap(r1,r2);
    int s0=sign(disttoline(0));
    
    while (l1<r1) //find minimum
     {
			mid=(l1+r1)>>1;
			d1=disttoline(mid),d2=disttoline(mid+1);
			if (d1<d2) r1=mid;
			else l1=mid+1;
	 }
	dd1=disttoline(l1);
	
    while (l2<r2) //find maximum
     {
			mid=(l2+r2)>>1;
			d1=disttoline(mid),d2=disttoline(mid+1);
			if (d1>d2) r2=mid;
			else l2=mid+1;
	 }
	dd2=disttoline(l2);

	return sign(dd1)!=sign(dd2);
}



int main()
{
    scanf("%d",&N);
    Repi(N)
     { scanf("%lf%lf",&p[i].x,&p[i].y); }
    
   m=sweephull(p,N);
   Repi(m)
	 if (p[i]>p[i+1]) { n=i; break; }

    if (N<=20)
     {
			brutanalno();
			return 0;
	 }

   while (scanf("%lf%lf%lf%lf",&A.x,&A.y,&B.x,&B.y)==4)
     {
					if (omgwtf())
					 printf("BAD\n");
					else printf("GOOD\n");
	 } 
	
	cout<<Time<<endl;
    return 0;
}
