// binary search radius - fix 2 points on circle => 2 possible centers ; use heuristic to quickly tell if there can't be K points in circle, otherwise iterate
// overall: O(N^3*log20000) upper bound
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)
#define F(i,n) for (int i=0;i<n;i++)

#define INF 2000000000

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

int N,K;
double RR,R;
const int MAXN=512;
const double EPS=1e-5;
PD p[MAXN];

inline double dist1(const PD &A,const PD &B)
{
	return sqr(A.x-B.x)+sqr(A.y-B.y);
}

int byx[MAXN],byy[MAXN];
bool cmpx(const int a,const int b)
{ 	 return p[a].x<p[b].x; }
bool cmpy(const int a,const int b)
{  return p[a].y<p[b].y; }

inline bool yey(const PD &X)
{
	p[N]=MP(X.x-R-EPS,0);
	int p1x=lower_bound(byx,byx+N,N,cmpx)-byx;
	p[N]=MP(X.x+R+EPS,0);
	int p2x=upper_bound(byx,byx+N,N,cmpx)-byx;
	p[N]=MP(0,X.y-R-EPS);
	int p1y=lower_bound(byy,byy+N,N,cmpy)-byy;
	p[N]=MP(0,X.y+R+EPS);
	int p2y=upper_bound(byy,byy+N,N,cmpy)-byy;
	//cout<<"                                      yey "<<X.x<<" "<<X.y<<" R "<<R<<" - byx "<<p1x<<" "<<p2x<<"   byy "<<p1y<<" "<<p2y<<"\n";
	int *p1,n;
	if (p2x-p1x<p2y-p1y)
	 p1=byx+p1x,n=p2x-p1x;
	else
	 p1=byy+p1y,n=p2y-p1y;
	if (n<K) { //cout<<"NO!\n";
				 return 0; }
	int cnt=0;
	Repi(n)
	 {
	   if (dist1(X,p[p1[i]])<=RR+EPS) cnt++;//,cout<<"  add "<<p1[i]<<"\n";
	   if (cnt>=K || cnt+n-i-1<K) break;
	 }
//	if (cnt>=K) cout<<"YES!\n"; else cout<<"NO\n";
	return cnt>=K;
}

PD ans;
bool can(double rr)
{
	R=rr;
	//cout<<"     try "<<R<<"\n";
	RR=R*R;
	Repi(N)
	 for (int j=i+1;j<N;j++)
	  if ( dist1(p[i],p[j])<=4*RR )
	   {
		//	cout<<"       pnts "<<i<<" "<<j<<"\n";
			PD mid=MP(p[i].x+p[j].x,p[i].y+p[j].y); mid.x/=2.,mid.y/=2.;
			PD up=MP(p[j].x-mid.x,p[j].y-mid.y);
			double d1=dist1(mid,p[j]);
			double d2=sqrt(RR-d1);
			d1=sqrt(d1);
			up.x*=d2/d1,up.y*=d2/d1;
		//	cout<<"             nmid "<<mid.x<<" "<<mid.y<<" up "<<up.x<<" "<<up.y<<"  d1= "<<d1<<" d2="<<d2<<"\n";
			PD X=mid; X.x-=up.y,X.y+=up.x;
			PD Y=mid; Y.x+=up.y,Y.y-=up.x;
		//	cout<<"             centers "<<X.x<<" "<<X.y<<" and "<<Y.x<<" "<<Y.y<<"\n";
			
			if (yey(X)) { ans=X; return 1;}
			if (X!=Y && yey(Y)) { ans=Y; return 1; }
	   }
	return 0;
}


int check(const PD &X,double R)
{
	int cnt=0;
	Repi(N)
	 if (dist1(X,p[i])<=R*R+2e-4) cnt++;
	return cnt;
}


int main()
{
    scanf("%d%d",&N,&K);
    Repi(N)
     {
			scanf("%lf%lf",&p[i].x,&p[i].y);
		//	cout<<" "<<i<<" -> "<<p[i].x<<" "<<p[i].y<<"\n";
			byx[i]=byy[i]=i;
	 }
	sort(byx,byx+N,cmpx); sort(byy,byy+N,cmpy);
//	cout<<" byx: "; Repi(N) cout<<byx[i]<<" "; cout<<"\n";
//	cout<<" byy: "; Repi(N) cout<<byy[i]<<" "; cout<<"\n";
	 
	
	
	//for (double r=0;r<=4;r+=.5)	 {			if (can(r)) cout<<r<<" : YES!\n"; else cout<<r<<": NO\n";	 }
	 
	 
	double l=0,r=20000.;
	while (l+3e-5<r)
	 {
			double m=(l+r)/2.;
			bool godown=can(m);
			//cout<<"          "<<m<<" ("<<l<<" "<<r<<") - can "<<godown<<"\n";
			if (godown) r=m;
			else l=m;
	 }
	can(r);
	printf("%.5lf\n%.5lf %.5lf\n",r,ans.x,ans.y);
	fprintf(stderr,"checker: %d >= %d\ntime : %.5lf\n",check(ans,r),K,Time);
    return 0;
}
