#include "necklace.h"
#include <iostream>
#include <fstream> 
#include <sstream>
#include <iomanip>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <vector>
#include <set>
#include <bitset>
#include <map>
#include <queue>
#include <algorithm>
#include <utility>
#include <numeric>
#include <functional>
#include <list>

using namespace std;
#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)
#define PI pair<int,int>
#define VI vector<int>
#define PB push_back
#define MP make_pair
#define ALL(v) (v).begin(),(v).end()
#define x first
#define y second
#define LL long long
#define SZ size()
#define sqr(a) ((a)*(a))


#define MAXN 1000100 


struct nn{ int from,lpos,rpos; nn(){}; nn(int fr,int lp,int rp){from=fr,lpos=lp,rpos=rp;};  };

nn n[MAXN];
int cnt,L[MAXN],R[MAXN];

void init()
{
   cnt=1;
   n[0]=nn(-1,667,666);
   L[0]=R[0]=0;
}

int pearl (int neck_id, int on_left)
{
     if (on_left) return L[neck_id];
     return R[neck_id];
}

void create (int fr, char oper, int on_left, int param)
{
      if (oper=='A')
       {
          if (on_left)
           n[cnt]=nn( fr,  n[fr].lpos-1, n[fr].rpos),L[cnt]=param,R[cnt]=(R[fr])?R[fr]:param;
          else
           n[cnt]=nn( fr,  n[fr].lpos, n[fr].rpos+1 ),L[cnt]=(L[fr])?(L[fr]):param,R[cnt]=param;
       }
      else
       {
         if (on_left)
          {
            n[cnt]=nn( fr, n[fr].lpos+1, n[fr].rpos );
            R[cnt]=L[cnt]=R[fr];
            for(;fr;fr=n[fr].from)
             {
                if (n[fr].lpos==n[cnt].lpos)
                 { L[cnt]=L[fr]; break; }
                if (n[fr].rpos==n[cnt].lpos)
                 { L[cnt]=R[fr]; break; }
             }
          }
         else
          {
            n[cnt]=nn( fr, n[fr].lpos, n[fr].rpos-1 );
            L[cnt]=R[cnt]=L[fr];
            for (;fr;fr=n[fr].from)
             {
               if (n[fr].lpos==n[cnt].rpos)
                { R[cnt]=L[fr]; break; }
               if (n[fr].rpos==n[cnt].rpos)
                { R[cnt]=R[fr]; break; }
             }
          }
       }
       
      if (n[cnt].lpos>n[cnt].rpos) L[cnt]=R[cnt]=0;
   //   cout<<cnt<<" : "<<n[cnt].from<<" ["<<n[cnt].lpos<<","<<n[cnt].rpos<<"] ; "<<L[cnt]<<" "<<R[cnt]<<endl;
      cnt++;
}

/*
struct necklace{ int lpar,rpar,lpar1,rpar1,lcol,rcol,len; 
                  necklace(){};
                  necklace(int a,int b,int c,int d,int e,int f,int g){ lcol=a,rcol=b,lpar=c,lpar1=d,rpar1=e,rpar=f,len=g; };
                };

int cnt;
necklace neck[MAXN];

void printnex()
{
   Repi(cnt)
       cout<<i<<" - ("<<neck[i].len<<") "<<neck[i].lcol<<" "<<neck[i].rcol<<" ; "<<neck[i].lpar<<" "<<neck[i].lpar1<<" - "<<neck[i].rpar1<<" "<<neck[i].rpar<<endl;
   cout<<endl;
}

void init1 ()
{
  neck[0]=necklace(0,0,0,0,0,0,0);
  cnt=1;
}

int pearl1 (int neck_id, int on_left)
{
   if (on_left) return neck[neck_id].lcol;
   return neck[neck_id].rcol;
}

void create1 (int fr, char oper, int on_left, int param)
{
       int l=neck[fr].lpar,l1=neck[fr].lpar1,r1=neck[fr].rpar1,r=neck[fr].rpar;
       
       
       if (oper=='A')
          {
           if (neck[fr].len==3)
            {
               if (on_left)
                 neck[cnt]=necklace( param,neck[fr].rcol ,
                                     cnt, l, r1, r, 
                                     4);
               else
                 neck[cnt]=necklace( neck[fr].lcol,param,
                                     l,l1,r,cnt,
                                     4 );
            }
           else
           if (neck[fr].len==2)
            {
               if (on_left)
                 neck[cnt]=necklace( param , neck[fr].rcol,
                                     cnt, l, l, r,
                                     3 );
               else
                 neck[cnt]=necklace( neck[fr].lcol , param ,
                                     l, r, r, cnt,
                                     3 );
            }
           else
           if (neck[fr].len==1)
            {
               if (on_left)
                 neck[cnt]=necklace( param, neck[fr].rcol,
                                     cnt, r, cnt ,r,
                                     2 );
               else
                 neck[cnt]=necklace( neck[fr].lcol , param,
                                     l, cnt, l ,cnt,
                                     2 );
            }
           else
           if (neck[fr].len==0)
            {
               neck[cnt]=necklace(param,param,cnt,0,0,cnt,1);
            }
           else
            {
                if (on_left)
                    neck[cnt]=necklace(param,neck[fr].rcol , cnt,neck[fr].lpar , neck[fr].rpar1,neck[fr].rpar , neck[fr].len+1);
                else
                    neck[cnt]=necklace(neck[fr].lcol,param , neck[fr].lpar,neck[fr].lpar1 , neck[fr].rpar,cnt , neck[fr].len+1);
            }
          }
          
          
       else
       
       
          {
           if (neck[fr].len==4)
            {
                if (on_left)
                 neck[cnt]=necklace( neck[l1].lcol , neck[fr].rcol,
                                     l1, r1 , r1 , r ,
                                     3 );
                else
                 neck[cnt]=necklace( neck[fr].lcol , neck[r1].rcol,
                                     l, l1, l1, r1 ,
                                     3 );
            }
           else
           if (neck[fr].len==3)
            {
                if (on_left)
                 neck[cnt]=necklace( neck[l1].lcol , neck[fr].rcol ,
                                     l1, r, l1, r ,
                                     2);
                else
                 neck[cnt]=necklace( neck[fr].lcol , neck[r1].rcol ,
                                     l, r1 , l , r1,
                                     2);
            }
           else
           if (neck[fr].len==2)
            {
               if (on_left)
                neck[cnt]=necklace( neck[fr].rcol , neck[fr].rcol ,
                                    r, 0, 0, r,
                                    1 );
               else
                neck[cnt]=necklace( neck[fr].lcol , neck[fr].lcol ,
                                    l, 0, 0, l,
                                    1);
            } 
           else
           if (neck[fr].len==1)
            {
               neck[cnt]=necklace(0,0, 0,0, 0,0, 0);
            }
           else
            {
               if (on_left)
                    neck[cnt]=necklace( neck[l1].lcol , neck[fr].rcol,
                                        l1, neck[l1].lpar1 , r1, r,
                                        neck[fr].len-1 );
               else
                    neck[cnt]=necklace( neck[fr].lcol , neck[l1].rcol,
                                        l, l1, neck[r1].rpar1 , r1,
                                        neck[fr].len-1 );
            }
        }
        
        
       cnt++;
 printnex();
}
*/

/*
int main()
{

init();
create(0,'A',1,3);
create(1,'A',0,5);
create(2,'A',1,7);
create(3,'A',1,8);
create(4,'R',1,0);
create(5,'R',0,0);
create(6,'A',0,6);
create(7,'R',0,0);
create(8,'A',0,7);
create(9,'R',1,0);
create(10,'R',1,0);
create(11,'A',1,9);
create(4,'A',1,9);
create(13,'A',0,6);
create(14,'R',0,0);
create(15,'R',1,0);
create(16,'R',0,0);
create(17,'R',1,0);
cout<<pearl(4,0)<<" "<<pearl(4,1)<<endl;
create(0,'A',0,1);
create(19,'A',0,2);
create(20,'A',0,3);
create(21,'A',0,4);
create(22,'A',0,5);
create(23,'A',0,6);
create(24,'A',0,7);
create(25,'A',0,8);
create(26,'A',1,9);
create(27,'A',1,10);
create(28,'A',1,11);
create(29,'A',1,12);
create(30,'R',1,0);
create(31,'R',1,0);
create(32,'R',1,0);
create(33,'R',1,0);
create(34,'R',1,0);
create(35,'R',1,0);
create(36,'R',1,0);
create(37,'R',1,0);
create(38,'R',0,0);
create(39,'A',1,666);
create(40,'A',1,777);
create(41,'R',0,0);
create(42,'R',0,0);
create(43,'R',0,0);
create(44,'R',0,0);
create(45,'R',0,0);

/*
create(0,'A',1,5);
create(1,'A',1,3);
cout<<"                                     dsfgdfsgsdfgsdfg "<<pearl(2,0)<<endl;
create(2,'R',0,0);
cout<<"                                      dsfgdfsgsdfgsdfg "<<pearl(3,0)<<endl;
cout<<"                                     dsfgdfsgsdfgsdfg "<<pearl(2,0)<<endl;
*/
   //return 0;
//}
