//wrong solution fixed: for each group we keep a list of candidates for starts of an empodio, updating the list whenever
//we add a[i] to (a[i]-1)'s group by adding a[i] as a new candidate to it and then popping all candidates that have been added later than the
//earliest added number in (a[i]+1)'s group
//before that, we check whether each of the candidates of (a[i]-1)'s group can be a start of an empodio ending at a[i] and if we find one,
//we declare the entire group as an empodio, even the numbers before the used candidate, since they cannot be part of any empodio - if they could, they would have already formed one
//note that to make my life easier and to know which group to which is added, i removed the 'rank' heuristic from the disjoint sets structure
//note also that the list of candidates is dynamic (with static memory, of course) since even initializing vectors in the set structure increases running time 1.5x
//final note: when the unite function is inlined, program runs slower (?!?!) overall, surprisingly, the solution is not even a bit slower than the wrong one which does not iterate over candidates but greedily choses the first one
#include <vector>
#include <list>
#include <map>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;
#define MAXN 1100100

int n,m,N,M,P,T,K;
int a[MAXN],pos[MAXN];
bool used[MAXN];

int prevcand[MAXN];
struct set{ 
	int par,leftmost,small,large;
    bool empodio;
    int candidate,firstcandidate;
    set(){};
	set(int x){leftmost=pos[x]; par=small=large=candidate=firstcandidate=x; prevcand[x]=-1; empodio=0; };
          };
set sets[MAXN];

int findroot(int x)
{
	if (x==sets[x].par) return sets[x].par;
	sets[x].par=findroot(sets[x].par);
	return sets[x].par;
}

void unite(int x,int y)
{
    int sm=MIN(sets[x].small,sets[y].small),lr=MAX(sets[x].large,sets[y].large),lf=MIN(sets[x].leftmost,sets[y].leftmost);
	x=findroot(x);
	y=findroot(y);
	sets[y].par=x; sets[x].small=sm; sets[x].large=lr; sets[x].leftmost=lf;
}

vector<PI> ans;

int main()
{
    scanf("%d",&M);
    int prev,next,cand,cand1;
    Repi(M)
     {
			scanf("%d",a+i);
			pos[a[i]]=i;
			sets[a[i]]=set(a[i]);
			used[a[i]]=1;
			if (i && used[a[i]-1])
			 {
					prev=findroot(a[i]-1);
					if (sets[prev].empodio) goto sux;
					unite(prev,a[i]);
					prevcand[a[i]]=sets[prev].candidate;
					sets[prev].candidate=a[i];
					
					for (cand=prevcand[a[i]];cand>-1;cand=prevcand[cand])
					 if (i-pos[cand]==a[i]-cand)
					  {
							ans.PB(MP(pos[cand]+1,i+1));
							sets[prev].empodio=1; //we can simply discard all other elements before cand in the group - they can't form an empodio since they haven't done it already
							sets[prev].large--; sets[a[i]]=set(a[i]);
					  }
					sux:;
			 }
			 
			if (used[a[i]+1])
			 {
					prev=findroot(a[i]);
					next=findroot(a[i]+1);
					if (sets[next].empodio || sets[prev].empodio) goto sux2;
					while (sets[prev].candidate>-1 && pos[sets[prev].candidate]>sets[next].leftmost)
							sets[prev].candidate=prevcand[sets[prev].candidate];
					
					unite(next,prev);
					if (sets[prev].candidate>-1)
					 {
					   prevcand[sets[next].firstcandidate]=sets[prev].candidate;
					   sets[next].firstcandidate=sets[prev].firstcandidate;
					 }
					sux2:;
			 }
	 }
	
	printf("%d\n",ans.SZ);
	Repi(ans.SZ)
	 printf("%d %d\n",ans[i].x,ans[i].y);
	fprintf(stderr,"time: %lf\n",Time);
    return 0;
}
