//for each cafe (x,y) we keep the best answer for each point (i,y) and each (x,i) for i=-1000...1000, and compute the same values for the next cafe (advance from each point to two next points)
//note that we only need the information for the previous cafe to advance to the next - we don't keep the others
//optimization: keep all visited states in queue and advance only from them (don't advance from unused states - it's pointless)
//note that a 'used' array (lastux,lastux in the case) is maintained, storing the last time each value was modified - that way there's no need to memset all arrays with zero at each step
//...................only test 19 runs for 2 sec, all others are <1s
#include <iostream> 
#include <fstream>
#include <sstream>
#include <iomanip>
#include <cstdlib>
#include <cstdio>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <queue>
#include <list>
#include <algorithm>
#include <utility>
#include <numeric>
#include <functional>
#include <cmath>
#include <ctime>

using namespace std;

#define Repi(n) for (int i=0;i<(n);i++)
#define Repj(n)	for (int j=0;j<(n);j++)
#define Repk(n) for (int k=0;k<(n);k++)
#define VI vector<int>
#define PB push_back
#define MP make_pair
#define x first
#define y second
#define SZ size()
#define ALL(v) v.begin(),v.end()
#define LL long long
#define UI unsigned int
#define sqr(a) ((a)*(a))
#define PI pair<int,int>
#define Time (double)clock()/CLOCKS_PER_SEC

#define INF 1000000000

#define MAXN 20100
#define MAXX 2048
int N;
PI p[MAXN];

int bestx[2][MAXX],besty[2][MAXX];
int qx[2][MAXX],qcx[2],qy[2][MAXX],qcy[2];
int lastux[MAXX],lastuy[MAXX];

int main()
{
  scanf("%d",&N);
  Repi(N)
   scanf("%d%d",&p[i+1].x,&p[i+1].y),p[i+1].x+=1000,p[i+1].y+=1000;
   
  int at=0,x,y;
  p[0]=MP(1000,1000);
  qx[0][0]=1000; qcx[0]=1; qcy[0]=0;
  bestx[0][1000]=0;
  for (int i=1;i<=N;i++)
   {
        y=p[i-1].y;
        Repj(qcx[at])
         {
            x=qx[at][j];
            if (lastux[x]<i)
             {
                qx[at^1][qcx[at^1]++]=x;
                lastux[x]=i;
                bestx[at^1][x]=INF;
             }
            bestx[at^1][x]=min(bestx[at^1][x],bestx[at][x]+abs(p[i].y-y));
            
            if (lastuy[y]<i)
             {
                 qy[at^1][qcy[at^1]++]=y;
                 lastuy[y]=i;
                 besty[at^1][y]=INF;
             }
            besty[at^1][y]=min(besty[at^1][y],bestx[at][x]+abs(p[i].x-x));
         }
         
        x=p[i-1].x;
        Repj(qcy[at])
         {
            y=qy[at][j];
            
            if (lastuy[y]<i)
             {
                qy[at^1][qcy[at^1]++]=y;
                lastuy[y]=i;
                besty[at^1][y]=INF;
             }
            besty[at^1][y]=min(besty[at^1][y],besty[at][y]+abs(p[i].x-x));
            
            if (lastux[x]<i)
             {
                 qx[at^1][qcx[at^1]++]=x;
                 lastux[x]=i;
                 bestx[at^1][x]=INF;
             }
            bestx[at^1][x]=min(bestx[at^1][x],besty[at][y]+abs(p[i].y-y));
         }
        
        at^=1;
        qcx[at^1]=qcy[at^1]=0;
   }
  
  int ans=INF;
  Repi(qcx[at])
   ans=min(ans,bestx[at][qx[at][i]]);
  Repi(qcy[at])
   ans=min(ans,besty[at][qy[at][i]]);
  printf("%d\n",ans); 
   
  return 0;
}
