//consider the function dist[i](x) = the distance between i and its real position if shifted by x
//its graphic is something like ../\/\/\/\... consider all dist[i] planted in a coordinate system for 0<=x<n
//as the distance between two consequtive "peaks" of the same dist[i] is n, there is exactly one peak for each function in the interval
//we need to choose x such that max(dist[all i](x)) is minimum; this minimum is obviously the point between
//two neigbouring peaks of some dist[j] and dist[k]. to find it, simply check all of these values which are N at most
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m;
int a[1000100];
bool peak[1000100];

inline int difference(int a,int b)
{
	if (a==-1) return 0;
	return (b-a)/2;
}

void getpeaks()
{
	int dif1,dif2,top,dif;
    int last=-1,first=-1;
    memset(peak,0,sizeof(peak));
    Repi(n) 
	 {
			dif=a[i]-i-1;
			dif1=(dif>=0)?dif:(n+dif);
			dif2=n-dif1;
//			cout<<dif1<<" "<<dif2<<endl;
			if (dif1<dif2)
			 {
					top=(2*n-(n/2-dif1))%n;
//					cout<<a[i]<<" going down "<<top<<" "<<(n+top-1)%n<<endl;
					peak[top]=1; if (n%2) peak[(n+top-1)%n]=1;
			 }
			else
			 {
					top=(n+(n/2-dif2))%n;
//					cout<<a[i]<<" going up "<<top<<" "<<(top+1)%n<<endl;
					peak[top]=1; if (n%2) peak[(top+1)%n]=1;
			 }
//			Repj(n) cout<<peak[j]<<" "; cout<<endl;
	 }
}

int getanswer()
{
    int ans=0;
    int first=-1,last=-1;
    Repi(n)
     if (peak[i])
      {
			if (first==-1) first=i;
			ans=max(ans,difference(last,i));
			last=i;
	  }
	ans=max(ans,difference(last,first+n));
	return n/2-ans;
}

int main()
{
    int i,j,k,l,;
    scanf("%d",&n);
    Repi(n) scanf("%d",a+i);
	 
    getpeaks();
    int ans=getanswer();
    reverse(a,a+n);
    getpeaks();
    ans<?=getanswer();
    
    printf("%d\n",ans);
    
    return 0;
}
