//find minimum height chamber in given pyramid using 2D index RMQ
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m,N,M,r,c,a[1024][1024],R;
int sum[1024][1024],vals[1024][1024];
PI b[2048][2048];

inline int Sum(int r1,int c1,int r2,int c2)
{  return sum[r2][c2]-sum[r2][c1-1]-sum[r1-1][c2]+sum[r1-1][c1-1];  }


//optimizations - no temporary variables (especially PI) ; binary shifting instead of */2 ; break if no use to update any further (!!!)
void push2(int val,int x,int y)
{
	vals[x][y]=val;
    int yy=-1,ox=x,oy=y;
	x+=R-1; y+=R-1;
	b[x][y]=MP(ox,oy);
	while(x)
	 {
		    if (yy!=-1) b[x][y]=(vals[b[x<<1][y].x][b[x<<1][y].y]<vals[b[(x<<1)+1][y].x][b[(x<<1)+1][y].y])?b[x<<1][y]:b[(x<<1)+1][y];
		    if (vals[b[x][y].x][b[x][y].y]<val) break;
			yy=y>>1;
			while(yy)
			 {
				    b[x][yy]=(vals[b[x][yy<<1].x][b[x][yy<<1].y] < vals[b[x][(yy<<1)+1].x][b[x][(yy<<1)+1].y])?b[x][yy<<1]:b[x][(yy<<1)+1];
				    if (vals[b[x][yy].x][b[x][yy].y]<val) break;
				    yy>>=1;
			 }
			x>>=1;
	 }
}

//optim - no temp vars
inline PI query2(int x1,int y1,int x2,int y2)
{
	x1+=R-1; x2+=R-1; y1+=R-1; y2+=R-1;
	int yy1,yy2; PI ret,ans;
	while (x1<=x2)
	 {
            yy1=y1,yy2=y2;
            while (yy1<=yy2)
             {
					ret=(vals[b[x1][yy1].x][b[x1][yy1].y]<vals[b[x1][yy2].x][b[x1][yy2].y])?b[x1][yy1]:b[x1][yy2];
					if (vals[ret.x][ret.y]<vals[ans.x][ans.y]) ans=ret;
					yy1=(yy1+1)/2; yy2=(yy2-1)/2;
			 }
            yy1=y1,yy2=y2;
            while (yy1<=yy2)
             {
					ret=(vals[b[x2][yy1].x][b[x2][yy1].y]<vals[b[x2][yy2].x][b[x2][yy2].y])?b[x2][yy1]:b[x2][yy2];
					if (vals[ret.x][ret.y]<vals[ans.x][ans.y]) ans=ret;
					yy1=(yy1+1)/2; yy2=(yy2-1)/2;
			 }
			x1=(x1+1)/2; x2=(x2-1)/2;
	 }
	return ans;
}


/*
PI statb[11][1024][1024];

void initstat()
{
	for (int i=1;i<=N;i++)
	 for (int j=1;j<=M;j++)
	  statb[0][i][j]=MP(i,j);
	PI t,tt;
	for (int pw=1;(1<<pw)<=R;pw++)
	 {
			int step=1<<(pw-1);
			for (int i=1;i<=N && i+step<=R;i++)
			 for (int j=1;j<=M && j+step<=R;j++)
			  {
			    statb[pw][i][j]=statb[pw-1][i][j];
			    PI &tt=statb[pw][i][j];
			    t=statb[pw-1][i+step][j];
			    if (vals[t.x][t.y]<vals[tt.x][tt.y]) tt=t;
			    t=statb[pw-1][i][j+step];
			    if (vals[t.x][t.y]<vals[tt.x][tt.y]) tt=t;
			    t=statb[pw-1][i+step][j+step];
			    if (vals[t.x][t.y]<vals[tt.x][tt.y]) tt=t;
			  }
	 }
}

inline PI query(int x1,int y1,int x2,int y2)
{
	int step=1;
	while (step<x2-x1-1)
}*/

int check(int x1,int y1,int x2,int y2)
{
	int sum=0;
	for (int i=x1;i<x1+n;i++)
	 for (int j=y1;j<y1+m;j++)
	  sum+=a[i][j];
	for (int i=x2;i<x2+r;i++)
	 for (int j=y2;j<y2+c;j++)
	  sum-=a[i][j];
	return sum;
}

int bruteforce()
{
	int best=0;
	for (int i=1;i<=N-n+1;i++)
	 for (int j=1;j<=M-m+1;j++)
	  {
			int ss=Sum(i,j,i+n-1,j+m-1);
			int maxx=INF;
			for (int k=i+1;k<=i+n-r-1;k++)
			 for (int l=j+1;l<=j+m-c-1;l++)
			    maxx<?=Sum(k,l,k+r-1,l+c-1);
			best>?=ss-maxx;
	  }
   return best;
}

int main()
{
    int i,j,k,l;
    scanf("%d%d%d%d%d%d",&M,&N,&m,&n,&c,&r);
    Repi(N)
     Repj(M)
      scanf("%d",&a[i+1][j+1]);
    
    Repi(N)
     Repj(M)
      sum[i+1][j+1]=sum[i][j+1]+sum[i+1][j]-sum[i][j]+a[i+1][j+1];
 
/*    Repi(N)
    {
     Repj(M)
      printf("%3d",sum[i+1][j+1]);
     cout<<endl;
	}*/
    
    R=1; while (R<max(N,M)) R*=2;
    memset(b,0,sizeof(b));
    vals[0][0]=INF;
    for (int i=1;i<=N-r+1;i++)
     for (int j=1;j<=M-c+1;j++)
      push2(Sum(i,j,i+r-1,j+c-1),i,j);
/*
    Repi(N+1)
    {
     Repj(M+1)
      cout<<setw(3)<<vals[i+1][j+1]<<" ";
     cout<<endl;
	}
*/	
//	initstat();
/*	for (int i=1;i<=N;i++)
	 {
	  for (int j=1;j<=M;j++)
	   cout<<statb[1][i][j].x<<","<<statb[1][i][j].y<<" ";
	  cout<<endl;
	 }
*/
	PI t; int Best=0; PI ans1,ans2;
	for (int i=1;i<=N-n+1;i++)
	 for (int j=1;j<=M-m+1;j++)
	  {
			t=query2(i+1,j+1,i+n-r-1,j+m-c-1);
			int s=Sum(i,j,i+n-1,j+m-1)-vals[t.x][t.y];
			if (s>Best) { Best=s; ans1=MP(i,j); ans2=t; }
		//	cout<<i<<" "<<j<<" -> "<<t.x<<" "<<t.y<<" = "<<s<<"   "<<i+1<<" "<<j+1<<" "<<i+n-2-r+1<<" "<<j+m-2-c+1<<endl;
	  }
    /*
    Repi(2*R)
     {
      Repj(R+5)
        printf("%2d,%2d ",b[i][j].x,b[i][j].y);
	  cout<<endl;
	 }
	 
	while (cin>>i>>j>>k>>l)
	{
		PI ans=query2(i,j,k,l);
		cout<<ans.x<<" "<<ans.y<<endl;
	}*/
	printf("%d %d\n%d %d\n",ans1.y,ans1.x,ans2.y,ans2.x);
	cout<<(double)clock()/CLOCKS_PER_SEC<<endl;
	cout<<check(ans1.x,ans1.y,ans2.x,ans2.y)<<endl;
	cout<<bruteforce()<<endl;
	
    return 0;
}
