// sieve of eratosthenes ; sum of all divisors of integer : suppose X = p1^q1 * p2^q2 * p3^q3...
// sum of divisors with only p1 = (p1^0+p1^1+..p1^q1)
// sum of divisors with p1 & p2 = each p1-divisor with p2 = (p1^0+p1^1..+p1^q1)*(p2^0+p2^1..+p2^q2)
// sum of div with p1, p2 & p3 = each p1-p2-divisor with p3 = (p1^0+p1^1..+p1^q1)*(p2^0+p2^1..+p2^q2)*(p3^0+p3^1+..+p3^q3)
// etc... :) btw x^0+x^1+..+x^n = (x^(n+1)-1)/(n-1) - geom progr
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

int n,m,N,M,P,T,K,A,B;

bool sieve[100000];
int primes[100000],pc;

void eratosthenes(int max)
{
	pc=0;
	for (int i=2;i<=max;i++)
	 if (!sieve[i])
	  {
			primes[pc++]=i;
			for (int j=i*i;j<=max;j+=i)
			 sieve[j]=1;
	  }
//	Repi(pc) cout<<primes[i]<<" "; cout<<endl; pause;
}

inline LL S(int x)
{
	LL ret=1; int tmp,ox=x;
	for (int i=0;i<pc && primes[i]*primes[i]<=x;i++)
	{
	 if (x%primes[i]==0)
	  {
			tmp=1;
			while (x%primes[i]==0) x/=primes[i],tmp*=primes[i];
			ret*=(LL)(tmp*primes[i]-1)/(primes[i]-1);
	  }
	}
	if (x>1) ret*=x+1;
	return ret-(LL)ox;
}

inline int getlength(int x1)
{
	LL newx; int len=1;
	while (1)
	 {
			newx=S(x1);
			if (newx==0 || newx>=x1) return len;
			x1=newx; len++;
	 } 
}

int main()
{
	cin>>A>>B;
	eratosthenes(sqrt(B)+10);
  //  A=200000,B=200100;

    int ans,anslen=0,tlen;
    for (int i=A;i<=B;i++)
     {
	  tlen=getlength(i);
      if (tlen>anslen) ans=i,anslen=tlen;
   //   if (i%1000==0) cout<<Time<<endl;
	 }  
    cout<<ans<<" "<<anslen<<"\n";

    cout<<Time<<endl;
   // pause;
    return 0;
}
