// 2D RMQ - dynamic & static
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m;
int N;


//dynamic RMQ - 2D indexed tree

#define MAXN 2048
int a[MAXN][MAXN];
int b[MAXN];

inline void push1D(int a[],int x,int val)
{
	x+=N;
	a[x]=val;
	while (x>1)
	 {
			x/=2;
			a[x]=max(a[x*2],a[x*2+1]);
	 }
}

inline int query1D(int a[],int x1,int x2)
{
	int ret=-1;
	x1+=N; x2+=N;
	while(x1<=x2)
	 {
			ret>?=max(a[x1],a[x2]);
			x1=(x1+1)/2; x2=(x2-1)/2;
	 }
	return ret;
}

inline void push2D(int x,int y,int val)
{
	x+=N;
	push1D(a[x],y,val);
	while (x>1)
	 {
			x/=2;
			push1D(a[x],y,max(a[x*2][y+N],a[x*2+1][y+N]));
	 }
}

inline int query2D(int x1,int y1,int x2,int y2)
{
	int ret=-1;
	x1+=N; x2+=N;
	while(x1<=x2)
	 {
			ret>?=max(query1D(a[x1],y1,y2),query1D(a[x2],y1,y2));
			x1=(x1+1)/2; x2=(x2-1)/2;
	 }
	return ret;
}

void print()
{
	for (int i=1;i<N*2;i++)
	 {
	  for (int j=1;j<N*2;j++)
	   cout<<setw(4)<<a[i][j];
	  cout<<endl;
	 }
	cout<<endl;
}




//static RMQ

int s[12][MAXN][MAXN];

void init(int a[][MAXN][MAXN])
{
	for (int i=1;(1<<i)<=MAXN;i++)
	{
	 int offs=1<<(i-1);
	 for (int j=0;j+offs<n;j++)
	  for (int k=0;k+offs<m;k++)
	   a[i][j][k]=max(max(a[i-1][j+offs][k+offs],a[i-1][j+offs][k]),max(a[i-1][j][k+offs],a[i-1][j][k]));
	}
}

inline int query(int x,int y,int len)
{
	int lev=1;
	while (1<<lev<=len) lev++; lev--;
	int p2=1<<lev;
	return max(max(s[lev][x][y],s[lev][x+len-p2][y]),max(s[lev][x][y+len-p2],s[lev][x+len-p2][y+len-p2]));
}


void printstat(int lev)
{
	Repi(lev)
	 {
	  Repj(n)
	   {
	    Repk(m)
	     cout<<setw(4)<<s[i][j][k];
	    cout<<endl;
	   }
	  cout<<endl;
	 }
}

int main()
{
    int i,j,k,l,Q;
    memset(a,255,sizeof(a));

    scanf("%d%d",&n,&m);
    N=1; while (N<m || N<n) N*=2;
    Repi(n)
     Repj(m)
      {
       scanf("%d",&l);
       push2D(i,j,l); //dynamic
       s[0][i][j]=l; //static
	  }
	init(s); //static
    
    scanf("%d",&Q);
    Repi(Q)
     {
			scanf("%d%d%d",&j,&k,&l);
			printf("%d\n",query2D(j,k,j+l-1,k+l-1)); //dynamic
			printf("%d\n",query(j,k,l)); //static
	 }
    
    cout<<(double)clock()/CLOCKS_PER_SEC<<endl;
    
    return 0;
}
