//area of union of parallelipipeds - line sweep with 2D mapped binary index tree
//could be done with interval tree (see baltic/2001/mars.cpp which, in turn, could be done using BIT ;)
//could also be done with static interval tree (a.k.a. indexed tree; with original or mapped coordinates - never done any of 'em before)
//could furthermore be done with 2 line sweeps (see skymapp.cpp - iskren's solution (which is faster))
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m;

#define MAXN 512
map<int,int> XX,YY,ZZ;
int xx[MAXN*2],yy[MAXN*2],zz[MAXN*2],Xn,Yn,Zn;

struct rect{
	int z,x1,y1,x2,y2; bool rem;
	rect(){};
	rect(int zz,int xx1,int yy1,int xx2,int yy2,bool remm){ z=zz,x1=xx1,y1=yy1,x2=xx2,y2=yy2,rem=remm; };
};
bool operator<(rect a,rect b)
{
	if (a.z==b.z)
	if (a.x1==b.x1)
	if (a.y1==b.y1)
	if (a.x2==b.x2)
	if (a.y2==b.y2)
	return a.rem<b.rem;
	else return a.y2<b.y2;
	else return a.x2<b.x2;
	else return a.y1<b.y1;
	else return a.x1<b.x1;
	return a.z<b.z;
}

struct omg{
	int x1,y1,z1,x2,y2,z2;
	omg(){};
	omg(int xx1,int yy1,int zz1,int xx2,int yy2,int zz2){ x1=xx1,y1=yy1,z1=zz1,x2=xx2,y2=yy2,z2=zz2; };
};
bool operator<(omg a,omg b)
{
	if (a.x1==b.x1)
	if (a.y1==b.y1)
	if (a.z1==b.z1)
	if (a.x2==b.x2)
	if (a.y2==b.y2)
	return a.z2<b.z2;
	else return a.y2<b.y2;
	else return a.x2<b.x2;
	else return a.z1<b.z1;
	else return a.y1<b.y1;
	return a.x1<b.x1;
}

omg p[MAXN];
rect r[MAXN*2];

int cnt[MAXN*2][MAXN*2];
LL area[MAXN*2][MAXN*2];
LL b[MAXN*2+1][MAXN*2+1]; //+1 !!!

inline void push(int x,int y,LL val) //x,y++ 6ot mu se podavat 0-based
{
	x++,y++;
	for (int X=x;X<=Xn;X+=X&(-X))
	 for (int Y=y;Y<=Yn;Y+=Y&(-Y))
	  b[X][Y]+=val;
}

inline void add(int x1,int y1,int x2,int y2)
{
//	cout<<"add "<<xx[x1]<<" "<<yy[y1]<<" "<<xx[x2]<<" "<<yy[y2]<<endl;
	for (int tx=x1;tx<x2;tx++)
	 for (int ty=y1;ty<y2;ty++)
	  {
			if (!cnt[tx][ty]) push(tx,ty,area[tx][ty]);  //precompute cell areas!!!!!
			cnt[tx][ty]++;
	  }
}

inline void del(int x1,int y1,int x2,int y2)
{
//	cout<<"del "<<xx[x1]<<" "<<yy[y1]<<" "<<xx[x2]<<" "<<yy[y2]<<endl;
	for (int tx=x1;tx<x2;tx++)
	 for (int ty=y1;ty<y2;ty++)
	  {
			cnt[tx][ty]--;
			if (!cnt[tx][ty]) push(tx,ty,-area[tx][ty]);
	  }
}

inline LL query1(int x,int y)
{
	LL ret=0; x++,y++;
	for (int X=x;X;X-=X&(-X))
	 for (int Y=y;Y;Y-=Y&(-Y))
	  ret+=b[X][Y];
	return ret;
}

int main()
{
    int i,j,k,l,x1,y1,z1,x2,y2,z2;
    scanf("%d",&n);
    Repi(n)
     {
			scanf("%d%d%d%d%d%d",&x1,&y1,&z1,&x2,&y2,&z2);
		    p[i]=omg( min(x1,x2) , min(y1,y2) , min(z1,z2) , max(x1,x2) , max(y1,y2) , max(z1,z2) );
		    
		    XX[x1]=XX[x2]=666;
		    YY[y1]=YY[y2]=666;
		    ZZ[z1]=ZZ[z2]=666;
	 }
	
	map<int,int>::iterator it;
	for (it=XX.begin(),i=0; it!=XX.end(); it++,i++)
	 { it->y=i; xx[i]=it->x; }
	Xn=i;
	for (it=YY.begin(),i=0; it!=YY.end(); it++,i++)
	 { it->y=i; yy[i]=it->x;  }
	Yn=i;
	for (it=ZZ.begin(),i=0; it!=ZZ.end(); it++,i++)
	 { it->y=i; zz[i]=it->x; }
	Zn=i;

    Repi(Xn-1)
     Repj(Yn-1)
      area[i][j]=(LL)(xx[i+1]-xx[i])*(LL)(yy[j+1]-yy[j]);

    Repi(n)
     {
      r[i*2]=rect(p[i].z1,XX[p[i].x1],YY[p[i].y1],XX[p[i].x2],YY[p[i].y2],0);
      r[i*2+1]=rect(p[i].z2,XX[p[i].x1],YY[p[i].y1],XX[p[i].x2],YY[p[i].y2],1);
     }
	sort(r,r+n*2);

	 
 	int lastz=r[0].z;
	LL ans=0;
//	while (Xn&(Xn-1)) Xn++;	while (Yn&(Xn-1)) Yn++; //better ???? - no (const query, longer insert)
	for (int i=0;i<2*n;)
	 {
			ans+=(LL)(r[i].z-lastz)*query1(Xn-1,Yn-1);
//			cout<<r[i].z<<"-"<<lastz<<" * "<<query1(Xn-1,Yn-1)<<endl;
			
			lastz=r[i].z;
			while (i<n*2 && r[i].z==lastz)
			 {
					if (r[i].rem) del(r[i].x1,r[i].y1,r[i].x2,r[i].y2);
					else add(r[i].x1,r[i].y1,r[i].x2,r[i].y2);
					i++;
			 }
	 }
	cout<<ans<<endl;
	 cout<<(double)clock()/CLOCKS_PER_SEC<<endl;
    return 0;
}
