#include <cstdio>
#include <utility>
#include <algorithm>
#include <set>
using namespace std;

#define f(i, n)						for(int i = 0; i < n; i ++)
#define fx(it, x)					for(typeof((x).begin()) it = (x).begin(); it != (x).end();++it)
#define x							first
#define y							first
#define index						second
#define whole						first
#define covered						second
#define MAX_N						(1 << 9)
#define Get_Time(time)				(double)((double)(clock() - time) / (double)CLOCKS_PER_SEC)

const int C = 1 << 20;

typedef long long LL;
typedef pair<int, int> state, node;
typedef struct point
{
	int X, Y, Z;
};
typedef struct cuboid
{
	point A, C;
};

class Balanced_Tree
{
public:

Balanced_Tree()
{
	memset(tree, 0, sizeof(tree));
}

void update(const int &a, const int &b, const int &delta, int node, int left, int right)
{
	if(a <= left && right <= b) tree[node].whole += delta;
	else
	{
		int mid = (left + right) >> 1;
		
		if(a <= mid) update(a, b, delta, node << 1, left, mid);
		if(mid < b) update(a, b, delta, (node << 1) + 1, mid + 1, right);
	}
	
	correct(node, left, right);
}

int query(const int &node)
{
	return tree[node].covered;
}

private:

node tree[C << 1];

inline void correct(const int &node, const int &left, const int &right)
{
	if(tree[node].whole)
	{
		tree[node].covered = right - left + 1;
		
		return;
	}
	
	tree[node].covered = 0;
	
	if(left < right) tree[node].covered = tree[node << 1].covered + tree[(node << 1) + 1].covered;
}

};


clock_t start;
int N, V;
cuboid c[MAX_N];
state v[MAX_N << 1];
set<state> h;
bool v_used[MAX_N], h_used[MAX_N];
Balanced_Tree T;
LL ans;


void Read()
{
	scanf("%d", &N);
	
	f(i, N)
	{
		scanf("%d %d %d %d %d %d", &c[i].A.X, &c[i].A.Y, &c[i].A.Z, &c[i].C.X, &c[i].C.Y, &c[i].C.Z);
		
		if(c[i].C.X < c[i].A.X) swap(c[i].C.X, c[i].A.X);
		if(c[i].C.Y < c[i].A.Y) swap(c[i].C.Y, c[i].A.Y);
		if(c[i].C.Z < c[i].A.Z) swap(c[i].C.Z, c[i].A.Z);
	}
}

LL get_area()
{
LL last_y = (*h.begin()).y, line_length = 0, ret = 0;
	
	fx(it, h)
	{
		ret += ((*it).y - last_y) * line_length;
		
		if(!h_used[(*it).index])
		{
			T.update(c[(*it).index].A.Z, c[(*it).index].C.Z - 1, + 1, 1, 0, C);
			
			h_used[(*it).index] = true;
		}
		else
		{
			T.update(c[(*it).index].A.Z, c[(*it).index].C.Z - 1, - 1, 1, 0, C);
			
			h_used[(*it).index] = false;
		}
		
		line_length = T.query(1);
		last_y = (*it).y;
	}
	
	return ret;
}

LL get_volume()
{
LL delta_x = 0, area = 0, ret = 0;
	
	V = N << 1;
	
	f(i, N)
	{
		v[i << 1].x = c[i].A.X;
		v[(i << 1) + 1].x = c[i].C.X;
		v[i << 1].index = v[(i << 1) + 1].index = i;
	}
	
	sort(v, v + V);
	
	f(i, V)
	{
		ret += delta_x * area;
		
		if(!v_used[v[i].index])
		{
			h.insert(state(c[v[i].index].A.Y, v[i].index));
			h.insert(state(c[v[i].index].C.Y, v[i].index));
			
			v_used[v[i].index] = true;
		}
		else
		{
			h.erase(state(c[v[i].index].A.Y, v[i].index));
			h.erase(state(c[v[i].index].C.Y, v[i].index));
		}
		
		area = get_area();
		delta_x = v[i + 1].x - v[i].x;
	}
	
	return ret;
}

void Solve()
{
	ans = get_volume();
}

void Write()
{
	printf("%I64d\n", ans);
	
	printf("\nRUN TIME: %.5lf\n", Get_Time(start));
	
//	system("pause");
}

int main()
{
	start = clock();
	
	Read();
	
	Solve();
	
	Write();
	
	
	return 0;
}
