#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int N,m;

typedef VI chislo;
LL osn=1000000000; int osnc=9;
chislo pow2[666];

//big numbers arithmetic

chislo operator+(chislo &a,chislo &b)
{
	chislo ret(max(a.SZ,b.SZ));
	int o=0,sz=min(a.SZ,b.SZ);
	Repi(sz)
	 {
			o+=b[i]+a[i];
			ret[i]=o%osn;
			o/=osn;
	 }
	Repi((int)a.SZ-(int)b.SZ)
	 {
			o+=a[i+b.SZ];
			ret[i+b.SZ]=o%osn;
			o/=osn;
	 }
	Repi((int)b.SZ-(int)a.SZ)
	 {
			o+=b[i+a.SZ];
			ret[i+a.SZ]=o%osn;
			o/=osn;
	 }
	if (o) ret.PB(o);
	return ret;
}

bool operator<(chislo &a,chislo &b)
{
	if (a.SZ!=b.SZ) return a.SZ<b.SZ;
	for (int i=a.SZ-1;i>=0;i--)
	 if (a[i]!=b[i]) return a[i]<b[i];
	return 0;
}

chislo operator-(chislo a,chislo &b) //assuming a>b
{
	Repi(b.SZ)
	 {
			if (a[i]<b[i])
			 {
					int j=i+1; while(!a[j]) { a[j]=osn-1; j++; }
					a[j]--; a[i]+=osn;
			 }
			a[i]-=b[i];
	 }
	while (!a[a.SZ-1]) a.pop_back();
	if (!a.SZ) a.PB(0);
	return a;
}

chislo operator*(LL a,chislo &b)
{
    LL o=0;
    chislo ret(b.SZ);
    Repi(b.SZ)
     {
			o+=(LL)b[i]*a;
			ret[i]=o%osn;
			o/=osn;
	 }
	if (o) ret.PB(o);
	return ret;
}



//big numbers interface

chislo stringtochislo(string s)
{
	int dig=0,ten=1; chislo ret;
	for (int i=s.SZ-1;i>=0;i--)
	 {
			dig+=ten*(s[i]-'0');
			ten*=10; if (ten==osn) {ten=1; ret.PB(dig); dig=0; }
	 }
	if (dig) ret.PB(dig);
	return ret;
}

string chislotostring(chislo a)
{
	ostringstream os;
	string s;
	for (int i=a.SZ-1;i>=0;i--)
	 {
			os.str(""); os.clear();
			os<<a[i];
			if (i!=a.SZ-1) Repj(osnc-os.str().SZ) s+="0";
			s+=os.str();
	 }
	return s;
}





//solution


chislo d[666][2000],trivial[4];

inline int prevstage0(int stage)
{ return (stage-1)/4*4+(stage-1)%2*2; }

int znak[]={-1,1};

//recursively find number, knowing stage, total number of numbers and position

chislo solve1(int N,int stage,chislo &pos)
{
	if (N==2) return trivial[stage];
	if (!stage) return pow2[N-1];
	bool right=!((stage-1)/2%2);
	int pr=prevstage0(stage);
	if (d[N-1][pr]<pos) { pos=pos-d[N-1][pr]; pr++; }
	chislo ret=solve1(N-1,pr,pos);
	if (right) return pow2[N-1]+ret;
	return pow2[N-1]-ret;
}

//find out during which stage the number has been checked (a stage changes when direction changes, or when the middle number has been passed)

chislo solve(chislo pos)
{
	if (pos==stringtochislo("1")) return pow2[N-1];
	int stage; chislo tot,newpos; tot=newpos=stringtochislo("0");
	for (stage=0;tot<pos;stage++)
	 tot=tot+d[N][stage];
	stage--; tot=tot-d[N][stage];
	tot=pos-tot;
	return solve1(N,stage,tot);
}



int main()
{
    int Q;
    cin>>N>>Q;
     
    
    //dp initialization
     
    d[2][0]=d[2][1]=d[2][3]=stringtochislo("1");
    for (int i=3;i<=N;i++)
     {
	   d[i][0]=stringtochislo("1");
       for (int j=1;j<=i*2;j++)
        {
		 int index=prevstage0(j);
         d[i][j]=d[i-1][index]+d[i-1][index+1];
		}
	 }
	trivial[0].PB(2); trivial[1].PB(3); trivial[2].PB(0); trivial[3].PB(1);
	pow2[0]=stringtochislo("1");
	for (int i=1;i<=N;i++)
	 pow2[i]=2*pow2[i-1];
    
    //main

	string s;
	Repi(Q) 
	 {
		cin>>s;
		
		cout<<chislotostring(solve(stringtochislo(s)))<<endl;
	 }
	 
	
    return 0;
}
