#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m;
PI p[10100];

int cp(PI &a,PI &b,PI &c)
{
	int dx1=b.x-a.x;
	int dy1=b.y-a.y;
	int dx2=c.x-a.x;
	int dy2=c.y-a.y;
	return dx1*dy2-dx2*dy1;
}

double cp(PD &a,PD &b,PD c)
{
	double dx1=b.x-a.x;
	double dy1=b.y-a.y;
	double dx2=c.x-a.x;
	double dy2=c.y-a.y;
	return dx1*dy2-dx2*dy1;
}

double sp(PD &a,PD &b,PD c)
{
	double dx1=b.x-a.x;
	double dy1=b.y-a.y;
	double dx2=c.x-a.x;
	double dy2=c.y-a.y;
	return dx1*dx2+dy1*dy2;
}

int dist1(PI &a,PI &b)
{	return sqr(a.x-b.x)+sqr(a.y-b.y); }

double dist1(PD &a,PD &b)
{	return sqr(a.x-b.x)+sqr(a.y-b.y); }

bool cmp(PI a,PI b)
{
	return (cp(p[0],a,b)==0)?(dist1(p[0],a)<dist1(p[0],b)):cp(p[0],a,b)>0;
}

PD intersect(PD &A,PD &B,PD C,PD D)
{
	double num=cp(A,C,D),den=cp(A,C,B)+cp(A,B,D);
	if (fabs(den)<1e-7) return MP(1e100,-1e99);
	PD X;
	X.x=A.x+(B.x-A.x)*num/den;
	X.y=A.y+(B.y-A.y)*num/den;
	return X;
}

int match[10100];

bool checkhull(PD &A,PD &B,int i1,int i2)
{
	PD X;
	int e1=(i1-m/2+m)%m,e2=(i2+m/2)%m;
//	cout<<"checking hull; line "<<A.x<<" "<<A.y<<" , "<<B.x<<" "<<B.y<<" ; "<<i1<<" "<<i2<<" to "<<e1<<" "<<e2<<endl;
	while(1)
	 {
	   if (i1==i2)
	      if ( fabs(cp(A,B,(PD)p[i1]))<1e-7 ) {match[i1]=i2; match[i2]=i1;} else return 0;
	   else
	   {
	    X=intersect(A,B,(PD)p[i1],(PD)p[i2]);
//	    cout<<i1<<" "<<i2<<": "<<p[i1].x<<" "<<p[i1].y<<" , "<<p[i2].x<<" "<<p[i2].y<<"\n";
	    if ( fabs(sp(X,A,(PD)p[i1]))<1e-7 && fabs(sp(X,B,(PD)p[i1]))<1e-7 && fabs(sp(X,A,(PD)p[i2]))<1e-7 
		  && fabs((double)p[i1].x+(double)p[i2].x-2.*X.x)<1e-7 && fabs((double)p[i1].y+(double)p[i2].y-2.*X.y)<1e-7)
	       { match[i1]=i2; match[i2]=i1; } else return 0;
	   }
	   if (i1==e1 && i2==e2) return 1;
	   i1--; i2++;
	   if (i1<0) i1+=m;
	   if (i2>=m) i2-=m;
	 }
}


map<PI,int> index,ni;


bool checkrest(PD &A,PD &B)
{
	PD X; PI P;
	map<PI,int>::iterator it;
	double den=dist1(A,B);
	for (int i=m+1;i<=n;i++)
	 if (match[i]==-1)
	 {
			double num=sp(A,B,(PD)p[i]);
			X.x=A.x+(B.x-A.x)*num/den;
			X.y=A.y+(B.y-A.y)*num/den;
//			cout<<p[i].x<<" "<<p[i].y<<" -> "<<X.x<<" "<<X.y<<endl;
			X.x+=X.x-(double)p[i].x; X.y+=X.y-(double)p[i].y;
			if ( fabs(X.x-round(X.x))<1e-7 && fabs(X.y-round(X.y))<1e-7 ) ; else return 0;
			P=MP((int)round(X.x),(int)round(X.y));
			it=ni.find(P);
			if (it==ni.end()) return 0; 
//			cout<<i<<" with "<<it->y<<endl;
			if (match[it->y]>-1) return 0;
			match[it->y]=i; match[i]=it->y;
	 }
	return 1;
}

int main()
{
	scanf("%d",&n);
	m=0;
	Repi(n)
	 {
	   scanf("%d%d",&p[i].x,&p[i].y);
	   index[p[i]]=i+1;
	   if (p[i]<p[m]) m=i;
	 }
	if (n==1) { cout<<"1\n"; return 0; }
	if (n==2) { cout<<"1 2\n"; return 0; }
	
	bool vsna1naprava=1;
	Repi(n)
	 if (cp(p[0],p[1],p[i])!=0) {vsna1naprava=0; break;}
	if (vsna1naprava)
	 {
			Repi(n)
			 cout<<i+1<<" ";
			cout<<endl;
			return 0;
		}
		

	swap(p[m],p[0]);
	sort(p+1,p+n,cmp);
	p[n]=p[0];
	int j=n-1;
	while (j && !cp(p[n],p[n-1],p[j])) j--;
	reverse(p+j+1,p+n);
	m=1;
	for (int i=2;i<=n;i++)
	 {
			while(cp(p[m-1],p[m],p[i])<0) m--;
			m++; swap(p[i],p[m]);
	 }
	Repi(n+1)
	 if (p[i]!=p[0] || !i)
	  ni[p[i]]=i;
	
//	Repi(m)	 cout<<p[i].x<<" "<<p[i].y<<" ; ";	cout<<endl;

    if (m%2)
     {
			Repi(m/2)
			 {
					PD A; A.x=(double)(p[i].x+p[i+1].x)/2.; A.y=(double)(p[i].y+p[i+1].y)/2.;
					PD B=(PD)p[(i+m/2+1)%m];
					memset(match,255,sizeof(match));
					if ( checkhull(A,B,i,i+1) )
					 {
//					   cout<<"HULL STAVA\n";
						if ( checkrest(A,B) )
						 {
//							 cout<<"YEEEEY!!!!\n";
							 break;
						 }
					 }
			 }
	 }
	else
	 {
			Repi(m/2)
			 {
					PD A; A.x=(double)(p[i].x+p[i+1].x)/2.; A.y=(double)(p[i].y+p[i+1].y)/2.;
					PD B; B.x=(double)(p[(i+m/2)%m].x+p[(i+m/2+1)%m].x)/2.; B.y=(double)(p[(i+m/2)%m].y+p[(i+m/2+1)%m].y)/2.;
					memset(match,255,sizeof(match));
					if ( checkhull(A,B,i,i+1) )
					 {
//					   cout<<"HULL STAVA\n";
						if ( checkrest(A,B) )
						 {
//							 cout<<"YEEEEY!!!!\n";
							 break;
						 }
					 }
					 
					A=p[i]; B=p[(i+m/2)%m];
					memset(match,255,sizeof(match));
					if (checkhull(A,B,i,i))
					 {
//					   cout<<"HULL STAVA 1\n";
						if ( checkrest(A,B) )
						 {
//							 cout<<"YEEEEY 1!!!!\n";
							 break;
						 }
					 }
			 }
	 }
	 
	VI ans(n);
	Repi(n+1)
	 if (p[i]!=p[0] || !i)
 	 ans[ index[p[i]]-1 ]=index[p[match[i]]];
	 
//	Repi(n) 	 cout<<match[i]<<" "; cout<<endl;
	
	

	if (match[0]==-1)
	 { cout<<"0\n"; return 0; }
	Repi(n) 
	 cout<<ans[i]<<" "; cout<<"\n";
	return 0;
}
