#include <iostream>
#include <cmath>
#include <fstream>
#include <vector>
#include <iomanip>

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

using namespace std;

#define MAXN 150
#define INF 2000000000
#define VI vector<int>
#define PB push_back
#define SZ size()
#define MP make_pair
#define PI pair<int,int>
#define PD pair<double,double>
#define x first
#define y second
#define SIGN(A) (((A)>0)-((A)<0))

struct line{double x1,y1,x2,y2;
  line(){};
  line(int X1,int Y1,int X2,int Y2):x1(X1),y1(Y1),x2(X2),y2(Y2){};
};
typedef line rect;

rect A;
vector<PD> p;
PD T;
int N;

inline double cross(PD &A,PD &B,PD &C)
{
	double dx1=B.x-A.x;
	double dy1=B.y-A.y;
	double dx2=C.x-A.x;
	double dy2=C.y-A.y;
	return dx1*dy2-dx2*dy1;
}

inline PD intersect(PD &A,PD &B,PD &C,PD &D)
{
	double num=cross(A,C,D),den=cross(A,C,B)+cross(A,B,D);
	if (fabs(den)<1e-7) return MP(1e100,1e100);
	PD X;
	X.x=A.x+(B.x-A.x)*num/den;
	X.y=A.y+(B.y-A.y)*num/den;
//	cout<<"int "<<A.x<<" "<<A.y<<" - "<<B.x<<" "<<B.y<<" with "<<C.x<<" "<<C.y<<" - "<<D.x<<" "<<D.y<<" = "<<X.x<<" "<<X.y<<endl;
	return X;
}

inline bool isin(PD &A,PD &B,PD &C)
{	return (A.x>=min(B.x,C.x) && A.x<=max(B.x,C.x) && A.y>=min(B.y,C.y) && A.y<=max(B.y,C.y)); }

void cut(vector<PD> &p,PD p1,PD p2)
{
	p.PB(p[0]);
	int start=-1,end=-1;
	PD sp,ep;
	Repi(p.SZ-1)
	 {
			PD X=intersect(p[i],p[i+1],p1,p2);
			if (isin(X,p[i],p[i+1]))
			 if (start==-1) { start=(i+1)%(p.SZ-1); sp=X; } else { end=i; ep=X; break; }
	 }
//	cout<<start<<" "<<end<<endl;
	if (start==-1 || end==-1) {p.pop_back(); return;}
	if (SIGN(cross(sp,ep,p[start]))==SIGN(cross(sp,ep,T))) { swap(start,end); swap(sp,ep); end--; start=(start+1)%(p.SZ-1); }
	if (start<=end) 
	 {p.erase(p.begin()+start,p.begin()+end+1);
	  p.insert(p.begin()+start,sp); p.insert(p.begin()+start+1,ep); //taq 4ast bavi mnoo...we nai-dobre e list
	  p.pop_back();
	 }
	else
	 {
			p.erase(p.begin()+start,p.end());
			p.erase(p.begin(),p.begin()+end+1);
			p.PB(sp); p.PB(ep);
	 }
}

int main()
{
	int x1,y1,x2,y2; PD l1,l2;
	scanf("%d%d%d%d",&x1,&y1,&x2,&y2); A=rect(x1,y1,x2,y2); //tva e glupavo...
	scanf("%lf%lf",&T.x,&T.y);
	scanf("%d",&N);
	
	p.PB(MP(A.x1,A.y1));
	p.PB(MP(A.x2,A.y1));
	p.PB(MP(A.x2,A.y2));
	p.PB(MP(A.x1,A.y2));
	
	Repi(N)
	 {
	   scanf("%lf %lf %lf %lf",&l1.x,&l1.y,&l2.x,&l2.y);
	   cut(p,l1,l2);
//	   Repi(p.SZ) cout<<p[i].x<<" "<<p[i].y<<" ; "; cout<<endl;
	 }
	 
	double S=0;
	p.PB(p[0]);
	Repi(p.SZ-1)
	 S+=(p[i].x-p[i+1].x)*(p[i].y+p[i+1].y);
	S/=2.;
	S=fabs(S);
	
	printf("%d\n",(int)S);
	
	return 0;
}
