//max flow - scaling bfs, improved shortest path
#include <iostream>
#include <fstream>
#include <set>
#include <vector>

using namespace std;

#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)
#define MP make_pair
#define x first
#define y second
#define PB push_back
#define VI vector<int>
#define ALL(v) (v).begin(),(v).end()
#define SZ size()
#define PI pair<int,int>
#define pause system("pause")
#define LL long long

#define tip VI

int n,m,sink,N;

int M[256][256],MAX;
VI a[256];

int flow1(int source,int sink) //SCALING BFS
{
    int q[200000];
    int p[256];
    bool u[256],found;
    int flow=0,delta=MAX;
    
    while(1)
    {
            q[0]=source; found=false;
            memset(u,0,sizeof(u)); p[source]=-1;
            u[source]=true;
            for (int s=0,e=1; s<e; s++){
                Repi(a[q[s]].SZ)
                {
                                int v=a[q[s]][i];
                                if (M[q[s]][v]>=delta && !u[v])
                                 {
                                               u[v]=true;
                                               q[e++]=v;
                                               p[v]=q[s];
                                               if (v==sink) { found=true; break; }
                                 }
                } if (found) break; }
                
           if (!found) 
            if (delta>1) 
             { delta/=2; continue; } 
            else return flow;
            
           int l=sink; int k=0,m=2000000000;
           while (l!=-1)
           { q[k++]=l; l=p[l]; }
           reverse(q,q+k);
           
           for (int i=1; i<k; i++)
            m=min(m,M[q[i-1]][q[i]]);
            
        //   Repi(k)            cout<<q[i]<<" "; cout<<" = "<<m<<endl;
           

           for (int i=1; i<k; i++)
           {
               M[q[i-1]][q[i]]-=m;
               M[q[i]][q[i-1]]+=m;
           }
           
           flow+=m;
    }
}

int flow(int source,int sink) //IMPROVED SHORTEST PATH
{
    int d[256],q[256],p[256];
    bool u[256];
    int flow=0,x,y,m,r;
    
    memset(d,127,sizeof(d));
    memset(u,0,sizeof(u));
    d[sink]=0; q[0]=sink; u[sink]=true;
    for (int s=0,e=1; s<e; s++) //calculate d[] - distance from sink do i
     Repi(a[q[s]].SZ)
     { int v=a[q[s]][i];
       if (M[q[s]][v]==0 && !u[v])
       {
                         u[v]=true;
                         q[e++]=v;
                         d[v]=d[q[s]]+1;
       }
     }
    
    int i=source; p[source]=-1;
    while (d[source]<N)
    {
      r=-1;
   //   cout<<"in "<<i<<endl;
      Repj(a[i].SZ)
       if (M[i][a[i][j]]>0 && d[a[i][j]]==d[i]-1) { r=a[i][j]; break; } //find existing edge from i gettings us closer to sink
      if (r==-1) //if not found - retreat
       {
                 r=2000000000;
                 Repj(a[i].SZ) if (M[i][a[i][j]]) r=min(r,d[a[i][j]]); //set new distance from sink to i (relabel)
                 d[i]=r+1;
       //          cout<<"retreat from "<<i<<" to "<<p[i]<<endl;
                 if (i!=source) i=p[i]; //go to previous vertice
                 continue;
       }
      //else advance  
      p[r]=i;
   //   cout<<"go to "<<r<<endl;
      i=r;
      if (i==sink) //if sink reached - augment
       {
                  x=i; y=0;
                  while (x!=-1) { q[y++]=x; x=p[x]; } //find current path
                  reverse(q,q+y);
                  m=2000000000;
                  for (int j=1; j<y; j++) m=min(m,M[q[j-1]][q[j]]); //find min capacity along it
             //     cout<<"path "; Repj(y) cout<<q[j]<<" "; cout<<" flow "<<m<<endl;
                  for (int j=1; j<y; j++) //push flow
                  {
                    M[q[j-1]][q[j]]-=m;
                    M[q[j]][q[j-1]]+=m;
                  }
                  flow+=m;
                  i=source;
       }
    }
    return flow;
}


int main()
{
    int i,j,k,l,x,ans=0;
    cin>>n>>m;
    sink=n+m+2; N=sink;
    Repi(n)
    {
           cin>>l;
           M[0][i+1]=l;
           a[0].PB(i+1);
           a[i+1].PB(0);
           MAX=max(MAX,l);
    }
    Repi(m)
    {
           cin>>l>>k;
           ans+=l;
           a[i+n+1].PB(sink);
           a[sink].PB(i+n+1);
           M[i+n+1][sink]=l;
           MAX=max(MAX,l);
           Repj(k)
            {
                  cin>>x;
                  a[x].PB(i+n+1);
                  a[i+n+1].PB(x);
                  M[x][i+n+1]=2000000000;
            }
    }
  //  cout<<ans<<" "<<flow(0,sink)<<endl;
    
    ans-=flow(0,sink);
    
    
    cout<<ans<<endl;
    
    return 0;
}
