/*
TASK:moat
LANG:C++
*/
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <iostream>
#include <iomanip>
#include <fstream>

using namespace std;

struct point {int x,y;};
typedef point vec;

point mnug[5100];
int n;

float dist(point p1,point p2)
{
    return sqrt((p1.x-p2.x)*(p1.x-p2.x)+(p1.y-p2.y)*(p1.y-p2.y));
}

int cp(point p0,point p1,point p2)
{ int dx1=p1.x-p0.x;
  int dx2=p2.x-p0.x;
  int dy1=p1.y-p0.y;
  int dy2=p2.y-p0.y;
  return dx1*dy2-dx2*dy1;
}

bool min1(double x, double y)
{ if (x<y) return 1;
  return 0;
}
bool cmp(point p1, point p2)
{   
    int RT=cp(mnug[1],p1,p2);
    return (RT==0)?min1(dist(mnug[1],p1),dist(mnug[1],p2)):RT<0; 
    }

void simple_path(int n, point p[])
{ int min=1;
  for (int i=2; i<=n; i++)
   if (p[i].x<p[min].x) min=i;
  swap(p[1],p[min]);
  sort(p+2,p+n+1,cmp);
}



int graham(int n,point p[])
{ p[n+1]=p[1];
  int m=2;
  for (int i=3; i<=n+1; i++)
  { while (cp(p[m],p[m-1],p[i])<0) m--;
    m++; swap(p[i],p[m]);
  }
  return m;
}

int main()
{
  int i,j,k,l;
  ifstream f("moat.in");
  f>>n;
  for (i=1; i<=n; i++)
   f>>mnug[i].x>>mnug[i].y;
  f.close();
  
  simple_path(n,mnug);
  int m=graham(n,mnug);
  mnug[m+1]=mnug[1];
  
  float d=0;
  for (i=1; i<=m; i++)
   d+=dist(mnug[i],mnug[i+1]);
  
  ofstream of("moat.out");
  of<<setprecision(2)<<fixed<<d<<"\n";
  of.close();

  return 0;         
}
