/*
TASK:dining
LANG:C++
ID:pascala1
*/
#include <vector>
#include <set>
#include <iostream>
#include <fstream>
#include <map>
#define PB push_back

using namespace std;

const long INF=2000000000;

//NOTE: I copy-pasted this algorithm from a source code I've written before. Hope I don't get disqualified for that :)

inline bool dfs1(vector<vector<long> > &a,vector<vector<long> > &c,vector<bool> &u,vector<long> &s,long v,long sink,vector<long> &q,vector<long> &q1)
//q - spisak s putq na dfs-a; q1[i] - koi podred e q[i+1] v spisaka na naslednicite na q[i]
{
     if (v==sink) return true;
     q.PB(v);
     for (long i=0; i<a[v].size(); i++)
     if (!u[a[v][i]] && s[a[v][i]]<s[v] && c[v][i]>0)
      {
               q1.PB(i);
               u[a[v][i]]=true;
               if (dfs1(a,c,u,s,a[v][i],sink,q,q1)) return true;
               u[a[v][i]]=false;
               q1.pop_back();
      }
     q.pop_back();
     return false;
}

long MaxFlow_Dinitz(vector<vector<long> > &a,vector<vector<long> > &c,vector<vector<long> > &t,long source,long sink)
//a - spisak na susedite; c - spisak na cenite; t - spisak na bliznacite (za rebroto (i,v) kudeto v=a[i][j] , a[v][t[i][j]] = i)
{
     long i,j,k,l,v,flow=0;
     vector<long> q,q1;
     bool found;
     vector<bool> u(a.size());
     vector<long> p(a.size()),s(a.size());

     while(1)
     {
       q.clear(); q.PB(sink);
       s[sink]=0; u.assign(u.size(),false);
       u[sink]=true; found=false;
       while (!q.empty())
        {
            q1.clear();
            for (i=0; i<q.size(); i++)
             for (j=0; j<a[q[i]].size(); j++)
             { v=a[q[i]][j];
               if (!u[v] && c[v][t[q[i]][j]]>0)
               {
                         s[v]=s[q[i]]+1;
                         u[v]=true;
                         if (v==source) found=true;
                         q1.PB(v);
               } 
             } 
            q=q1; 
        }
       if (!found) break;
       u.assign(u.size(),false);
       q.clear();
       q1.clear();
       while (1)
        {
          if (! dfs1(a,c,u,s,source,sink,q,q1) ) break;
          u[sink]=false; u[source]=false;
          l=INF;
          for (i=0; i<q.size(); i++)
           if (c[q[i]][q1[i]]<l) l=c[q[i]][q1[i]];
          flow+=l; 
          for (i=0; i<q.size(); i++)
           {
                    c[q[i]][q1[i]]-=l;
                    k=a[q[i]][q1[i]];
                    c[k][t[q[i]][q1[i]]]+=l;
           } 
        }
     }  
   return flow;  
}


long MaxFlow_EdmondsKarp(vector<vector<long> > &a,vector<vector<long> > &c,vector<vector<long> > &t,long source,long sink)
{
     long i,j,k,l,v,flow=0;
     vector<long> q,q1;
     bool found;
     vector<bool> u(a.size());
     vector<long> p(a.size());
    
   while (1)
   { 
     q.clear(); q.PB(source);
     found=false; u[source]=true;
     u.assign(u.size(),false);
     while (!q.empty() && !found)
     {   q1.clear();
         for (i=0; i<q.size(); i++)
          for (j=0; j<a[q[i]].size(); j++)
          { v=a[q[i]][j];
           if (!u[v] && c[q[i]][j]>0)
           {
              q.PB(v);
              u[v]=true;
              p[v]=t[q[i]][j];
              if (v==sink) found=true;
           }
          } 
         q=q1;
     }
     if (!found) break;
     q.clear();
     i=sink;
     while (i!=source)
      {
           q.PB(t[i][p[i]]);
           i=a[i][p[i]];
       }
     reverse(q.begin(),q.end());  
     l=INF;
     k=source;
     for (i=0; i<q.size(); i++)
     {
      if (c[k][q[i]]<l) l=c[k][q[i]];
      k=a[k][q[i]];
     }
     flow+=l;
     k=source;
     for (i=0; i<q.size(); i++)
     {
         c[k][q[i]]-=l;
         v=a[k][q[i]];
         c[v][t[k][q[i]]]+=l;
         k=a[k][q[i]];
     }
   } 
   return flow;
}


int main()
{
    int n,m,f,d;
    int i,j,k,l,x,y,sink;
    vector<vector<long> > a;
    vector<vector<long> > c;
    vector<vector<long> > t;
    
    ifstream fi("dining.in");
    fi>>n>>f>>d;
    a.resize(n*2+f+d+2);
    c.resize(n*2+f+d+2);
    t.resize(n*2+f+d+2);
    sink=2*n+f+d+1;
    for (i=1; i<=f; i++)
     {
              a[0].PB(i);
              a[i].PB(0);
              t[0].PB(a[i].size()-1);
              t[i].PB(a[0].size()-1);
              c[0].PB(1);
              c[i].PB(0);
     }
    for (i=sink-d; i<sink; i++) 
     {
              a[sink].PB(i);
              a[i].PB(sink);
              t[sink].PB(a[i].size()-1);
              t[i].PB(a[sink].size()-1);
              c[sink].PB(0);
              c[i].PB(1);
     }
    for (i=f+1; i<=n+f; i++)
    {
      fi>>j>>k;
      for (l=0; l<j; l++)
       {
                fi>>x;
                a[i].PB(x);
                a[x].PB(i);
                t[i].PB(a[x].size()-1);
                t[x].PB(a[i].size()-1);
                c[i].PB(0);
                c[x].PB(1);
       }
      for (l=0; l<k; l++)
       {
                fi>>x;
                x+=2*n+f;
                a[i+n].PB(x);
                a[x].PB(i+n);
                t[i+n].PB(a[x].size()-1);
                t[x].PB(a[i+n].size()-1);
                c[i+n].PB(1);
                c[x].PB(0);
       }
    }
    for (i=f+1; i<=n+f; i++)
    {
       a[i].PB(i+n);
       a[i+n].PB(i);
       t[i].PB(a[i+n].size()-1);
       t[i+n].PB(a[i].size()-1);
       c[i].PB(1);
       c[i+n].PB(0);
    }
    fi.close();
    
    ofstream of("dining.out");
    of<<MaxFlow_Dinitz(a,c,t,0,sink)<<"\n";
//    of<<MaxFlow_EdmondsKarp(a,c,t,0,sink)<<"\n";
    of.close();
    
    return 0;
}
