/*
ID: pascala1
PROG: sightsee
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,F[1024],D[1024],b[1024];
PI d[2][1024];
struct edge{int a,b,c;};
VI adj[1024],cost[1024];
edge E[5100];
bool u[1024],re[1024];

int TLE=0.97*(double)CLOCKS_PER_SEC;


void dfs1(int V)
{
  //   if (clock()>TLE) return;
     u[V]=1; double W=0.;
     Repi(adj[V].SZ)
      {
                  int v=adj[V][i];
                //  cout<<V<<" -> "<<v<<endl;
                  if (!u[v])
                    dfs1(v);
                  if ((double)(D[v]+F[V])/(double)(b[v]+cost[V][i]) > W && re[v])
                    {
                                                 D[V]=D[v]+F[V];
                                                 b[V]=b[v]+cost[V][i];
                                                 re[V]=1;
                                 //                cout<<V<<": "<<d[V]<<" "<<b[V]<<endl;
                                                 W=(double)(D[V])/(double)(b[V]);
                    }
      }
}

int main()
{
    int i,j,k,l;
    FILE *f=fopen("sightsee.in","r");
    fscanf(f,"%d%d",&n,&m);
    Repi(n)
     fscanf(f,"%d",&F[i]);
    Repi(m)
    {
     fscanf(f,"%d%d%d",&E[i].a,&E[i].b,&E[i].c);
     E[i].a--; E[i].b--;
     adj[E[i].a].PB(E[i].b); cost[E[i].a].PB(E[i].c);
    }
    fclose(f);
    
    double ans=0.;

    srand(6661313);
    Repi(n/32)
    {
           k=rand()%n;
           memset(u,0,sizeof(u));
           memset(re,0,sizeof(re));
           re[k]=1;
           memset(D,0,sizeof(D));
           memset(b,0,sizeof(b));
           dfs1(k);
           ans=max(ans,(double)D[k]/(double)b[k]);
    }
 //   cout<<ans<<" "<<clock()<<endl;

    int a,b,c,D,R;
    bitset<1024> u[2][1024];
    int st[2][1024];
    Repi(n) { u[0][i][i]=1; st[0][i]=i; d[0][i].x=0; d[0][i].y=1; }
    
    Repi(n)
    {
     Repj(n) { d[i&1^1][j].x=0; d[i&1^1][j].y=1; }
     Repj(m)
      {
       a=E[j].a; b=E[j].b; c=E[j].c;
       D=(d[i&1][a].x+(u[i&1][a][b]^1)*F[b]+(d[i&1][a].x==0)*F[a]);
       R=(d[i&1][a].y*(d[i&1][a].x>0)+c);
//       cout<<a+1<<" "<<b+1<<" "<<c<<": "<<D<<"/"<<R<<" > "<<d[i&1^1][b].x<<"/"<<d[i&1^1][b].y<<endl;
       if (u[i&1][a][b] && u[i&1][a].count()>1 && b==st[i&1][a])
        ans=max(ans,(double)D/(double)R);
       if ( D*d[i&1^1][b].y > R*d[i&1^1][b].x )
        {
          d[i&1^1][b].x=D;
          d[i&1^1][b].y=R;
          u[i&1^1][b]=u[i&1][a]; u[i&1^1][b][b]=1;
          st[i&1^1][b]=st[i&1][a];
        }
      }
//     Repj(n) 
///      cout<<d[i&1^1][j].x<<" "<<d[i&1^1][j].y<<" ; "; cout<<endl;
//     Repj(n) 
//      cout<<st[i&1^1][j]<<" "; cout<<endl;
//    cout<<ans<<endl;
      if (clock()>TLE) break;
    }
//    cout<<clock()<<endl; pause;
//    cout<<ans<<endl;
//   pause;
    
    f=fopen("sightsee.out","w");
    if (ans<EPS)
     fprintf(f,"0\n");
    else
     fprintf(f,"%.2lf\n",ans);
    fclose(f); 
     
    
    return 0;
}
