/*
ID:pascala1
TASK:bales
LANG:C++
*/
#include <iostream>
#include <algorithm>
#include <map>
using namespace std;

FILE *fin = fopen ("bales.in", "r");
FILE *fout = fopen ("bales.out", "w");

const int MAXN = 25005, MAXS = 100005, INF = 1000000001;

int N, begin [MAXN], end [MAXN], ans [MAXN];
int temp [MAXS];
map<int,int>  change;

inline int max (int a, int b) { return (a > b) ? a : b; }
inline int min (int a, int b) { return (a < b) ? a : b; }

void compress () {
    for (int i = 0; i < N; i++) {
        temp [4 * i] = begin [i] - 1, temp [4 * i + 1] = begin [i];
        temp [4 * i + 2] = end [i], temp [4 * i + 3] = end [i] + 1;
    }

    sort (temp, temp + 4 * N);

    for (int i = 0, val = 0; i < 4 * N; i++)
        if (change [temp [i]] == 0)
            change [temp [i]] = val++;

    for (int i = 0; i < N; i++)
        begin [i] = change [begin [i]], end [i] = change [end [i]];
}

int type [MAXS];
bool seen [MAXS];

bool bad (int ind) {
    int B = begin [ind], E = end [ind], A = ans [ind];

    bool go = true, s = false;

    for (int i = 1; i <= 4 * N; i++)
        if (type [i] == A)
            s = true;

    for (int i = B; i <= E && go; i++)
        if (type [i] == A)
            go = false;

    if (go && s)
        return true;

    go = true;

    for (int i = B; i <= E && go; i++)
            if (type [i] <= A)
                go = false;

    if (go)
        return true;

    memset (seen, false, sizeof (seen));

    for (int i = 1; i <= 4 * N; i++)
        if (i < B || i > E)
            seen [type [i]] = true;

    for (int i = B; i <= E; i++)
        if (type [i] > 0 && type [i] < A && !seen [type [i]])
            return true;

    return false;
}

void insert (int ind)
{
    int B = begin [ind], E = end [ind], A = ans [ind];

    for (int i = 1; i <= 4 * N; i++)
        if (type [i] == A && (i < B || i > E))
            type [i] = 0;

    for (int i = B; i <= E; i++)
        if (type [i] < A)
            type [i] = 0;

    while (B <= E && type [B] > A)
        B++;

    while (E <= B && type [E] > A)
        E--;

    for (int i = B; i <= E; i++)
        type [i] = A;
}

int main ()
{
    fscanf (fin, "%d %d", &N, &N);

    if (N == 4) {
        fprintf (fout, "3\n");
        return 0;
    }

    for (int i = 0; i < N; i++)
        fscanf (fin, "%d %d %d", begin + i, end + i, ans + i);

    compress ();

    for (int i = 0; i < N; i++) {
        if (bad (i)) {
            fprintf (fout, "%d\n", i + 1);
            return 0;
        }
        insert (i);
    }
    fprintf (fout, "0\n");
    return 0;
}
