/*
PROG:travel
LANG:C++
ID:pascala1
*/
// dijkstra; dfs pre/in order ; interval tree ; lowest common ancestor (with static range minimum query (rmq))
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define F(i,n) for (int i=0;i<n;i++)
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))

#define MAXN 140000
#define MAXM 200001
#define INF 1000000000

int N,M;
VI adj[MAXN],cost[MAXN];

int d[MAXN],p[MAXN],p2[MAXN];
bool used[MAXN],used1[MAXN];
int level[MAXN];

void dijkstra(int v,int p[],int d[])
{
	memset(p,-1,sizeof(int)*(N+3));
	memset(d,127,sizeof(int)*(N+3));
	memset(used,0,N+3);
	PQ<PI,vector<PI>,greater<PI> > q;
	q.push(MP(0,v)); d[v]=0;
	PI tmp;
	while (!q.empty())
	 {
			tmp=q.top(); q.pop();
			if (used[tmp.y]) continue;
			used[tmp.y]=1;
			Repi(adj[tmp.y].SZ)
			 {
					int nxt=adj[tmp.y][i],nc=cost[tmp.y][i]+tmp.x;
					if (!used[nxt] && nc<d[nxt])
					 {
							d[nxt]=nc;
							q.push(MP(nc,nxt));
							p[nxt]=tmp.y;
					 }
			 }
	 }
}


int pre[MAXN],pres[MAXN],pree[MAXN],prec;

void dfspre(int v)
{
	pres[v]=prec;
	pre[prec++]=v;
	Repi(adj[v].SZ)
	 if (p[adj[v][i]]==v)
	  {
		level[adj[v][i]]=level[v]+1;
	    dfspre(adj[v][i]);
	  }
	pree[v]=prec-1;
}

int n;
int ans[MAXN];
struct node{  int mind,inc,start,end; node(){}; node(int a,int b,int st,int en){mind=a,inc=b,start=st,end=en;};  };
node tree[MAXN*2];
int leaves[MAXN];
set<PI> edges[MAXN];
struct edge{ int a,b,c; edge(){}; edge(int aa,int bb,int cc){a=aa,b=bb,c=cc;}; };
vector<edge> eat[MAXN];

int lcaord[20][MAXM*2],lcac,lcapos[MAXN];
void lcadfs(int v)
{
	lcapos[v]=lcac;
	lcaord[0][lcac++]=v;
	Repi(adj[v].SZ)
	 if (p[adj[v][i]]==v)
	  {
			lcadfs(adj[v][i]);
			lcaord[0][lcac++]=v;
	  }
}
void lcapre()
{
	for (int j=1;(1<<j)<=lcac;j++)
	 {
			for (int i=0;i+(1<<(j-1))<lcac;i++)
			 {
			    int a1=lcaord[j-1][i],a2=lcaord[j-1][i+(1<<(j-1))];
			    lcaord[j][i]=(level[a1]<level[a2])?a1:a2;
		     }
	 }
}
int lca(int a,int b)
{
	if (lcapos[a]>lcapos[b]) swap(a,b);
	int dist=lcapos[b]-lcapos[a];
	int pow2=31-__builtin_clz(dist);
	int c1=lcaord[pow2][lcapos[a]],c2=lcaord[pow2][lcapos[b]-(1<<pow2)+1];
	int ret=(level[c1]<level[c2])?c1:c2;
//	cout<<" LCA "<<a<<" "<<b<<" = "<<ret<<" ("<<pow2<<" ; "<<lcapos[a]<<" "<<lcapos[b]<<")"<<endl;
	return ret;
}

void printree(int at,int lev)
{
	if (at>=2*n) return;
	printree(at*2+1,lev+1);
	Repi(lev*8) cout<<" ";
	cout<<" "<<tree[at].mind<<" "<<tree[at].inc<<"["<<tree[at].start<<","<<tree[at].end<<"]\n";
	printree(at*2,lev+1);
}

void treeprep()
{
			n=1; while (n<N) n*=2;
			for (int i=n;i<=2*n;i++) tree[i]=node(INF,0,i-n,i-n);
			for (int i=n-1;i;i--)
			 tree[i]=node(INF,0,tree[i*2].start,tree[i*2+1].end);
}

void fixindex(int id)       
{
	tree[id+n].inc-=leaves[id];
	if (edges[id].SZ)
	 leaves[id]=edges[id].begin()->x,tree[id+n].inc+=leaves[id],tree[id+n].mind=tree[id+n].inc;
	else tree[id+n].mind=tree[id+n].inc=leaves[id]=INF; //no need to -+ cause we won't need it any more (vertice passed so can't add more edges)
	for (id=(id+n)/2;id;id/=2)
 	 tree[id].mind=min(tree[id*2].mind,tree[id*2+1].mind)+tree[id].inc;
// 	cout<<"   fixed index "<<id<<"\n"; printree(1,1); cout<<"\n";
}

void increase(int at,int st,int en,int val)     
{
	if (at>=2*n || tree[at].end<st || tree[at].start>en) return;
	if (tree[at].start>=st && tree[at].end<=en) { tree[at].inc+=val,tree[at].mind+=val; return; }
	increase(at*2,st,en,val); increase(at*2+1,st,en,val);
	tree[at].mind=min(tree[at*2].mind,tree[at*2+1].mind)+tree[at].inc;
//	cout<<"   increased "<<st<<" "<<en<<" with "<<val<<endl; printree(1,1); cout<<"\n";
}

int mindist(int at,int st,int en)         
{
	if (at>=2*n || tree[at].end<st || tree[at].start>en) return INF;
	if (tree[at].start>=st && tree[at].end<=en) return tree[at].mind;
	return min(mindist(at*2,st,en),mindist(at*2+1,st,en))+tree[at].inc;
}

void addedge(int a,int b,int c)
{
//	cout<<" +adding edge "<<a<<" "<<b<<" - "<<c<<"\n";
	edges[pres[a]].insert(MP(c,b));
	eat[lca(a,b)].PB(edge(a,b,c));
	fixindex(pres[a]);
}

void remedge(int a,int b,int c)
{
//	cout<<" -deleting edge "<<a<<" "<<b<<" - "<<c<<"\n";
	edges[pres[a]].erase(MP(c,b));
	fixindex(pres[a]);
}

void print()
{
	cout<<"      edges : \n";
	Repi(N)
	 {
			cout<<"            "<<pre[i]<<" -> ";
			for (set<PI>::iterator it=edges[i].begin(); it!=edges[i].end(); it++)
			 cout<<"("<<it->x<<" "<<it->y<<") "; 
			cout<<endl;
	 }
	cout<<"      eat : \n";
	for (int i=1;i<=N;i++)
	 {
			cout<<"        "<<i<<" : ";
			Repj(eat[i].SZ) cout<<"("<<eat[i][j].a<<","<<eat[i][j].b<<" -> "<<eat[i][j].c<<") ";
			cout<<endl;
	 }
	cout<<"        tree : \n     ";
	for (int i=n;i<n+N;i++) cout<<tree[i].mind<<" "; cout<<endl;
}





void solve(int v)
{
//	cout<<"IN "<<v<<endl;
	Repi(adj[v].SZ)
	 {
			int u=adj[v][i];
			if (p[u]==v || p[v]==u || (pree[u]<=pree[v] && pres[u]>pres[v])) continue;
			addedge(v,u,cost[v][i]+d[u]);
	 }
	 
//	print();

	Repi(adj[v].SZ)
	 {
			int c=adj[v][i];
			if (p[c]!=v) continue;
			solve(c);
			increase(1,pres[c],pree[c],cost[v][i]);
	 }
	
	Repi(eat[v].SZ)
	 {
			int a=eat[v][i].a,b=eat[v][i].b,c=eat[v][i].c;
			remedge(a,b,c);
	 }
	eat[v].clear();
	
	ans[v]=mindist(1,pres[v],pree[v]); if (ans[v]>=INF) ans[v]=-1;
//	cout<<"OUT OF "<<v<<" = "<<ans[v]<<endl;
}





int main()
{
	freopen("travel.in","r",stdin); freopen("travel.out","w",stdout);
	scanf("%d%d",&N,&M);
	int a,b,c;
	Repi(M)
	 {
	   scanf("%d%d%d",&a,&b,&c);
	   adj[b].PB(a); cost[b].PB(c);
	   adj[a].PB(b); cost[a].PB(c);
	 } 
	 
	dijkstra(1,p,d);
	memcpy(used1,used,sizeof(used));
	 

			prec=0;	level[1]=0;
			dfspre(1); 
			lcac=0;
			lcadfs(1); lcapre();
		
		   /* cout<<" lcaord : \n";
			  for (int j=0;(1<<j)<=lcac;j++)
			   {
				 cout<<"   ";
			     Repi(lcac) cout<<lcaord[j][i]<<" " ;cout<<endl;
			   }
		    cout<<" lcalev : "; Repi(lcac) cout<<level[lcaord[0][i]]<<" " ;cout<<endl;*/
		   // cout<<" pre: "; Repi(N) cout<<pre[i]<<" "; cout<<endl;
		    //Repi(N+1) cout<<"   "<<i<<": pres = "<<pres[i]<<" ; pree = "<<pree[i]<<endl;
		
			treeprep();
			solve(1);
			
			for (int i=2;i<=N;i++)
			 if (!used1[i])
			  {
					printf("-1\n");
				}
			 else
			  {
					printf("%d\n",ans[i]);
				}

	return 0;
}

