/*
PROG:travel
LANG:C++
ID:pascala1
*/
//or simply disoint sets if you are no idiot
#include <iostream>
#include <queue>
#include <set>
using namespace std;
#define For(i,a,b) for (int i = a; i < b; i++)
typedef pair<int,int> pii;

struct edge {
	int w, d;
};

vector<edge> adj[100111];

//part 1: find the shortest path tree
bool vis[100111];
int dist[100111];
void dijkstra(pair<int,int> restrict = pair<int,int>())
{
	memset(vis, 0, sizeof(vis));
	memset(dist, 0x7f, sizeof(dist));
	priority_queue<pii, vector<pii>, greater<pii> > Q;
	Q.push(make_pair(0, 0));
	dist[0] = 0;
	while (Q.size())
	{
		pii x = Q.top(); Q.pop();
		int d = x.first, v = x.second;
		if (vis[v]) continue;
		vis[v] = true;
		
		For (i, 0, adj[v].size())
		{
			int w = adj[v][i].w, wt = adj[v][i].d;
			if (d + wt < dist[w] && make_pair(v<?w, v>?w) != restrict)
				dist[w] = d + wt, Q.push(make_pair(d + wt, w));
		}
	}
}

//part 2: calculate the answers
int ans[100111];
int par[100111];
int num[100111];
vector<pii> child[100111];

multiset<pii> dat[100111];
int id[100111];
int find(int x) {
	while (id[x] != x)
		x = id[x] = id[id[x]];
	return x;
}
void unite(int x, int y)
{
	x = find(x), y = find(y);
	if (x == y) return;
	if (dat[x].size() < dat[y].size())
	{
		dat[y].insert(dat[x].begin(), dat[x].end());
		dat[x].clear();
		id[x] = y;
	}
	else 
	{
		dat[x].insert(dat[y].begin(), dat[y].end());
		dat[y].clear();
		id[y] = x;
	}
}

int cnum = 0;
int depth[100111];
void calculate(int v, int dep = 0)
{
	depth[v] = dep;
	//printf("v=%d depth=%d par=%d\n", v, depth[v], par[v]);
	num[v] = cnum++; //dfs number

	For (i, 0, child[v].size()) {
		calculate(child[v][i].first, dep + child[v][i].second);
		unite(v, child[v][i].first);
	}
	
	int fv = find(v);
	//put all the edges in
	For (i, 0, adj[v].size())
	{
		int w = adj[v][i].w, d = adj[v][i].d;
		if (w == par[v]) continue;
		
		//add cross / back edges
		if (!vis[w] || num[w] < num[v])
		{
			dat[fv].insert(make_pair(depth[v] + d + dist[w], w));
			//printf("%d-%d, %d\n", v, w, depth[v] + d + dist[w]);
		}
		else 
		{
			//remove this edge
			multiset<pii>::iterator msi = dat[fv].find(make_pair(depth[w] + d + dist[v], v));
			if (msi != dat[fv].end())
				dat[fv].erase(msi);
		}
	}
	
	//printf("v: %d\n", v); for (typeof dat[fv].begin() si = dat[fv].begin(); si != dat[fv].end(); ++si) printf("%d,%d ", si->first, si->second); puts("");
	
	while (dat[fv].size())
	{
		int w = dat[fv].begin()->second;
		if (!vis[w] || num[w] < num[v]) break;
		dat[fv].erase(dat[fv].begin());
	}
	
	ans[v] = (dat[fv].empty() ? -1 : dat[fv].begin()->first - depth[v]);

	vis[v] = true;
}

int main()
{
	freopen("travel.in", "r", stdin);
	freopen("travel.out", "w", stdout);
	
	int N, M;
	scanf("%d %d", &N, &M);
	For (i, 0, M)
	{
		int a, b, c; scanf("%d %d %d", &a, &b, &c); a--, b--;
		adj[a].push_back((edge) {b, c});
		adj[b].push_back((edge) {a, c});
	}
	
	dijkstra();
	
	For (i, 0, N)
		For (j, 0, adj[i].size())
			if (dist[i] + adj[i][j].d == dist[adj[i][j].w]) {
				child[i].push_back(make_pair(adj[i][j].w, adj[i][j].d));
				par[adj[i][j].w] = i;
			}
	
	For (i, 0, N) id[i] = i;
	
	memset(vis, 0, sizeof(vis));
	memset(ans, -1, sizeof(ans));
	calculate(0);
	
	For (i, 1, N)
		printf("%d\n", ans[i]);
}
