/*
PROG:travel
LANG:C++
ID:pascala1
*/
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define F(i,n) for (int i=0;i<n;i++)
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))

#define MAXN 140000
#define INF 1000000000

int N,M;
VI adj[MAXN],cost[MAXN];

int d[MAXN],p[MAXN],p2[MAXN];
bool used[MAXN],used1[MAXN];
void dijkstra(int v,int p[],int d[])
{
	memset(p,-1,sizeof(int)*(N+3));
	memset(d,127,sizeof(int)*(N+3));
	memset(used,0,N+3);
	PQ<PI,vector<PI>,greater<PI> > q;
	q.push(MP(0,v)); d[v]=0;
	PI tmp;
	while (!q.empty())
	 {
			tmp=q.top(); q.pop();
			if (used[tmp.y]) continue;
			used[tmp.y]=1;
			Repi(adj[tmp.y].SZ)
			 {
					int nxt=adj[tmp.y][i],nc=cost[tmp.y][i]+tmp.x;
					if (!used[nxt] && nc<d[nxt])
					 {
							d[nxt]=nc;
							q.push(MP(nc,nxt));
							p[nxt]=tmp.y;
					 }
			 }
	 }
}


void dijkstra2(int v,int d[],int tar,int banned)
{
	memset(d,127,sizeof(int)*(N+3));
	memset(used,0,N+3);
	PQ<PI,vector<PI>,greater<PI> > q;
	q.push(MP(0,v)); d[v]=0;
	PI tmp;
	while (!q.empty())
	 {
			tmp=q.top(); q.pop();
			if (used[tmp.y]) continue;
			used[tmp.y]=1; if (tmp.y==tar) break;
			Repi(adj[tmp.y].SZ)
			 {
					int nxt=adj[tmp.y][i]; 
					if (used[nxt] || (banned==tmp.y && tar==nxt)) continue;
					int nc=cost[tmp.y][i]+tmp.x;
					if (nc<d[nxt])
					 {
							d[nxt]=nc;
							q.push(MP(nc,nxt));
					 }
			 }
	 }
}

int pre[MAXN],pres[MAXN],pree[MAXN],prec;

void dfspre(int v)
{
	if (used[v]) return;
	pres[v]=prec;
	pre[prec++]=v;
	Repi(adj[v].SZ)
	 if (p[adj[v][i]]==v)
	  dfspre(adj[v][i]);
	pree[v]=prec-1;
}

int n;
int ans[MAXN];
struct node{  int mind,inc; node(){}; node(int a,int b){mind=a,inc=b;};  };
node tree[MAXN*2];
set<PI> edges[MAXN];
struct edge{ int a,b,c; edge(){}; edge(int aa,int bb,int cc){a=aa,b=bb,c=cc;}; };
vector<edge> eat[MAXN];

int lca(int a,int b)                  //better!!!!!!!!!
{
	int a1=a,ans=1;
    memset(used,0,sizeof(used));
	while (a!=1) used[a]=1,a=p[a],counter3++;
	while (b!=1) { if (used[b]) {ans=b; break;} b=p[b]; }
	while (a1!=1) used[a1]=0,a1=p[a1];
	return ans;
}

void fixindex(int id)          //better!!!!!!!!!!!!!
{
	if (edges[id].SZ)
	 tree[id+n].mind=edges[id].begin()->x;
	else tree[id+n].mind=INF;
}

void increase(int st,int en,int val)       //better!!!!!!!!!!!!!!!!!
{
	for (int i=st;i<=en;i++)
	 tree[i+n].inc+=val;
}

int mindist(int st,int en)            //better!!!!!!!!!!!!!!!!!!!
{
	int res=INF;
	for (int i=st;i<=en;i++)
	   res=min(res,tree[i+n].mind+tree[i+n].inc);
	return res;
}

void addedge(int a,int b,int c)
{
//	cout<<" +adding edge "<<a<<" "<<b<<" - "<<c<<"\n";
	edges[pres[a]].insert(MP(c,b));
	eat[lca(a,b)].PB(edge(a,b,c));
	fixindex(pres[a]);
}

void remedge(int a,int b,int c)
{
//	cout<<" -deleting edge "<<a<<" "<<b<<" - "<<c<<"\n";
	edges[pres[a]].erase(MP(c,b));
	fixindex(pres[a]);
}

void print()
{
	cout<<"      edges : \n";
	Repi(N)
	 {
			cout<<"            "<<pre[i]<<" -> ";
			for (set<PI>::iterator it=edges[i].begin(); it!=edges[i].end(); it++)
			 cout<<"("<<it->x<<" "<<it->y<<") "; 
			cout<<endl;
	 }
	cout<<"      eat : \n";
	for (int i=1;i<=N;i++)
	 {
			cout<<"        "<<i<<" : ";
			Repj(eat[i].SZ) cout<<"("<<eat[i][j].a<<","<<eat[i][j].b<<" -> "<<eat[i][j].c<<") ";
			cout<<endl;
	 }
	cout<<"        tree : \n     ";
	for (int i=n;i<n+N;i++) cout<<tree[i].mind<<" "; cout<<endl;
}





void solve(int v)
{
	//cout<<"IN "<<v<<endl;
	Repi(adj[v].SZ)
	 {
			int u=adj[v][i];
			if (p[u]==v || p[v]==u || (pree[u]<=pree[v] && pres[u]>pres[v])) continue;
			addedge(v,u,cost[v][i]+d[u]);
	 }
	 
	//print();

	Repi(adj[v].SZ)
	 {
			int c=adj[v][i];
			if (p[c]!=v) continue;
			solve(c);
			increase(pres[c],pree[c],cost[v][i]);
	 }
	
	Repi(eat[v].SZ)
	 {
			int a=eat[v][i].a,b=eat[v][i].b,c=eat[v][i].c;
			remedge(a,b,c);
	 }
	eat[v].clear();
	
	ans[v]=mindist(pres[v],pree[v]); if (ans[v]>=INF) ans[v]=-1;
	//cout<<"OUT OF "<<v<<" = "<<ans[v]<<endl;
}





int main()
{
	freopen("travel.in","r",stdin); freopen("travel.out","w",stdout);
	scanf("%d%d",&N,&M);
	int a,b,c;
	Repi(M)
	 {
	   scanf("%d%d%d",&a,&b,&c);
	   adj[b].PB(a); cost[b].PB(c);
	   adj[a].PB(b); cost[a].PB(c);
	 } 
	 
	dijkstra(1,p,d);
	memcpy(used1,used,sizeof(used));
	 
/*	if (N<=3100)
	 {
	   for (int i=2;i<=N;i++)
	    {
			dijkstra2(1,d,i,p[i]);
			if (d[i]>1000000000) d[i]=-1;
			printf("%d\n",d[i]);
  	    }
	 }
	else */
	 {
			memset(used,0,sizeof(used)); prec=0;
			dfspre(1);
		
		   // cout<<" pre: "; Repi(N) cout<<pre[i]<<" "; cout<<endl;
		    //Repi(N+1) cout<<"   "<<i<<": pres = "<<pres[i]<<" ; pree = "<<pree[i]<<endl;
		
			n=1; while (n<N) n*=2;
			Repi(n)
			 tree[i]=node(INF,0);
			for (int i=n;i<=2*n;i++) tree[i]=node(INF,0);
			
         	memset(used,0,sizeof(used));
			solve(1);
			
			for (int i=2;i<=N;i++)
			 if (!used1[i])
			  {
					printf("-1\n");
				}
			 else
			  {
					printf("%d\n",ans[i]);
				}
	 } 
	return 0;
}

