/*
PROB: stock
LANG: C++
*/

#include <fstream>
#include <iostream>
#include <algorithm>
using namespace std;

const int MAXD = 15, MAXS = 55, MAXM = 500005;

int S, D, M;
int dp[MAXM];
int cost[MAXS][MAXD];

int main()
{
    ifstream in("stock.in");
    ofstream out("stock.out");
    
    in >> S >> D >> M;
    for (int i = 0; i < S; ++i)
        for (int j = 0; j < D; ++j)
            in >> cost[i][j];
    
    int B = M;
    for (int i = 1; i < D; ++i)
    {
        memset(dp, -1, sizeof(int) * (B + 1));
        dp[B] = 0;
        
        for (int j = 0; j < S; ++j)
        {
            if (cost[j][i] <= cost[j][i - 1]) // Nothing will change!
                continue;
            for (int k = B - cost[j][i - 1]; k >= 0; --k)
                if (dp[k + cost[j][i - 1]] >= 0)
                    if (dp[k] < dp[k + cost[j][i - 1]] + cost[j][i])
                        dp[k] = dp[k + cost[j][i - 1]] + cost[j][i];
        }
        for (int j = B - 1; j >= 0; --j)
            if (dp[j] >= 0)
                if (B < j + dp[j])
                    B = j + dp[j];
    }
    out << B << endl;
    
    in.close();
    out.close();
    return 0;
}
