/*
PROG:shuttle
LANG:C++
ID:pascala1
*/
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define F(i,n) for (int i=0;i<n;i++)
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))

#define MAXN 50003
int N,M,C; int n;
int cnt[MAXN];
PI ints[MAXN];int cost[MAXN],len[MAXN];
int add[MAXN];
#define INF 1000000000

int nonzero[MAXN],minval[MAXN];

struct node{ int nonz,mi; node(){};
             node(int a,int b){nonz=a,mi=b;};
			  };
			  
node tree[MAXN*4]; int tz;

inline void fix(int i)
{
	  tree[i].nonz=tree[i*2].nonz+tree[i*2+1].nonz;
	  tree[i].mi=min(tree[i*2].mi,tree[i*2+1].mi);
}

int init()
{
	for (int i=tz;i<tz*2;i++)
	 if (cnt[i-tz+1])
	  tree[i]=node(1,cnt[i-tz+1]);
	 else tree[i]=node(0,INF);
	for (int i=tz-1;i;i--)
	 fix(i);
}

void printree(int at,int lev)
{
	if (at>=tz*2) return;
	printree(at*2+1,lev+1);
	Repi(lev) cout<<"   ";
	cout<<tree[at].nonz<<","<<tree[at].mi<<endl;
	printree(at*2,lev+1);
}

node query(int at,int l,int r,int L,int R)
{
	if (l>R || r<L) return node(0,INF);
	if (l>=L && r<=R) return tree[at];
	int mid=(l+r)>>1;
	node tmp1=query(at*2,l,mid,L,R),tmp2=query(at*2+1,mid+1,r,L,R);
	tmp1.nonz+=tmp2.nonz;
	tmp1.mi=min(tmp1.mi,tmp2.mi);
	return tmp1;
}

void decrease(int L,int R,int with)
{
	int l=L+tz-1,r=R+tz-1;
	for (int i=l;i<=r;i++)
	 if (tree[i].mi<INF)
	  {	   tree[i].mi-=with; 
	   	   if (!tree[i].mi)
	   	    {
	   	      tree[i].mi=INF,tree[i].nonz=0;
			}
	  }
	while (l)
	 {
	   l/=2,r/=2;
	   for (int i=l;i<=r;i++)
	    fix(i);
	 }
}

struct cmp
{
  bool operator()(const int &a,const int &b) const
  {return (nonzero[a]==nonzero[b])?(a<b):nonzero[a]>nonzero[b]; };
};

inline void getnewdata(int i)
{
			node tmp=query(1,1,tz,ints[i].x,ints[i].y-1);
			nonzero[i]=tmp.nonz;
			minval[i]=tmp.mi;
}

set<int,cmp> q;
int tomod[MAXN],tmc;
int modded[MAXN];

/*int lsort[MAXM],rsort[MAXM];
int posinl[MAXM],posinr[MAXM];
bool cmpl(int a,int b)
{ return ints[a].x<ints[b].x; }
bool cmpr(int a,int b)
{ return ints[a].y<ints[b].y; }
*/
inline bool overlap(int a,int b)
{
	return max(ints[a].y,ints[b].y)-min(ints[a].x,ints[b].x) < len[a]+len[b];
}

int main()
{
	freopen("shuttle.in","r",stdin); freopen("shuttle.out","w",stdout);
	scanf("%d%d%d",&M,&N,&C);
	n=0;
	int ans=0;
	Repi(M)
	 {
			int a,b,c;
			scanf("%d%d%d",&a,&b,&c);
			add[a]+=c; add[b]-=c;
			ints[n++]=MP(a,b); cost[n-1]=c; len[n-1]=b-a;
		//	lsort[n-1]=rsort[n-1]=i;
			ans+=c;
		//	cout<<"    "<<i<<" : "<<ints[i].x<<" "<<ints[i].y<<" - "<<len[i]<<endl;
	 }
	/*sort(lsort,lsort+M,cmpl); 
	sort(rsort,rsort+M,cmpr); 
	Repi(M)
	 posinl[lsort[i]]=i,posinr[rsort[i]]=i;*/
	
/*	Repi(M)
	 {
			cout<<"  "<<i<<" - "<<ints[lsort[i]].x<<" "<<ints[lsort[i]].y<<" ("<<lsort[i]<<")\n";
	 }
	 cout<<endl;
	Repi(M)
	 {
			cout<<"  "<<i<<" - "<<ints[rsort[i]].x<<" "<<ints[rsort[i]].y<<" ("<<rsort[i]<<")\n";
	 }
	*/ 
	tz=1;
	while (tz<N) tz*=2;
	int cur=0;
	for (int i=1;i<N;i++)
	 {
			cur+=add[i];
			cnt[i]=max(0,cur-C);
			//cout<<setw(3)<<cnt[i];
	 }
	//cout<<endl;
	//for (int i=1;i<N;i++) cout<<setw(3)<<i;  cout<<endl;
	 
	init();

	Repi(M)
	 getnewdata(i);
	Repi(M)
	 if (nonzero[i])
	  q.insert(i);
	
	
	int tim=0;
	while (!q.empty())
	 {
			tim++;
			int at=*q.begin(); q.erase(q.begin());
			ans-=minval[at];
			//cout<<" in "<<at<<" - "<<nonzero[at]<<" "<<minval[at]<<" ---- ans "<<ans<<endl;
			decrease(ints[at].x,ints[at].y-1,minval[at]);
			
			tmc=0;
		/*	for (int p=posinl[at];p<M && ints[lsort[p]].x<ints[at].y;p++)
			 {
			   if (modded[lsort[p]]==tim) continue;
			   cout<<"               affl "<<lsort[p]<<endl;
			   tomod[tmc++]=lsort[p];
			   modded[lsort[p]]=tim;
			 }
			for (int p=posinr[at]-1;p>=0 && ints[rsort[p]].y>ints[at].x;p--)
			 {
			   if (modded[rsort[p]]==tim) continue;
			   cout<<"               affr "<<rsort[p]<<endl;
			   tomod[tmc++]=rsort[p];
			   modded[rsort[p]]=tim;
			 }*/
			Repi(M)
			 if (overlap(i,at))
			  tomod[tmc++]=i;
			
			Repi(tmc) 
			 q.erase(tomod[i]);
			Repi(tmc)
			 getnewdata(tomod[i]);
			Repi(tmc)
			 if (nonzero[tomod[i]])
			  {
			//	cout<<"                      reinsert "<<tomod[i]<<endl;
			    q.insert(tomod[i]);
			  }
			  
	/*cout<<endl;
	printree(1,0);
	cout<<endl;
			
	cout<<endl;
	cout<<endl;*/
	 }
	/*Repi(M)
	 {
			node tmp=query(1,1,tz,ints[i].x,ints[i].y-1);
			cout<<"    query "<<ints[i].x<<" "<<ints[i].y-1<<" = "<<tmp.nonz<<" "<<tmp.mi<<endl;
		}*/
	printf("%d\n",ans);
	
	return 0;
}

