/*
PROG:damage2
LANG:C++
ID:pascala1
*/
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define F(i,n) for (int i=0;i<n;i++)
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))
#define INF 1000000000
#define Time ((double)clock()/CLOCKS_PER_SEC)

// I wrote the max flow code some time ago

#define MAXN 3010

template<class CapType> class FlowNetwork_l{
	public: 
		int N,M;
	    vector<VI> adj;
	    vector<vector<CapType> > cap;
	    vector<VI> twin;
	    void init(int _N) { N=_N; M=0; adj.clear(); cap.clear(); adj.resize(N); cap.resize(N); twin.clear(); twin.resize(N); }
	    void add(int u,int v,CapType _cap=1)
	     {
			twin[u].PB(adj[v].SZ); twin[v].PB(adj[u].SZ);
			adj[u].PB(v); adj[v].PB(u);
			cap[u].PB(_cap); cap[v].PB(0);
			M++;
	     }
	    
	    
		vector<vector<CapType> > res;
	    vector<bool> used,sux;
	    VI q,dist;
	    int src,snk;
	    bool bfs(int v)
	     {
				used.assign(N,0);
				dist.assign(N,-1);
				q[0]=v; dist[v]=0; used[v]=1;
				for (int s=0,e=1;s<e;s++)
				 {
						int u=q[s];
						Repi(adj[u].SZ)
						 {
								v=adj[u][i];
								int at=twin[u][i];
								if (res[v][at]>0 && !used[v])
								 {
										dist[v]=dist[u]+1;
										used[v]=1;
										q[e++]=v;
								 }
						 }
				 }
				return used[src];
		 }
	    
	    VI prev,previ,path,pathi;
	    bool dfs(int v)
	     {
				if (v==snk) return 1;
				if (used[v] || sux[v]) return 0;
				used[v]=1;
				Repi(adj[v].SZ)
				 {
				   if (res[v][i] && dfs(adj[v][i]))
				    {
						prev[adj[v][i]]=v;
						previ[adj[v][i]]=i;
						return 1;
					}
				 }
				sux[v]=1;
				return 0;
		 }
	    
	    CapType augment()
	     {
					   int pc=0,u=snk;
					   while (u!=-1) { path[pc++]=u; pathi[pc-1]=previ[u]; u=prev[u]; }
					   reverse(path.begin(),path.begin()+pc); reverse(pathi.begin(),pathi.begin()+pc);
					   
					   CapType mincap=res[path[0]][pathi[1]];
					   for (int i=1;i<pc-1;i++)
					      mincap=min(mincap,res[path[i]][pathi[i+1]]);

					   Repi(pc-1)
					    {
							res[path[i]][pathi[i+1]]-=mincap;
							int at=twin[path[i]][pathi[i+1]];
							res[path[i+1]][at]+=mincap;
						}		
					
					   return mincap;
		 }
	    
	    CapType Dinitz(int source,int sink,bool residual=0)
	     {
				CapType flow=0;
				src=source,snk=sink;
				res=cap;
				q.resize(N); prev.resize(N); previ.resize(N); prev[src]=-1; path.resize(N); pathi.resize(N);
				while (bfs(sink))
				 {
						used.assign(N,0);
						sux.assign(N,0);
						while (dfs(source))
						 {
							flow+=augment();
							used.assign(N,0);
						 }
				 }
				if (residual) cap=res;
				return flow;
		 }
	    
	    
	    
		CapType MaxFlow(int source,int sink,bool residual=0)
		 {
			VI dist(N),path(N),pathi(N),prev(N),previ(N),q(N),next(N);
			vector<bool> used(N);
			vector<vector<CapType> > res=cap;
			int u,v,pc;
			CapType mincap,Flow=0;
		
			q[0]=sink; used[sink]=1; dist[sink]=0;
			for (int s=0,e=1;s<e;s++)
			 {
					u=q[s];
					Repi(adj[u].SZ)
					 {
							v=adj[u][i];
							int at=twin[u][i];
							if (cap[v][at]>0 && !used[v])
							 {
									dist[v]=dist[u]+1;
									used[v]=1;
									q[e++]=v;
							 }
					 }
			 }
		
			u=source; prev[source]=-1; previ[source]=0;
			while (dist[source]<N)
			 {
					for(;next[u]<adj[u].SZ;next[u]++)
					 { v=adj[u][next[u]];
					   if (res[u][next[u]]>0 && dist[u]==dist[v]+1 && dist[v]<INF) break;
					 }
					if (next[u]==adj[u].SZ)
					 {
					   dist[u]=INF;
					   Repi(adj[u].SZ)
					    if (res[u][i]>0)
					     dist[u]=min(dist[u],dist[adj[u][i]]+1);
					   next[u]=0;
					   if (u!=source) u=prev[u];
					   continue;
					 }
					prev[v]=u;
					previ[v]=next[u];
					u=v;
					if (u==sink)
					 {
					   pc=0;
					   while (u!=-1) { path[pc++]=u; pathi[pc-1]=previ[u]; u=prev[u]; }
					   reverse(path.begin(),path.begin()+pc); reverse(pathi.begin(),pathi.begin()+pc);
					   
					   mincap=res[path[0]][pathi[1]];
					   for (int i=1;i<pc-1;i++)
					      mincap=min(mincap,res[path[i]][pathi[i+1]]);
					   Flow+=mincap;
					   Repi(pc-1)
					    {
							res[path[i]][pathi[i+1]]-=mincap;
							int at=twin[path[i]][pathi[i+1]];
							res[path[i+1]][at]+=mincap;
						}
					   u=source;
					 }
			 }
			if (residual) cap=res;
			return Flow;
		 }


      };
	


int N,M,C;
VI adj[MAXN];
int used[MAXN];
int dp[MAXN],dam[MAXN];
bitset<MAXN> conn[MAXN];
int in[MAXN];
int out[MAXN];
int source,sink;


int main()
{
	freopen("damage2.in","r",stdin); freopen("damage2.out","w",stdout);
	scanf("%d%d%d",&N,&M,&C);
	Repi(M)
	 {
			int a,b;
			scanf("%d%d",&a,&b);
			if (a==b || conn[a][b]) continue;
			adj[a].PB(b); adj[b].PB(a);
			conn[a][b]=conn[b][a]=1;
	 }
	int realC=C;
	Repi(C)
	 {
			int j;
			scanf("%d",&j);
			if (dam[j]) realC--;
			dam[j]=1;
	 }
	 
	FlowNetwork_l<int> G;
	G.init( N*2-realC-1  +2 );
	sink=G.N-1; source=0;
	
	int id=1;
	in[1]=out[1]=0;
	for (int i=2;i<=N;i++)
	 if (dam[i])
	  {
			in[i]=out[i]=id++;
			G.add(in[i],sink,INF);
	  }
	 else
	  {
			in[i]=id++;
			out[i]=id++;
			G.add(in[i],out[i]);
	  }
	
	for (int i=1;i<=N;i++)
	 {
			Repj(adj[i].SZ)
			 {
					int v=adj[i][j];
					if (dam[i] && dam[v]) continue;
					G.add(out[i],in[v],INF);
			 }
	 }
	
	printf("%d\n",G.Dinitz(source,sink));
	return 0;
}

