/*
PROG: damage2
LANG: C++
ID: bigbrobg1
*/

#include <iostream>
#include <algorithm>
using namespace std;

const int INF = 1234567;
const int MAXN = 8192;
const int MAXM = 131072;

int P, C, N;
int src, dst;
bool damaged[MAXN];
int d[MAXN];
int q[MAXN];
int adj[MAXM], prev[MAXM], cap[MAXM], last[MAXN];

#define in(x) (2 * x)
#define out(x) (2 * x + 1)

inline void add_edge(int ind, int u, int v, int c) { 
    adj[ind] = v;
    cap[ind] = c;
    prev[ind] = last[u];
    last[u] = ind;
}

void read() {
    freopen("damage2.in", "r", stdin);
    freopen("damage2.out", "w", stdout);
    
    int E = 0;
    scanf("%d %d %d", &P, &C, &N);
    for (int i = 0; i < C; ++i) {
        int u, v;
        scanf("%d %d", &u, &v); --u, --v;
        if (u == v)
            continue;
        add_edge(E++, out(u), in(v), 1);
        add_edge(E++, in(v), out(u), 0);
        
        add_edge(E++, out(v), in(u), 1);
        add_edge(E++, in(u), out(v), 0);
    }
    src = 2 * P;
    dst = 2 * P + 1;
    for (int i = 0; i < N; ++i) {
        int x;
        scanf("%d", &x);
        damaged[x - 1] = true;
    }
    add_edge(E++, src, 0, INF);
    add_edge(E++, 0, src, 0);
    for (int i = 0; i < P; ++i)
        if (damaged[i] || i == 0) {
            if (i != 0) {
                add_edge(E++, out(i), dst, INF);
                add_edge(E++, dst, out(i), 0);
            }
            
            add_edge(E++, in(i), out(i), INF);
            add_edge(E++, out(i), in(i), 0);
        } else {
            add_edge(E++, in(i), out(i), 1);
            add_edge(E++, out(i), in(i), 0);
        }
}

int dfs(int src, int dst, int by) {
    if (src == dst)
        return by;
    for (int i = last[src]; i != -1; i = prev[i])
        if (d[adj[i]] + 1 == d[src] && cap[i] > 0) {
            int b = dfs(adj[i], dst, min(by, cap[i]));
            if (b > 0) {
                cap[i] -= b;
                cap[i ^ 1] += b;
                return b;
            }
            d[adj[i]] = -1;
        }
    return 0;
}

void solve() {
    
    int n = dst + 1;
    int res = 0;
    while (true) {
        int qh = 0;
        int qt = 1;
        memset(d, -1, sizeof(int) * n);
        q[qh] = dst;
        d[dst] = 0;
        while (qh < qt) {
            int at = q[qh++];
            for (int i = last[at]; i != -1; i = prev[i])
                if (cap[i ^ 1] > 0 && d[adj[i]] == -1) {
                    d[adj[i]] = d[at] + 1;
                    q[qt++] = adj[i];
                }
        }
        if (d[src] < 0)
            break;
        int by;
        do {
            by = dfs(src, dst, INF);
            res += by;
        } while (by > 0);
    }
    printf("%d\n", res);
}

int main() {
    memset(last, -1, sizeof(last));
    read();
    solve();
    return 0;
}
