/*
PROG: cowemb
LANG: C++
ID: john_rape1
*/

#include <cstdio>
#include <cmath>
#include <algorithm>

const int MAX_N = 50000 + 5;

struct line
{
	double a, b, c;
};

struct point
{
	double x, y;
	int seg;
	point(double _x, double _y, int _s): x(_x), y(_y), seg(_s){};
	point(){};
};

bool operator< (const point &a, const point &b)
{
	double ang1 = atan2(a.y, a.x);
	if(ang1 < 0)	ang1 += 2 * M_PI;
	double ang2 = atan2(b.y, b.x);
	if(ang2 < 0)	ang2 += 2 * M_PI;
	return ang1 + 1e-9 < ang2;
}

struct seg
{
	int b, e;
	seg(): b(-1), e(-1){}
};

bool operator< (const seg &a, const seg &b)
{
	return a.b < b.b;
}

int BIT[10 * MAX_N];
int sz = 1;

void update(int x, int a)
{
	for(; x <= sz; x += (x & -x))
		BIT[x] += a;
}

int query(int x)
{
	int res = 0;
	for(; x; x ^= (x & -x))
		res += BIT[x];
	return res;
}

int query(int x, int y)
{
	return query(y) - query(x - 1);
}

int N;
long long res;
double d;
line l[MAX_N];
point p[2 * MAX_N];
seg s[MAX_N];
int top = 0;
int all[2 * MAX_N];
int main()
{
//	freopen("cowemb.in", "r", stdin);
//	freopen("cowemb.out", "w", stdout);
	int temp_d;
	scanf("%d %d", &N, &temp_d);
	d = temp_d;
	for(int i = 0; i < N; i ++)
	{
		int a, b, c;
		scanf("%d %d %d", &a, &b, &c);
		l[i].a = a, l[i].b = b, l[i].c = c;
	}
	for(int i = 0; i < N; i ++)
	{
		if(l[i].b == 0)
		{
			double x = -l[i].c / l[i].a;
			if( fabs(x) + 1e-9 < d )
			{
				double y = sqrt(d * d - x * x);
				p[2 * top] = point(x, y, top);
				p[2 * top + 1] = point(x, -y, top);
				top ++;
			}
		}
		else
		{
			double A = l[i].a * l[i].a + l[i].b * l[i].b;
			double K = l[i].a * l[i].c;
			double C = l[i].c * l[i].c - l[i].b * l[i].b * d * d;
			double D = K * K - A * C;
			if(D < 1e-9)	continue;
			double x1 = (- K - sqrt(D)) / A;
			double y1 = (- l[i].a * x1 - l[i].c) / l[i].b;
			p[2 * top] = point(x1, y1, top);
			double x2 = (- K + sqrt(D)) / A;
			double y2 = (- l[i].a * x2 - l[i].c) / l[i].b;
			p[2 * top + 1] = point(x2, y2, top);
			top ++;
		}
	}
	while(sz < 2 * top)	sz <<= 1;
//	printf("size is %d\n", sz);
	std :: sort(p, p + 2 * top);
//	for(int i = 0; i < 2 * top; i ++)	printf("%lf %lf %d\n", p[i].x, p[i].y, p[i].seg);
	for(int i = 0; i < 2 * top; i ++)
		if( s[p[i].seg].b == -1 )	s[p[i].seg].b = i, all[i] = -1;
		else						s[p[i].seg].e = i, all[i] = s[p[i].seg].b;
	std :: sort(s, s + top);
//	for(int i = 0; i < top; i ++)	printf("%d %d\n", s[i].b, s[i].e);
	
	for(int i = 0; i < 2 * top; i ++)
		if( all[i] == -1 )
			update(i + 1, 1);
		else
		{
			res += (long long) query(all[i] + 2, i);
			update(all[i] + 1, - 1);
		}
	printf("%lld\n", res);
	
	
	
    return 0;
}
