/*
ID: pascala1
PROG: bcatch
LANG: C++
Problem bcatch: Apple Catching [Hal Burch, 2004]

It is a little known fact that cows love apples.  Farmer John has
two apple trees (which are conveniently numbered 1 and 2) in his
field, each full of apples. Bessie cannot reach the apples when
they are on the tree, so she must wait for them to fall. However,
she must catch them in the air since the apples bruise when they
hit the ground (and no one wants to eat bruised apples). Bessie is
a quick eater, so an apple she does catch is eaten in just a few
seconds.

Each minute, one of the two apple trees drops an apple. Bessie,
having much practice, can catch an apple if she is standing under
a tree from which one falls. While Bessie can walk between the two
trees quickly (in much less than a minute), she can stand under
only one tree at any time. Moreover, cows do not get a lot of
exercise, so she is not willing to walk back and forth between the
trees endlessly (and, because of this indolence, thus misses some
apples).

Apples fall (one each minute) for T (1 <= T <= 1,000) minutes.
Bessie is willing to walk back and forth at most W (1 <= W <= 30)
times. Given which tree will drop an apple each minute, determine
the maximum number of apples which Bessie can catch.  Bessie starts
at tree 1.

PROBLEM NAME: bcatch

INPUT FORMAT:

* Line 1: Two space separated integers: T and W

* Lines 2..T+1: 1 or 2: the tree that will drop an apple each minute.

SAMPLE INPUT (file bcatch.in):

7 2
2
1
1
2
2
1
1

INPUT DETAILS:

Seven apples fall - one from tree 2, then two in a row from tree 1, then
two in a row from tree 2, then two in a row from tree 1. Bessie is 
willing to walk from one tree to the other twice.

OUTPUT FORMAT:

* Line 1: The maximum number of apples Bessie can catch without
        walking more than W times.

SAMPLE OUTPUT (file bcatch.out):

6

OUTPUT DETAILS:

Bessie can catch six apples by staying under tree 1 until the first two
have dropped, then moving to tree 2 for the next two, then returning back
to tree 1 for the final two.
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

#define MAXN 1024
int n,m,N,M,P,T,K;
int tree[MAXN];

int dp[MAXN][32][2];
int solve(int sec,int moved,int under)
{
	int &ret=dp[sec][moved][under];
	if (ret>-1) return ret;
	if (moved>M || sec==N) return ret=0;
	ret=(tree[sec]==under) + max( solve(sec+1,moved,under) , solve(sec+1,moved+1,under^1) );
	return ret;
}

int main()
{
	freopen("bcatch.in","r",stdin);
	freopen("bcatch.out","w",stdout);
    scanf("%d%d",&N,&M);
    Repi(N)
     scanf("%d",tree+i),tree[i]--;
    
    memset(dp,-1,sizeof(dp));
    cout<<max(solve(0,0,0),solve(0,1,1))<<"\n";
    
//    pause;
    return 0;
}
