/*
ID: pascala1
PROG: books
LANG: C++
Problem books: Books [BulgarianOI, 2005]

A sequence of N (1 <= N <= 200) books on a bookshelf contains respectively
s_1, s_2, ..., s_N pages (1 <= s_i <= 10,000,000). These books must be
digitized by K employees (1 <= K <= 100). The first employee will process 0
or more of the books starting at s1; the second employee will process 0 or
more of the next books in sequence and so on. Each employee is paid d_1
dollars per page for her first processed book, d_2 dollars per page for her
second processed book, ..., d_i dollars per page (0 <= d_i <= 10,000,000)
for her i-th processed book.

Write a program to determine the minimum possible cost to process all the
books.

PROBLEM NAME: books

INPUT FORMAT:

* Line 1: Two space-separated integers, N and K

* Line 2: N space-separated integers, respectively s1, s2, ..., sN

* Line 3: N space-separated integers, respectively d1, d2, ..., dN

SAMPLE INPUT (file books.in):

6 3
50 100 60 5 6 30
1 2 3 4 5 6

OUTPUT FORMAT:

* Line 1: A single line on the standard output, the minimal cost the
        employer has to pay to process all the books.

SAMPLE OUTPUT (file books.out):

339
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define LINF 2000000000000000000LL
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

#define MAXN 205

int n,m,N,M,P,T,K;
int d[MAXN],s[MAXN];
LL dp[MAXN][MAXN];
LL sumfrom[MAXN][MAXN];

int main()
{
	freopen("books.in","r",stdin);
	freopen("books.out","w",stdout);
	
    scanf("%d%d",&N,&K);
    Repi(N) scanf("%d",s+i);
    Repi(N) scanf("%d",d+i);
    
    Repi(N)
      Repj(N-i)
        sumfrom[i][i+j]=((j)?sumfrom[i][i+j-1]:0)+(LL)d[j]*(LL)s[i+j];
	 
    Repi(N) dp[0][i]=sumfrom[0][i];
    
    for (int i=1;i<K;i++)
     Repj(N)
      {
		dp[i][j]=LINF;
        Repk(j+1)
         dp[i][j]=min(dp[i][j],dp[i-1][k]+sumfrom[k+1][j]);
//        cout<<i<<" "<<j<<" = "<<dp[i][j]<<endl;
	  }
	
    cout<<dp[K-1][N-1]<<"\n";
    
    return 0;
}
