/*
ID: pascala1
PROG: pie1
LANG: C++
Problem pie1: Cow Pie Treasures [Kolstad, 2006]

The cows have been busily baking pies that contain gold coins! Each
pie has some number N_i (1 <= N_i <= 25) of gold coins and is neatly
labeled on its crust with the number of gold coins inside.

The cows have placed the pies very precisely in an array of R rows
and C columns (1 <= R <= C <= 100) out in the pasture.  You have
been placed in the pasture at the location (R=1,C=1) and have
gathered the gold coins in that pie. You must make your way to the
other side of the pasture, moving one column closer to the end point
(which is location (R,C)) with each move you make. As you step to
the new column, you may stay on the same row or change your row by
no more than 1 (i.e., from (r,c) you can move to (r-1,c+1), (r,
c+1), or (r+1,c+1).  Of course, you would not want to leave the
field and fail to get some gold coins, and you must end up at (R,C).

Given a map of the pasture, what is the greatest number of gold
coins you can gather?

By way of example, consider this field of gold-bearing cow pies:

start-> 6 5 3 7 9 2 7
        2 4 3 5 6 8 6
        4 9 9 9 1 5 8 <-end

Here's one path:

start-> 6 5 3 7 9 2 7
         \
        2 4 3 5 6 8 6
           \   / \
        4 9 9-9 1 5-8 <-end

The path above yields 6+4+9+9+6+5+8 = 47 gold coins. The path below
is even better and yields 50 coins, which is the best possible:

start-> 6 5 3 7 9 2 7
         \
        2 4 3 5 6-8 6
           \   /   \
        4 9 9-9 1 5 8 <-end

PROBLEM NAME: pie1

INPUT FORMAT:

* Line 1: Two space-separated integers: R and C

* Lines 2..R+1: Each line contains C space-separated small integers in
        the obvious order

SAMPLE INPUT (file pie1.in):

3 7
6 5 3 7 9 2 7
2 4 3 5 6 8 6
4 9 9 9 1 5 8

OUTPUT FORMAT:

* Line 1: An integer (which fits easily into 32 bits) that is the
        maximum number of gold coins that can be gathered

SAMPLE OUTPUT (file pie1.out):

50
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

int n,m,N,M,P,T,K;

int R,C;
int a[128][128];
int dp[128][128];

int solve(int x,int y)
{
	int &ret=dp[x][y];
	if (ret!=-1) return ret;
	ret=solve(x-1,y-1);// cout<<x<<" "<<y<<" =a "<<ret<<endl;
	ret=max(ret,solve(x,y-1));// cout<<x<<" "<<y<<" =b "<<ret<<endl;
	ret=max(ret,solve(x+1,y-1));// cout<<x<<" "<<y<<" =c "<<ret<<endl;
	ret+=a[x][y];
	return ret;
}


int main()
{
    freopen("pie1.in","r",stdin);
    freopen("pie1.out","w",stdout);
    scanf("%d%d",&R,&C);
    Repi(R)
     Repj(C)
      scanf("%d",&a[i+1][j+1]);


    memset(dp,-1,sizeof(dp));
    Repi(R+1) dp[i][0]=a[i][0]=-10000000; Repi(C+1) dp[0][i]=a[0][i]=a[R+1][i]=dp[R+1][i]=-10000000;
    dp[0][0]=a[0][0]=0;
    printf("%d\n",solve(R,C));
    
    return 0;
}
