/*
PROG:digest
LANG:C++
ID:pascala1
roblem digest: Contest Digests [Ilham Kurnia, Russ Cox, 2002]

Farmer John runs his own Olympiad, the USACOW, to keep his cows on
their hooves. FJ's Olympiad is a bit like the USACO contests with
N tasks (1 <= N <= 10), each with T (1 <= T <= 10) test cases, with
each test case worth a certain number of points P_i (1 <= P_i <=
400).

At the end of each contest, FJ posts the results on the barn wall,
using a digest format like the USACO scoring lines, with '*'s marking
correct test cases, '.'s marking incorrect ones, and a total number
of points.

Bessie entered FJ's last contest and remembers N, the total number
of points for each test case, and her total score. She does not,
however, remember which cases she got correct and incorrect.  Help
her find a possible digest line (test cases marked correct and
incorrect) for her score.

If there are multiple possible score lines, find the one that is
lexicographically first when '*'s come before '.'s. Some solution
will exist for each input set.

PROBLEM NAME: digest

INPUT FORMAT:

* Line 1: Two space-separated integers: N and S

* Lines 2..N+1: Many space-separated integers: T_i, ... .  Each line
        describes the test case points for a single task with a number
        of space-separated integers. The first integer on the line,
        T_i, is the number of test cases. The remaining T integers are
        the point values for the test cases for that problem.

SAMPLE INPUT (file digest.in):

2 850
3 100 200 200
2 250 300

OUTPUT FORMAT:

* Lines 1..N: Bessie's results in the usual contest digest form: each
        task should be on its own line, represented by a sequence of
        '*'s and '.'s. Line i reflects the results for task i.

SAMPLE OUTPUT (file digest.out):

**.
**

OUTPUT DETAILS:

Bessie can earn a score of 850 by getting every test case correct except
for task 1, test case 3.  (Bessie could also get every test case correct
except for task 1, test case 2, but that score line -- *.* ** -- comes
lexicographically later.)
*/
#include <cstdio>
#include <iostream>

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

using namespace std;

bool used[15][15];
char yey[2][40001][102];
int q[40001],qc;

int main()
{
	freopen("digest.in","r",stdin); freopen("digest.out","w",stdout);
	int n,s,t[14],p[15][15];
	scanf("%d%d",&n,&s);
	Repi(n)
	 { scanf("%d",t+i);
	   Repj(t[i])  scanf("%d",&p[i][j]);
	 }

	qc=1;
	q[0]=0;
	int at=0,test=0;
	Repi(n)
	 Repj(t[i])
	  {
			Repk(qc) strcpy(yey[at^1][q[k]],yey[at][q[k]]),
					 yey[at^1][q[k]][test]='.',
					 yey[at][q[k]][test]='*';
			int oqc=qc;
			Repk(oqc)
			 {
					int ns=q[k]+p[i][j];
					if (!yey[at^1][ns][0] || strcmp(yey[at^1][ns],yey[at][q[k]])>0)
					 {
							if (!yey[at^1][ns][0]) q[qc++]=ns;
							strcpy(yey[at^1][ns],yey[at][q[k]]);
					 }
			 }
			
			at^=1; test++;
	  }

   test=0;
   Repi(n)
    {
     Repj(t[i])
      printf("%c",yey[at][s][test++]);
     printf("\n");
	}

	
	return 0;
}
