/*
ID: pascala1
PROG: elevator
LANG: C++
Problem elevator: Space Elevator [Coaches , 2004]

The cows are going to space! They plan to achieve orbit by building
a sort of space elevator: a giant tower of blocks. They have K (1
<= K <= 400) different types of blocks with which to build the
tower.  Each block of type i has height h_i (1 <= h_i <= 100) and
is available in quantity c_i (1 <= c_i <= 10). Due to possible
damage caused by cosmic rays, no part of a block of type i can
exceed a maximum altitude a_i (1 <= a_i <= 40000).

Help the cows build the tallest space elevator possible by stacking
blocks on top of each other according to the rules.

PROBLEM NAME: elevator

INPUT FORMAT:

* Line 1: A single integer: K

* Lines 2..K+1: Line i+1 describes block type i with three
        space-separated integers: h_i, a_i, and c_i

SAMPLE INPUT (file elevator.in):

3
7 40 3
5 23 8
2 52 6

OUTPUT FORMAT:

* Line 1: A single integer H, the maximum height of a tower that can
        be built

SAMPLE OUTPUT (file elevator.out):

48

OUTPUT DETAILS:

From the bottom: 3 blocks of type 2, below 3 of type 1, below 6 of
type 3.  Stacking 4 blocks of type 2 and 3 of type 1 is not legal,
since the top of the last type 1 block would exceed height 40.
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

#define MAXN 512
int n,m,N,M,P,T,K;
int h[MAXN],a[MAXN],c[MAXN];

int q[500000];
bool can[500000];

int main()
{
    freopen("elevator.in","r",stdin); freopen("elevator.out","w",stdout);
    
    scanf("%d",&N);
    Repi(N)
     scanf("%d%d%d",h+i,a+i,c+i);
    
    Repi(N)
     Repj(N)
      if (i<j && a[i]>a[j])
       swap(a[i],a[j]),swap(h[i],h[j]),swap(c[i],c[j]);
    
    can[0]=1; q[0]=0; M=1;
    int ans=0;
    Repi(N)
     {
			int from=INF,oM=M;
			Repj(oM)
			  {
					int na=q[j];
					Repk(c[i])
					 {
							na+=h[i]; if (na>a[i]) break;
							if (!can[na])
							 {
									q[M++]=na;
									can[na]=1;
									ans=max(ans,na);
							 }
					 }
			  }
	 }
    
    printf("%d\n",ans);
    
    return 0;
}
