/*
PROG:elite
LANG:C++
ID:pascala1
Problem elite: Elite Eating [Bulgarian Winter 2002 via Nikolay Valtchanov, 2003]

Farmer John's 100 cows are conveniently branded with the integers
1..100. FJ has created an elite milking program where exactly N (1
<= N <= 25) cows with certain brands get to enter the barn first.
The restriction on this elite group of cows is that the sum of the
squares of the brands of each member of the group must be strictly
less than a given integer S (1 <= S <= 10,000).

Determine the number of different groups of cows that can be selected
for the elite milking program.

PROBLEM NAME: elite

INPUT FORMAT:

* Line 1: Two space-separated integers: N and S

SAMPLE INPUT (file elite.in):

3 30

OUTPUT FORMAT:

* Line 1: A single integer that is the number of different possible
        groups that can line up for elite eating.

SAMPLE OUTPUT (file elite.out):

4

OUTPUT DETAILS:

The sequences of length 3 with sum of squares < 30 are:
1 2 3
1 2 4
2 3 4
1 3 4

The sequence of brands 1 2 5 is not valid since 1 + 4 + 25 = 30 and
is not strictly less than 30.
*/
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <map>

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)
#define LL long long

int n,s;
/*
std::map<int,int> dp[101][101];
//	ret=solve(pos-1,used,sum)+solve(pos-1,used-1,sum-pos*pos);	

int solve(int pos,int used,int sum)
{
	if (!pos) return used==0 && sum==0;
	if (pos<0 || used<0 || sum<0) return 0;
	std::map<int,int>::iterator it=dp[pos][used].find(sum); if (it!=dp[pos][used].end()) return it->second;
	int ret=solve(pos-1,used,sum)+solve(pos-1,used-1,sum-pos*pos);
//	printf(" %d %d %d = %d\n",pos,used,sum,ret);
    dp[pos][used][sum]=ret;
	return ret;
}
*/
int cnt[2][101][10000];

int main()
{
	freopen("elite.in","r",stdin); freopen("elite.out","w",stdout);
	scanf("%d%d",&n,&s);
	
 /*   int ans=0;
    Repi(s) ans+=solve(100,n,i); */
    
	int atpos=0;
	cnt[0][0][0]=1;
    for (int pos=1;pos<=100;pos++)
     {
			memset(cnt[atpos^1],0,sizeof(cnt[atpos^1]));
			int pos2=pos*pos;
			for (int used=0;used<=n;used++)
			 for (int sum=0;sum<s;sum++)
			  if (cnt[atpos][used][sum])
			   {
				 int tmp=cnt[atpos][used][sum];
				// printf("%d %d %d = %d\n",pos,used,sum,tmp);
			     cnt[atpos^1][used][sum]+=tmp;
			     if (sum+pos2>=s) continue;
			     cnt[atpos^1][used+1][sum+pos2]+=tmp;
			   }
			atpos^=1;
	 }

    int ans=0;
    for (int i=0;i<s;i++)
     ans+=cnt[atpos][n][i];
    
    printf("%d\n",ans);
	return 0;
}
