/*
ID: pascala1
PROG: jpol
LANG: C++
Problem jpol: Jersey Politics [Coaches, 2004]

[
Memory Limit: 18MB, due to a change in the grading system since this
problem was used.
]

In the newest census of Jersey Cows and Holstein Cows, Wisconsin
cows have earned three stalls in the Barn of Representatives. The
Jersey Cows currently control the state's redistricting committee.
They want to partition the state into three equally sized voting
districts such that the Jersey Cows are guaranteed to win elections
in at least two of the districts.

Wisconsin has 3*K (1 <= K <= 60) cities of 1,000 cows, conveniently
numbered 1..3*K, each with a known number (range: 0..1,000) of
Jersey Cows.  Find a way to partition the state into three districts,
each with K cities, such that the Jersey Cows have the majority
percentage in at least two of districts.

All supplied input datasets are solvable.

PROBLEM NAME: jpol

INPUT FORMAT:

* Line 1: A single integer: K

* Lines 2..3*K+1: Line i+1 contains  a single integer that is city i's
        cow census: the number of cows in each city that are Jersey
        Cows.

SAMPLE INPUT (file jpol.in):

2
510
500
500
670
400
310

OUTPUT FORMAT:

* Lines 1..K: K lines that are the city numbers in district one, one
        per line

* Lines K+1..2K: K lines that are the city numbers in district two,
        one per line

* Lines 2K+1..3K: K lines that are the city numbers in district three,
        one per line

SAMPLE OUTPUT (file jpol.out):

1
2
3
6
5
4

OUTPUT DETAILS:

Other solutions might be possible.  Note that "2 3" would NOT be a
district won by the Jerseys, as they would be exactly half of the
cows.
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

int n,m,N,M,P,T,K;
PI a[256];
char from[61][62000];
unsigned short sumsx[61*62000];
char sumsy[61*62000];
int sc;
bool second[256];

int main()
{
    freopen("jpol.in","r",stdin); freopen("jpol.out","w",stdout);
    
    scanf("%d",&N);
    Repi(3*N) scanf("%d",&a[i].x),a[i].y=i+1;
    
    sort(a,a+3*N); reverse(a,a+3*N);
    
    memset(from,-1,sizeof(from));
    from[0][0]=0;
    sc=1; sumsx[0]=0; sumsy[0]=0;
    
    Repi(2*N)
     {
			int osc=sc;
			Repj(osc)
			 {
					int ns=sumsx[j]+a[i].x,nt=sumsy[j]+1;
					if (nt<=N && from[nt][ns]==-1)
					 {
							from[nt][ns]=i;
							sumsx[sc++]=ns; sumsy[sc-1]=nt;
					//		cout<<" sum "<<ns<<" with "<<nt<<" pieces from "<<a[i].x<<"\n";
					 }
			 }
	 }
	
	int at;
	
	for (int i=500*N+1;;i++)
	 if (from[N][i]>-1)
	  {
			at=i;
			break;
	  }
	  
//	cout<<" at "<<at<<endl;
	for (int i=N;i;i--)
	 {
			second[from[i][at]]=1;
	//		cout<<"  ans "<<a[from[i][at]].x<<endl;
			at-=a[from[i][at]].x;
	 }
	
	Repi(N)
	 cout<<a[i+2*N].y<<"\n";
	Repi(2*N)
	 if (second[i])
	  cout<<a[i].y<<"\n";
	Repi(2*N)
	 if (!second[i])
	  cout<<a[i].y<<"\n";
	 
    return 0;
}
