/*
ID: pascala1
PROG: money
LANG: C++
Problem money: Cow Cash [Traditional, 2003]

The cows have not only created their own government but they have
chosen to create their own money system. In their own rebellious
way, they are curious about values of coinage. Traditionally, coins
come in values like 1, 5, 10, 20 or 25, 50, and 100 units, sometimes
with a 2 unit coin thrown in for good measure.

The cows want to know how many different ways it is possible to
dispense a certain amount of money using various coin systems.  For
instance, using a system with values {1, 2, 5, 10, ...} it is
possible to create 18 units several different ways, including: 18x1,
9x2, 8x2+2x1, 3x5+2+1, and many others.

Write a program to compute how many ways to construct a given amount
of money N (1 <= N <= 10,000) using V (1 <= V <= 25) coins. It is
guaranteed that the total will fit into both a signed 'long long'
integer (C/C++), 'Int64' (Pascal), and 'long' integers in Java.

PROBLEM NAME: money

INPUT FORMAT:

* Line 1: Two space-separated integers: V and N

* Lines 2..V+1: Each line contains an integer that is an available
        coin value

SAMPLE INPUT (file money.in):

3 10
1
2
5

OUTPUT FORMAT:

* Line 1: A single line containing the total number of ways to
        construct N money units using V coins

SAMPLE OUTPUT (file money.out):

10
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,a[32];
long long d[32][11000];

long long count(int last,int left)
{
     if (left==0) return 1;
     if (d[last][left]>-1) return d[last][left];
     long long &r=d[last][left];
     r=0;
     for (int i=last; left-a[i]>=0 && i<n; i++)
      r+=count(i,left-a[i]);
     return r;
}

int main()
{
    int i,j,k,l;
    ifstream f("money.in");
    f>>n>>m;
    Repi(n)
     f>>a[i];
    sort(a,a+n);
    f.close();
    
    memset(d,255,sizeof(d));
    ofstream of("money.out");
    of<<count(0,m)<<"\n";
    of.close();

    return 0;
}
