/*
PROG:packhay
LANG:C++
ID:pascala1
Problem packhay: Hay Packing [Traditional, 2005]

Cows do love their hay. Their latest challenge is storing hay bales
in a certain bin in the barn so they'll have hay throughout FJ's
holiday. They know the bin will hold a maximum volume M (10 <= M
<= 5,000) of hay. They have H (1 <= H <= 200) indivisible hay bales,
each with volume V_i (1 <= V_i <= 500).

They're keen to know: what is the maximum total volume of hay they
can stash into the bin? They can choose as many or as few bales as
they wish.

PROBLEM NAME: packhay

INPUT FORMAT:

* Line 1: Two space-separated integers: M and H

* Lines 2..H+1: Line i contains a single integer: V_i

SAMPLE INPUT (file packhay.in):

21 5
2
4
6
8
10

OUTPUT FORMAT:

* Line 1: The maximum amount of hay that can actually be stored in the
        bin

SAMPLE OUTPUT (file packhay.out):

20

OUTPUT DETAILS:

All the hay bale sizes are even, so it's unlikely that 21 can be achieved
*/
#include <cstdio>

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

int M,H;
int h[10000];
bool can[10000];

int main()
{
	freopen("packhay.in","r",stdin); freopen("packhay.out","w",stdout);
	scanf("%d%d",&M,&H);
	can[0]=1;
	Repi(H) { scanf("%d",h+i); for (int j=M-1;j>=0;j--) if (can[j] && j+h[i]<=M) can[j+h[i]]=1; }
	
	for (int i=M;i>=0;i--)
	 if (can[i])
	  { printf("%d\n",i); return 0; }
	
	return 0;
}
