/*
ID: pascala1
PROG: smrtfun
LANG: C++
Problem smrtfun: Cow Exhibition [Brian Jacokes, 2003]

"Fat and docile, big and dumb, they look so stupid, they aren't
much fun..." - Cows with Guns by Dana Lyons

The cows want to prove to the public that they are both smart and
fun. In order to do this, Bessie has organized an exhibition that
will be put on by the cows. She has given each of the N (1 <= N <=
100) cows a thorough interview and determined two values for each
cow: the cow's smartness S_i (-1000 <= S_i <= 1000) and the cow's
funness F_i (-1000 <= F_i <= 1000).

Bessie must choose which cows she wants to bring to her exhibition.
She believes that the total smartness TS of the group is the sum
of the Si's and, likewise, the total funness TF of the group is the
sum of the Fi's.  Bessie wants to maximize the sum of TS and TF,
but she also wants both of these values to be non-negative (since
she must also show that the cows are well-rounded; a negative TS
or negative TF would ruin this). Help Bessie maximize the sum of
TS and TF without letting either of these values become negative.

PROBLEM NAME: smrtfun

INPUT FORMAT:

* Line 1: A single integer: N

* Lines 2..N+1: Line i+1 contains two space-separated integers: S_i
        and F_i

SAMPLE INPUT (file smrtfun.in):

5
-5 7
8 -6
6 -3
2 1
-8 -5

OUTPUT FORMAT:

* Line 1: One integer: the optimal sum of TS and TF such that both TS
        and TF are  non-negative.  If no subset of the cows has
        non-negative TS and non- negative TF, print 0.

SAMPLE OUTPUT (file smrtfun.out):

8

OUTPUT DETAILS:

Bessie chooses cows 1, 3, and 4, giving values of TS = -5+6+2 = 3 and TF
= 7-3+1 = 5, so 3+5 = 8.  Note that adding cow 2 would improve the value
of TS+TF to 10, but the new value of TF would be negative, so it is not
allowed.
*/
// iterative maxTF[TS][lastused] = max( maxTF[TS][lastused-1] , maxTF[TS-lastused.S][lastused-1] )
//bugs: canceled out all pairs : cow.S + cow.F < 0 which was WRONG!
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <assert.h>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

#define MAXN 128
int n,m,N,M,P,F[MAXN],S[MAXN],K;

int buff[2][200100];
int q[200100],qc;
bool used[200100];

int bf[MAXN],bs[MAXN],bc;
int brute()
{
	int ans=0;
	for (int mask=0;mask<(1<<bc);mask++)
	 {
			int tf=0,ts=0;
			Repi(bc)
			 if (mask&(1<<i))
			  tf+=bf[i],ts+=bs[i];
			if (tf>=0 && ts>=0) 
			 { ans=max(ans,tf+ts);
			 }
	 }
	return ans;
}

int main()
{
    freopen("smrtfun.in","r",stdin); freopen("smrtfun.out","w",stdout);
    
    scanf("%d",&N);
    Repi(N)
     {
	   int a,b;
       scanf("%d%d",S+i,F+i); bf[bc]=S[i],bs[bc++]=F[i];
	 }
//	cout<<brute()<<endl;
     
    Repi(200100) buff[0][i]=buff[1][i]=-INF;
    int *dp[2]; dp[0]=buff[0]+100050,dp[1]=buff[1]+100050;
    memset(used,0,sizeof(used));
    bool *uu=used+100050;
    qc=1; q[0]=0; dp[0][0]=0; uu[0]=1;
    int ans=0,at=0;
    
    Repi(N)
     {
			int oqc=qc,ns;
			Repj(oqc)
			 {
					ns=q[j]+S[i]; dp[at^1][q[j]]=max(dp[at][q[j]],dp[at^1][q[j]]);
					if (!uu[ns]) q[qc++]=ns,uu[ns]=1;
					dp[at^1][ns]=max(dp[at][ns],dp[at^1][ns]);
					dp[at^1][ns]=max(dp[at^1][ns],dp[at][q[j]]+F[i]);
					if (ns>=0 && dp[at^1][ns]>=0) ans=max(ans,ns+dp[at^1][ns]);
			 }
			at^=1;
	 }
    cout<<ans<<"\n";

    return 0;
}
