/*
PROG:apples
LANG:C++
ID:pascala1
Problem apples: Apples [Kuipers, 2002]

When summer comes to the farm, it is time to harvest the cow's
favorite fruit, apples. At FJ's farm, they have an extraordinary
way of harvesting apples: Bessie shakes an apple tree, the apples
fall down and FJ tries to catch as many of the N (1 <= N <= 5,000)
apples as possible.

As an experienced apple catcher, FJ plots his apple catching
carefully. He knows exactly where (an X,Y coordinate where each of
X and Y is in the range -1,000..1,000) each apple will fall and
when (a time in the range 1 <= T <= 1,000,000). He walks to his
planned apple-catching spot so that he can catch the apple as it
falls.

FJ can walk S (1 <= S <= 1,000) units per unit of time. What is the
greatest number of apples he can catch if he starts at point (0,0)
at time 0? Note that FJ takes just over 1.41 units of time to walk
from (0,0) to (1,1) when walking at speed 1.

PROBLEM NAME: apples

INPUT FORMAT:

* Line 1: Two space-separated integers: N and S

* Lines 2..N+1: Line i+1 contains the cartesian coordinates and time
        apple i lands with three space-separated integers: X_i, Y_i,
        and T_i

SAMPLE INPUT (file apples.in):

5 3
0 0 1
0 3 2
-5 12 6
-1 0 3
-1 1 2

OUTPUT FORMAT:

* Line 1: A file with a single line containing an integer that is the
        largest possible number of apples that FJ can catch.

SAMPLE OUTPUT (file apples.out):

3

OUTPUT DETAILS:

FJ can catch apples 1, 5 and 4.
*/
//note : sqrt sux
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))
#define sqr(x) (x)*(x)

struct apple{ int x,y; double t; };
bool operator<(const apple &a,const apple &b)
{ return a.t<b.t; }

int N;
apple a[6000];
int dp[6000];
double S;

int main()
{
	freopen("apples.in","r",stdin); freopen("apples.out","w",stdout);
	scanf("%d%lf",&N,&S);
	Repi(N)
	 scanf("%d%d%lf",&a[i].x,&a[i].y,&a[i].t),a[i].t*=S;
	a[N].x=a[N].y=a[N].t=0; N++;
	sort(a,a+N);
	
	int ans=1;
	dp[0]=0;
	for (int i=1;i<N;i++)
	 {
			dp[i]=-1000000000;
			Repj(i)
			 {
					if ( sqr(a[j].x-a[i].x)+sqr(a[j].y-a[i].y) > sqr(a[i].t-a[j].t) ) continue;
					dp[i]=max(dp[i],dp[j]+1);
			 }
		//	cout<<i<<" = "<<a[i].x<<" "<<a[i].y<<" "<<a[i].t<<" = "<<dp[i]<<endl;
			ans=max(ans,dp[i]);
	 }
	printf("%d\n",ans);
	
	return 0;
}

