/*
PROG:cfair
LANG:C++
ID:pascala1
Problem cfair: The County Fair [Brian Dean, 2006]

Every year, Farmer John loves to attend the county fair. The fair
has N booths (1 <= N <= 400), and each booth i is planning to give
away a fabulous prize at a particular time P(i) (0 <= P(i) <=
1,000,000,000) during the day. He has heard about this and
would like to collect as many fabulous prizes as possible to share
with the cows. He would like to show up at a maximum possible number
of booths at the exact times the prizes are going to be awarded.

FJ investigated and has determined the time T(i,j) (always in range
1..1,000,000) that it takes him to walk from booth i to booth j.
The county fair's unusual layout means that perhaps FJ could travel
from booth i to booth j by a faster route if he were to visit
intermediate booths along the way. Being a poor map reader, Farmer
John never considers taking such routes -- he will only walk from
booth i to booth j in the event that he can actually collect a
fabulous prize at booth j, and he never visits intermediate booths
along the way. Furthermore, T(i,j) might not have the same value
as T(j,i) owing to FJ's slow walking up hills.

Farmer John starts at booth #1 at time 0. Help him collect as many
fabulous prizes as possible.

PROBLEM NAME: cfair

INPUT FORMAT:

* Line 1: A single integer: N.

* Lines 2..1+N: Line i+1 contains a single integer: P(i).

* Lines 2+N..1+N+N^2: These N^2 lines each contain a single integer
        T(i,j) for each pair (i,j) of booths. The first N of these
        lines respectively contain T(1,1), T(1,2), ..., T(1,N). The
        next N lines contain T(2,1), T(2,2), ..., T(2,N), and so on.
        Each T(i,j) value is in the range 1...1,000,000 except for the
        diagonals T(1,1), T(2,2), ..., T(N,N), which have the value
        zero.

SAMPLE INPUT (file cfair.in):

4
13
9
19
3
0
10
20
3
4
0
11
2
1
15
0
12
5
5
13
0

INPUT DETAILS:

There are 4 booths. Booth #1 is giving away a prize at time 13, booth #2
at time 9, booth #3 at time 19, and booth #4 at time 3.

OUTPUT FORMAT:

* Line 1: A single integer, containing the maximum number of prizes
        Farmer John can acquire.

SAMPLE OUTPUT (file cfair.out):

3

OUTPUT DETAILS:

Farmer John first walks to booth #4 and arrives at time 3, just in
time to receive the fabulous prize there. He them walks to booth
#2 (always walking directly, never using intermediate booths!) and
arrives at time 8, so after waiting 1 unit of time he receives the
fabulous prize there. Finally, he walks back to booth #1, arrives
at time 13, and collects his third fabulous prize.
*/
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))

#define MAXN 512
int N,T[MAXN][MAXN]; PI P[MAXN];
int dp[MAXN];

int main()
{
	freopen("cfair.in","r",stdin); freopen("cfair.out","w",stdout);
	scanf("%d",&N);
	Repi(N) scanf("%d",&P[i+1].x),P[i+1].y=i+1;
	sort(P+1,P+N+1);
	Repi(N)
	 Repj(N)
	  scanf("%d",&T[i+1][j+1]);
	Repi(N) T[0][i+1]=T[1][i+1],T[i+1][0]=10000000;

	int ans=0;
	for (int i=1;i<=N;i++)
	 {
			int at=P[i].y;
		//	cout<<" at "<<at<<" ("<<P[i].x<<") :\n";
			Repj(i)
			 {
					int from=P[j].y;
					if (P[j].x+T[from][at]<=P[i].x)
					 {
					//   cout<<"    try from "<<from<<" - "<<P[j].x<<" + "<<T[from][at]<<" ("<<dp[from]<<")"<<endl;
					   dp[at]=max(dp[at],dp[from]+1);
					 }
			 }
			ans=max(ans,dp[at]);
		//	cout<<" "<<at<<" = "<<dp[at]<<endl;
	 }
	printf("%d\n",ans);
	
	return 0;
}

