/*
PROG:leap2
LANG:C++
ID:pascala1
Problem leap2: Millenium Leapcow [via Nikolay Valtchanov, from Bulgaria '01, 2003]

The cows have revised their game of leapcow. They now play in the
middle of a huge pasture upon which they have marked a grid that
bears a remarkable resemblance to a chessboard of N rows and N
columns (3 <= N <= 365).

Here's how they set up the board for the new leapcow game:

* First, the cows obtain N x N squares of paper.  They write the
  integers from 1 through N x N, one number on each piece of paper.

* Second, the 'number cow' places the papers on the N x N squares
  in an order of her choosing.

Each of the remaining cows then tries to maximize her score in the
game:

* First, she chooses a starting square and notes its number.

* Then, she makes a 'knight' move (like the knight on a chess board)
  to a square with a higher number.  If she's particularly strong,
  she leaps to the that square; otherwise she walks.

* She continues to make 'knight' moves to higher numbered squares
  until no more moves are possible.

Each 'knight' move earns the competitor a single point.  The cow
with the most points wins the game.

Help the cows figure out the best possible way to play the game.

PROBLEM NAME: leap2

INPUT FORMAT:

* Line 1: A single integer: N

* Lines 2.....: These lines contain space-separated integers that tell
        the contents of the chessboard.  The first set of lines
        (starting at the second line of the input file) represents the
        first row on the chessboard; the next set of lines represents
        the next row, and so on.

To keep the input lines of reasonable length, when N > 15, a row is
broken into successive lines of 15 numbers and a potentially shorter
line to finish up a row.  Each new row begins on its own line.

SAMPLE INPUT (file leap2.in):

4
1 3 2 16
4 10 6 7
8 11 5 12
9 13 14 15

OUTPUT FORMAT:

* Line 1: A single integer that is the winning cow's score; call it W.

* Lines 2..W+1: Output, one per line, the integers that are the
        starting square, the next square the winning cow visits, and
        so on through the last square. If a winning cow can choose
        more than one path, show the path that would be the 'smallest'
        if the paths were sorted by comparing their respective 'square
        numbers'.

SAMPLE OUTPUT (file leap2.out):

7
2
4
5
9
10
12
13

OUTPUT DETAILS:

The longest tour consists of the moves 2 to 4, 4 to 5, 5 to 9, 9 to
10, 10 to 12, 12 to 13 and has length of 7 squares.
*/
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))

#define MAXN 365
int a[MAXN][MAXN];
int N;
int dp[MAXN][MAXN]; PI from[MAXN][MAXN];

int mov[8][2]={
	{2,1},
	{2,-1},
	{-2,1},
	{-2,-1},
	{1,2},
	{1,-2},
	{-1,2},
	{-1,-2}
	};

int solve(int x,int y)
{
	int &ret=dp[x][y];
	if (ret>-1) return ret;
	
	ret=0;
	from[x][y].x=-1;
	Repi(8)
	 {
			int x1=mov[i][0]+x,y1=mov[i][1]+y;
			if (x1<0 || x1>=N || y1<0 || y1>=N) continue;
			if (a[x1][y1]>a[x][y] && (solve(x1,y1)>ret || (solve(x1,y1)==ret && a[x1][y1]<a[from[x][y].x][from[x][y].y])))
			 {
					ret=solve(x1,y1);
					from[x][y]=MP(x1,y1);
			 }
	 }
	ret++;
	
	//cout<<" "<<x<<" "<<y<<" = "<<ret<<" from "<<from[x][y].x<<" "<<from[x][y].y<<endl;
	return ret;
}

vector<PI> init;

int main()
{
	freopen("leap2.in","r",stdin); freopen("leap2.out","w",stdout);
	scanf("%d",&N);
	Repi(N)
	 Repj(N)
	  scanf("%d",&a[i][j]);
	  
	int ans=0;
	memset(dp,-1,sizeof(dp));
	Repi(N)
	 Repj(N)
	  {
		if (solve(i,j)>ans)
		 ans=solve(i,j),init.clear(),init.PB(MP(i,j));
		else if (solve(i,j)==ans)
		 init.PB(MP(i,j));
	  }
	
	vector<VI> paths(init.SZ);
	Repi(paths.SZ)
	 {
	  while (init[i].x>-1)
	   {
			paths[i].PB(a[init[i].x][init[i].y]);
			init[i]=from[init[i].x][init[i].y];
	   }
	 }
	sort(paths.begin(),paths.end());


	printf("%d\n",ans);
	Repi(ans)
	 printf("%d\n",paths[0][i]);
	
	return 0;
}

