/*
PROG:lexicon
LANG:C++
ID:pascala1
Problem lexicon: The Cow Lexicon [Vladimir Novakovski, 2002]

The cows have a dictionary, you know. It contains W (6 <= W <= 1000)
words, each at most 20 characters long.  Because their cowmunication
system, based on mooing, is not very accurate, sometimes they hear
words that do not make any sense. For instance, Bessie once received
a message that said "browndcodw." As it turns out, the intended
message was "browncow" and the two letter "d"s were noise from other
parts of the barnyard.

The cows want you to help them decipher a received message of length
L (2 <= L <= 1600) characters that is a bit garbled.  In particular,
they know that the message has some extra letters, and they want
you to determine the smallest number of letters that must be removed
to make the message a sequence of words from the dictionary.

PROBLEM NAME: lexicon

INPUT FORMAT:

* Line 1: Two space-separated integers, respectively W and L

* Line 2: L characters (followed by a newline, of course): the
        received message (the message contains only the characters
        'a'..'z')

* Lines 3..W+2: The dictionary, one word per line; words consist only
        of the characters 'a'..'z'.

SAMPLE INPUT (file lexicon.in):

6 10
browndcodw
cow
milk
white
black
brown
farmer

OUTPUT FORMAT:

A single line with a single integer that is the smallest number of
characters that need to be removed to make the message a sequence of
dictionary words.

SAMPLE OUTPUT (file lexicon.out):

2
*/
//nenormalno dp za max common subsequence s multiple patterns sus trie i knapsack elementi
//bug 1 - ne se useti 4e override-nati stoinosti moje da advance-vat sus su6tata bukva, s koqto sa bili overridden
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))

int W,L;
char s[2000];
char word[1024][24];

struct node{
	  int ans,ans1;
	  bool word;
	  node *next[26];
	  node(){ memset(next,0,sizeof(next)); word=0; ans=ans1=-1; };
 		};

void insert(node *root,char *word)
{
	if (!word[0]) { root->word=1; return; }
	node *&nxt=root->next[word[0]-'a'];
    if (!nxt) nxt=new node;
    insert(nxt,word+1);
}

void printree(node *root,int lev,bool letnotans)
{
	bool first=1;
	Repi(26)
	 if (root->next[i])
	  {
			if (!first)
			 Repj(lev) cout<<" ";
			if (letnotans) cout<<(char)(i+'a'); else if (root->next[i]->ans==-1) cout<<"-"; else cout<<root->next[i]->ans;
			printree(root->next[i],lev+1,letnotans);
			first=0;
	  }
	if (root->word) cout<<"\n";
}

node *root,*q[32*1024];
int qc;

int main()
{
	freopen("lexicon.in","r",stdin); freopen("lexicon.out","w",stdout);
	scanf("%d%d",&W,&L);
	scanf("%s",s);
	root=new node;
	Repi(W)
	 {
	   scanf("%s",word[i]);
	   insert(root,word[i]);
	 }
//	printree(root,0,1);
	
	root->ans=0;
	q[0]=root; qc=1;
	for (int i=0;i<L;i++)
	 {
		//	cout<<"\n\n------------adding "<<s[i]<<endl;
			char c=s[i]-'a';
			int oqc=qc;
			Repi(oqc)
			 {
					node *&nxt=q[i]->next[c];
					if (!nxt) continue;
					if (nxt->ans==-1) q[qc++]=nxt;
					nxt->ans1=max(nxt->ans1,q[i]->ans+1);
					if (nxt->word) 
					 { root->ans1=max(root->ans1,nxt->ans1);
			//		   cout<<"          word completed - root = "<<root->ans1<<"\n"; 
					 }
			 }
			Repi(qc)
					q[i]->ans=max(q[i]->ans,q[i]->ans1),q[i]->ans1=-1;
		//	printree(root,0,0);
	 }
	printf("%d\n",L-root->ans);
	return 0;
}

