/*
PROG:treasures
LANG:C++
ID:pascala1
Problem treasures: Treasures [BulgarianOI, 2005]

N (1 <= N <= 1,000) treasures have been buried and can be dug out
to earn money. While digging is expensive, finding a treasure can
create tremendous profit (after expenses are subtracted from the
treasure's value). Create a program to compute the maximum profit
possible from a set of buried treausres.

The treasures each have value Pi (1 <= Pi <= 1,000,000) and are
buried on a two-dimensional grid split into squares, each with
coordinates Xi,Yi (-10,000 <= Xi <= 10,000 and -10,000 <= Yi < 0).

Digging the square with coordinates (x, y) is permitted only if y
= -1 or if the three squares with coordinates (x-1, y+1), (x, y+1)
and (x+1, y+1) have already been dug. The cost for digging a square
is 1. When a treasure is dug out, its value is considered earned.

Determine the maximum possible profit by digging the optimal number
of treasures (which might be 0).

PROBLEM NAME: treasures

INPUT FORMAT:

* Line 1: The single integer N

* Lines 2..N+1: Line i+1 contains three space-separated integers: Xi,
        Yi, and Pi.

SAMPLE INPUT (file treasures.in):

2
7 -2 9
8 -10 20

OUTPUT FORMAT:

* Line 1: A single integer that is the maximum achievable profit

SAMPLE OUTPUT (file treasures.out):

5
*/
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))

#define MAXN 1024
int N;
struct tres{ int x,y,p,sx,ex; };
bool operator<(const tres &a,const tres &b)
{ return a.ex<b.ex; }

tres a[MAXN];
int dp[MAXN];
#define sqr(a) ((a)*(a))

int main()
{
	freopen("treasures.in","r",stdin); freopen("treasures.out","w",stdout);
	scanf("%d",&N);
	Repi(N)
	 scanf("%d%d%d",&a[i+1].x,&a[i+1].y,&a[i+1].p),a[i+1].sx=a[i+1].x+a[i+1].y+1,a[i+1].ex=a[i+1].x-a[i+1].y-1;
	sort(a+1,a+N+1);
	a[0].y=0; a[0].p=0; a[0].x=a[0].sx=a[0].ex=-20000;
	
	int ans=0;
	for (int i=1;i<=N;i++)
	 {
			int profit=a[i].p,loss=a[i].y*a[i].y,common;
			dp[i]=-1000000000;
			for (int j=i-1;j>=0;j--)
			 {
					int hui=a[j].ex-max(a[i].sx,a[j].sx)+1;
					int ch=hui/2+1;
					common=(a[j].ex>=a[i].sx)?sqr(ch)-(hui%2==0)*ch:0;
					dp[i]=max(dp[i],dp[j]+profit-loss+common);
					if (a[j].x+a[j].y>=a[i].x+a[i].y) profit+=a[j].p;
			 }
		   ans=max(ans,dp[i]);
	 }
	printf("%d\n",ans);
	
	return 0;
}

