/*
PROG:cheappal
LANG:C++
ID:pascala1

Problem cheappal: Cheapest Palindrome [Eko Mirhard, 2007]

Memory Limit: 18MB due to system change.

Keeping track of all the cows can be a tricky task so Farmer John
has installed a system to automate it. He has installed on each cow
an electronic ID tag that the system will read as the cows pass by
a scanner. Each ID tag's contents are currently a single string
with length M (1 <= M <= 2,000) characters drawn from an alphabet
of N (1 <= N <= 26) different symbols (namely, the lower-case roman
alphabet).

Cows, being the mischievous creatures they are, sometimes try to
spoof the system by walking backwards. While a cow whose ID is
"abcba" would read the same no matter which direction the she walks,
a cow with the ID "abcb" can potentially register as two different
IDs ("abcb" and "bcba").

FJ would like to change the cows's ID tags so they read the same
no matter which direction the cow walks by. For example, "abcb" can
be changed by adding "a" at the end to form "abcba" so that the ID
is palindromic (reads the same forwards and backwards). Some other
ways to change the ID to be palindromic include adding the three
letters "bcb" to the begining to yield the ID "bcbabcb" or removing
the letter "a" to yield the ID "bcb". One can add or remove characters
at any location in the string yielding a string longer or shorter
than the original string.

Unfortunately as the ID tags are electronic, each character insertion
or deletion has a cost (0 <= cost <= 10,000) which varies depending
on exactly which character value to be added or deleted. Given the
content of a cow's ID tag and the cost of inserting or deleting
each of the alphabet's characters, find the minimum cost to change
the ID tag so it satisfies FJ's requirements. An empty ID tag is
considered to satisfy the requirements of reading the same forward
and backward. Only letters with associated costs can be added to a
string.

PROBLEM NAME: cheappal

INPUT FORMAT:

* Line 1: Two space-separated integers: N and M

* Line 2: This line contains exactly M characters which constitute the
        initial ID string

* Lines 3..N+2: Each line contains three space-separated entities: a
        character of the input alphabet and two integers which are
        respectively the cost of adding and deleting that character.

SAMPLE INPUT (file cheappal.in):

3 4
abcb
a 1000 1100
b 350 700
c 200 800

INPUT DETAILS:

The nametag is "abcb" with these per-operation costs:
  Insert Delete
a  1000   1100
b   350    700
c   200    800

OUTPUT FORMAT:

* Line 1: A single line with a single integer that is the minimum cost
        to change the given name tag.

SAMPLE OUTPUT (file cheappal.out):

900

OUTPUT DETAILS:

If we insert an "a" on the end to get "abcba", the cost would be
1000. If we delete the "a" on the beginning to get "bcb", the cost
would be 1100. If we insert "bcb" at the begining of the string, the
cost would be 350+200+350=900, which is the minimum.
*/
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))

int N,L;
char s[2048];

int ins[127],del[127];
int dp[2002][2002];

int solve(int st,int en)
{
	if (st>=en) return 0; //tuka a ne dolu 6tot se polu4ava st<0 i en>N-1
	int &ret=dp[st][en];
	if (ret>-1) return ret;
	ret=100000000;
	
	if (s[st]==s[en]) return ret=solve(st+1,en-1); //intuitivno tva e vqrno (tuka napravo mojem da return), no ne sum sig za6to
	if (del[s[st]]>-1)
	 ret=min(ret,del[s[st]]+solve(st+1,en));
	if (del[s[en]]>-1)
	 ret=min(ret,del[s[en]]+solve(st,en-1));
	if (ins[s[st]]>-1)
	 ret=min(ret,ins[s[st]]+solve(st+1,en));
	if (ins[s[en]]>-1)
	 ret=min(ret,ins[s[en]]+solve(st,en-1));
	
//	cout<<" "<<st<<" "<<en<<" = "<<ret<<endl;
	return ret;
}

int main()
{
	freopen("cheappal.in","r",stdin); freopen("cheappal.out","w",stdout);
	scanf("%d%d",&N,&L);
	scanf("%s\n",s);
//	cout<<s<<endl;
	memset(ins,-1,sizeof(ins));
	memset(del,-1,sizeof(del));
	Repi(N)
	 {
	  char c;
	  scanf("%c",&c); scanf("%d %d\n",ins+c,del+c);
	//  cout<<"     "<<c<<" - "<<ins[c]<<" "<<del[c]<<endl;
	 }
	
	memset(dp,-1,sizeof(dp));
	printf("%d\n",solve(0,L-1));
	return 0;
}

