/*
PROG:cowrun
LANG:C++
ID:pascala1
Problem cowrun: The Cow Run [Chris Tzamos, 2006]

The N (1 <= N <= 1,000) cows have escaped from the farm and have
gone on a rampage. Each minute a cow is outside the fence, she
causes one dollar worth of damage. Farmer John must visit each one
to install a halter that will calm the cow and stop the damage.

Happily, the cows are positioned in a straight line on a road outside
the farm. FJ can see each of them and knows every cow i's unique
coordinates (-500,000 <= P_i <= 500,000, P_i != 0) relative to the
gate (position 0) where FJ starts.

FJ moves at one unit of distance per minute and can install a halter
instantly. Determine the order that FJ should visit the cows so he
can minimize the total cost of the damage; report the minimum total
damage.

PROBLEM NAME: cowrun

INPUT FORMAT:

* Line 1: A single integer: N

* Lines 2..N+1: Line i+1 contains a single integer: P_i

SAMPLE INPUT (file cowrun.in):

4
-2
-12
3
7

INPUT DETAILS:

Four cows placed in positions: -2, -12, 3, and 7.

OUTPUT FORMAT:

* Line 1: The minimum total cost of the damage.

SAMPLE OUTPUT (file cowrun.out):

50

OUTPUT DETAILS:

The optimal visit order is -2, 3, 7, -12. FJ arrives at position
-2 in 2 minutes for a total of 2 dollars in damage for that cow.

He then travels to position 3 (distance: 5) where the cumulative
damage is  2 + 5 = 7 dollars for that cow.

He spends 4 more minutes to get to 7 at a cost of 7 + 4 = 11 dollars
for that cow.

Finally, he spends 19 minutes to go to -12 with a cost of 11 + 19
= 30 dollars.

The total damage is 2 + 7 + 11 + 30 = 50 dollars.
*/
//absolutely same as ontherun
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))


int N,L;
int p[1024];
int dp[1024][1024];

#define INF 1000000000
int solve(int s,int e)
{
	int &ret=dp[s][e];
	if (ret>-1) return ret;
	ret=INF;
	if (s==e) return ret;
	int left=min(s,e)+N-max(s,e);
	if (s<e)
	 {
			ret=min(ret,solve(s+1,e)+left*(p[s+1]-p[s]));
			ret=min(ret,solve(e,s+1)+left*(p[e]-p[s]));
	 }
	else
	 {
			ret=min(ret,solve(s-1,e)+left*(p[s]-p[s-1]));
			ret=min(ret,solve(e,s-1)+left*(p[s]-p[e]));
	 }
	return ret;
}

int main()
{
	freopen("cowrun.in","r",stdin); freopen("cowrun.out","w",stdout);
	scanf("%d",&N);
	Repi(N)
	 scanf("%d",&p[i]);
	p[N++]=L;
	sort(p,p+N);
	int s; Repi(N) if (p[i]==0) { s=i; break; }
	
	memset(dp,-1,sizeof(dp)); dp[s][s]=0;
	printf("%d\n",min(solve(0,N-1),solve(N-1,0)));
	return 0;
}

