/*
PROG:haystack
LANG:C++
ID:pascala1
Problem haystack: Needle in a Haystack [Brian Dean, 2006]

Farmer John is looking for one tiny little needle in the collection
of his N (1 <= N <= 200) haystacks. The haystacks are all accessible
via paths of different lengths that branch off at right angles from
unique locations of a main trail (which corresponds to the line
y=0); below is a typical map:

                              HS3
               HS1             |
                |   HS2        | HS4
                |    |         |  |
                +----+---------+--+  <-- main trail

Fortunately, FJ has a remarkable metal detector. If he walks all
the way over to a haystack (traversing both an X and Y distance in
rectilinear fashion), the detector can tell him if the needle is
in that haystack; if not, the detector tells him the needle lies
in one of the haystacks to the left (smaller X) or one of the
haystacks to the right (larger X) of the current haystack.

FJ begins his search at (0, 0). The N haystacks have coordinates
(X_i, Y_1) (-10,000 <= X_i <= 10,000 & -10,000 <= Y_i <= 10,000).
No two haystacks share the same X coordinate. Your goal is to
determine how far FJ might walk in the worst case while using an
optimal strategy.

The optimal strategy is the one for which the worst needle position
is least bad, in terms of how far FJ walks.  That is, you should
find the minimum over all search strategies of the maximum over all
needle locations of the distance that Farmer John walks. Output
this value, M.

PROBLEM NAME: haystack

INPUT FORMAT:

* Line 1: A single integer: N

* Lines 2..N+1: Line i+1 contains the two space-separated coordinates
        of haystack i: X_i and Y_i

SAMPLE INPUT (file haystack.in):

4
-9 3
-4 2
6 4
9 2

OUTPUT FORMAT:

* Line 1: A single integer, M

SAMPLE OUTPUT (file haystack.out):

31

OUTPUT DETAILS:

* FJ goes to HS2 (6 units)
* If the needle is on the right, then he goes to HS3 (16 units)
* If the needle is again on the right, then he goes to HS4 (9 units)
These are the worst cases for an optimal strategy.
*/
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))

#define MAXN 202
int dp[MAXN][MAXN][3],N;
PI p[MAXN];

int solve(int st,int en,int where)
{
	int &ret=dp[st][en][where];
	if (ret>-1) return ret;
	if (st>en) return ret=0;
	
	ret=1000000000; PI P;
	if (where==0) P=MP(0,0); else if (where==1) P=p[st-1]; else P=p[en+1];
	for (int i=st;i<=en;i++)
	   ret=min(ret, P.y + abs(P.x-p[i].x) + p[i].y + max( solve(st,i-1,2) , solve(i+1,en,1) ) );
	
	return ret;
}

int main()
{
	freopen("haystack.in","r",stdin); freopen("haystack.out","w",stdout);
	scanf("%d",&N);
	Repi(N)
	 scanf("%d%d",&p[i].x,&p[i].y),p[i].y=abs(p[i].y);
	sort(p,p+N);
	
	memset(dp,-1,sizeof(dp));
	printf("%d\n",solve(0,N-1,0));
	
	return 0;
}

