/*
PROG:ontherun
LANG:C++
ID:pascala1
Problem ontherun: Grazing on the Run [Brian Dean, 2005]

A long linear field has N (1 <= N <= 1,000) clumps of grass at
unique locations on what will be treated as a number line. Think
of the clumps as points on the number line.

Bessie starts at some specified location L on the number line (1
<= L <= 1,000,000) and traverses the number line in the two possible
directions (sometimes reversing her direction) in order to reach
and eat all the clumps.  She moves at a constant speed (one unit
of distance in one unit of time), and eats a clump instantly when
she encounters it.

Clumps that aren't eaten for a while get stale.  We say the
``staleness'' of a clump is the amount of time that elapses from
when Bessie starts moving until she eats a clump.  Bessie wants to
minimize the total staleness of all the clumps she eats.

Find the minimum total staleness that Bessie can achieve while
eating all the clumps.

PROBLEM NAME: ontherun

INPUT FORMAT:

* Line 1 : Two space-separated integers: N and L.

* Lines 2..N+1: Each line contains a single integer giving the
        position P of a clump (1 <= P <= 1,000,000).

SAMPLE INPUT (file ontherun.in):

4 10
1
9
11
19

INPUT DETAILS:

Four clumps: at 1, 9, 11, and 19. Bessie starts at location 10.

OUTPUT FORMAT:

* Line 1: A single integer: the minimum total staleness Bessie can
        achieve while eating all the clumps.

SAMPLE OUTPUT (file ontherun.out):

44

OUTPUT DETAILS:

Bessie can follow this route:

* start at position 10 at time 0
* move to position 9, arriving at time 1
* move to position 11, arriving at time 3
* move to position 19, arriving at time 11
* move to position 1, arriving at time 29

giving her a total staleness of 1+3+11+29 = 44.  There are other routes
with the same total staleness, but no route with a smaller one.
*/
//dp - same as batch, ioi02 - fuck up the future
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))

int N,L;
int p[1024];
int dp[1024][1024];

#define INF 1000000000
int solve(int s,int e)
{
	int &ret=dp[s][e];
	if (ret>-1) return ret;
	ret=INF;
	if (s==e) return ret;
	int left=min(s,e)+N-max(s,e);
	if (s<e)
	 {
			ret=min(ret,solve(s+1,e)+left*(p[s+1]-p[s]));
			ret=min(ret,solve(e,s+1)+left*(p[e]-p[s]));
	 }
	else
	 {
			ret=min(ret,solve(s-1,e)+left*(p[s]-p[s-1]));
			ret=min(ret,solve(e,s-1)+left*(p[s]-p[e]));
	 }
	return ret;
}

int main()
{
	freopen("ontherun.in","r",stdin); freopen("ontherun.out","w",stdout);
	scanf("%d%d",&N,&L);
	Repi(N)
	 scanf("%d",&p[i]);
	p[N++]=L;
	sort(p,p+N);
	int s; Repi(N) if (p[i]==L) { s=i; break; }
	
	memset(dp,-1,sizeof(dp)); dp[s][s]=0;
	printf("%d\n",min(solve(0,N-1),solve(N-1,0)));
	return 0;
}

