/*
PROG:psolve
LANG:C++
ID:pascala1

Problem psolve: Problem Solving [Hal Burch, 2004]

In easier times, Farmer John's cows had no problems. These days,
though, they have problems, lots of problems; they have P (1 <= P
<= 300) problems, to be exact. They have quit providing milk and
have taken regular jobs like all other good citizens; in a normal
month they make M (1 <= M <= 1000) money.

Their problems, however, are so complex they must hire consultants
to solve them. Consultants are not free, but they are competent:
consultants can solve any problem in a single month. Each consultant
demands two payments: one in advance (1 <= payment <= M) to be paid
at the start of the month problem-solving is commenced and one more
payment at the start of the month after the problem is solved (1
<= payment <= M). Thus, each month the cows can spend the money
earned during the previous month to pay for consultants. Cows are
spendthrifts: they can never save any money from month-to-month;
money not used is wasted on cow candy.

Since the problems to be solved depend on each other, they must be
solved mostly in order. For example, problem 3 must be solved before
problem 4 or during the same month as problem 4.

Determine the number of months it takes to solve all of the cows'
problems and pay for the solutions.

PROBLEM NAME: psolve

INPUT FORMAT:

* Line 1: Two space-separated integers: M and P.

* Lines 2..P+1: Line i+1 describes problem i with two space-separated
        integers: B_i and A_i. B_i is the payment to the consult
        BEFORE the problem is solved; A_i is the payment to the
        consult AFTER the problem is solved.

SAMPLE INPUT (file psolve.in):

100 5
40 20
60 20
30 50
30 50
40 40

INPUT DETAILS:

The cows make 100 money each month. They have 5 problems to solve,
which cost 40, 60, 30, 30, and 40 in advance to solve and then 20,
20, 50, 50, and 40 at the beginning of the month after the problems
are solved.

OUTPUT FORMAT:

* Line 1: The number of months it takes to solve and pay for all the
        cows' problems.

SAMPLE OUTPUT (file psolve.out):

6

OUTPUT DETAILS:

+------+-------+--------+---------+---------+--------+
|      | Avail | Probs  | Before  |  After  |  Candy |
|Month | Money | Solved | Payment | Payment |  Money |
+------+-------+--------+---------+---------+--------+
|  1   |  0    | -none- |    0    |    0    |     0  |
|  2   | 100   |  1, 2  | 40+60   |    0    |     0  |
|  3   | 100   |  3, 4  | 30+30   |  20+20  |     0  |
|  4   | 100   | -none- |    0    |  50+50  |     0  |
|  5   | 100   |   5    |   40    |    0    |    60  |
|  6   | 100   | -none- |    0    |   40    |    60  | 
+------+-------+--------+---------+---------+--------+
*/
//phahahahah
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))
#define MAXN 1024

int A[MAXN],B[MAXN];
int N,P;

int ans[MAXN],topay[MAXN];
typedef pair<PI,int> tip;

PQ<tip,vector<tip>,greater<tip> > q;
inline void tryadd(int job,int tans,int nextpay)
{
//	cout<<"             try add "<<job<<" - "<<tans<<" "<<nextpay<<endl;
	if (ans[job]<=tans && topay[job]<=nextpay) return;
//	cout<<"                        SUCCEEDED!!!\n";
	q.push(MP(MP(tans,nextpay),job));
}

int main()
{
	freopen("psolve.in","r",stdin); freopen("psolve.out","w",stdout);
	scanf("%d%d",&P,&N);
	Repi(N)
	 {
	   scanf("%d%d",A+i+1,B+i+1);
	//   cout<<"   "<<i+1<<" - "<<A[i+1]<<" "<<B[i+1]<<endl;
	}
	
	memset(ans,127,sizeof(ans));
	memset(topay,0,sizeof(topay));
	q.push(MP(MP(0,0),0)); tip t;
	while (!q.empty())
	 {
			t=q.top(); q.pop();
			int nextpay=t.x.y,tans=t.x.x,job=t.y;
			if (ans[job]<=tans && topay[job]<=nextpay) continue;
		//	cout<<" in "<<job<<" : "<<tans<<" "<<nextpay<<endl;
			ans[job]=tans,topay[job]=nextpay;
			if (job==N) break;
			int sumA=0,sumB=0;
			for (int i=job+1;i<=N;i++)
			 {
					sumA+=A[i],sumB+=B[i];
					if (sumB>P || sumA>P) continue;
			//		cout<<"    add "<<i<<" : "<<sumA<<" "<<sumB<<endl;
					if (sumA+nextpay<=P)
					 tryadd(i,tans+1,sumB);
					tryadd(i,tans+2,sumB);
			 } 
	 }
	printf("%d\n",ans[N]+2);
	return 0;
}

