/*
PROG:trt
LANG:C++
ID:pascala1
Problem trt: Treats for the Cows [Marco Gallotta, 2005]

FJ has purchased N (1 <= N <= 2000) yummy treats for the cows who
get money for giving vast amounts of milk. FJ sells one treat per
day and wants to maximize the money he receives over a given period
time.

The treats are interesting for many reasons:
  * The treats are numbered 1..N and stored sequentially in single
    file in a long box that is open at both ends. On any day, FJ
    can retrieve one treat from either end of his stash of treats.
  * Like fine wines and delicious cheeses, the treats improve with
    age and command greater prices.
  * The treats are not uniform: some are better and have higher
    intrinsic value. Treat i has value v(i) (1 <= v(i) <= 1000).
  * Cows pay more for treats that have aged longer: a cow will
    pay v(i)*a for a treat of age a.

Given the values v(i) of each of the treats lined up in order of
the index i in their box, what is the greatest value FJ can receive
for them if he orders their sale optimally?

The first treat is sold on day 1 and has age a=1. Each subsequent
day increases the age by 1.

PROBLEM NAME: trt

INPUT FORMAT:

* Line 1: A single integer, N

* Lines 2..N+1: Line i+1 contains the value of treat v(i)

SAMPLE INPUT (file trt.in):

5
1
3
1
5
2

INPUT DETAILS:

Five treats. On the first day FJ can sell either treat #1 (value 1) or
treat #5 (value 2).

OUTPUT FORMAT:

* Line 1: The maximum revenue FJ can achieve by selling the treats

SAMPLE OUTPUT (file trt.out):

43

OUTPUT DETAILS:

FJ sells the treats (values 1, 3, 1, 5, 2) in the following order
*/
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))

int v[2024],N;
int sum[2024];
int dp[2024][2024];
int solve(int st,int en)
{
	int &ret=dp[st][en];
	if (ret>-1) return ret;
	if (st==en) return ret=v[st];
	return ret=max( solve(st+1,en)+sum[en]-sum[st]+v[st] , solve(st,en-1)+sum[en-1]-sum[st]+v[st]+v[en] );
}

int main()
{
	freopen("trt.in","r",stdin); freopen("trt.out","w",stdout);
	scanf("%d",&N);
	Repi(N)
	 scanf("%d",v+i);
	sum[0]=v[0];
	Repi(N)
	 sum[i+1]=sum[i]+v[i+1];
	
	memset(dp,-1,sizeof(dp));
	printf("%d\n",solve(0,N-1));
	return 0;
}

