/*
PROG:turnin
LANG:C++
ID:pascala1
Problem turnin: Turning in Homework [Hal Burch, 2004]

Bessie must turn in her homework for her C classes (1 <= C <= 1,000)
at Moo U so that she still has time to chew the cud with her fellow
classmates as they wait for the bus to go home.

Teachers accept homework submissions only after they have finished
their classes and also cleaned the chalkboard, put away lab supplies,
and so on. The input data tells the earliest time a teacher will
accept homework.

Bessie starts at one end (distance 0) of a hallway H (1 <= H <=
1,000) meters long and walks at the rate of one meter per second
to various classrooms (in any order she chooses) to turn in her
homework. Each classroom is located along this hallway, as well as
the door to the waiting area for the buses.

The distance from the bus waiting area to the hall entrance is B
(0 <= B <= H).

Given the location of both the exit and the classrooms and also the
teachers' schedules, determine the earliest time that Bessie can
exit the door to the waiting area for the buses. Bessie must turn
in all her homework before exiting. The act of turning in the
homework takes no time, by the way.

PROBLEM NAME: turnin

INPUT FORMAT:

* Line 1: Three integers: C, H, and B.

* Lines 2..C+1: Each line contains two integers that describe a
        classroom where homework is to be submitted. The first integer
        (0..H) is the number of meters to the classroom from the
        hallway entrance.  The second integer (0..10,000) is the first
        time (in seconds) that the teacher for that course will accept
        homework.

SAMPLE INPUT (file turnin.in):

4 10 3
8 9
4 21
3 16
8 12

OUTPUT FORMAT:

* Line 1: A single integer: the earliest second that Bessie can exit
        the door to the waiting area for the buses.

SAMPLE OUTPUT (file turnin.out):

22

OUTPUT DETAILS:

Time   Action
  0   Bessie walks to the classrooms 8 meters down the hall (at 8m)
  8   Bessie waits 1 second
  9   Bessie turns in the first set of homework 
  9   Bessie waits 3 seconds, thinking about cool hay in the summertime
 12   Bessie turns in the other homework for this location
 12   Bessie walks back to the classroom 4 meters down the hall (at 4m)
 16   Bessie waits 5 seconds, thinking of a handsome bull she once met
 21   Bessie turns in her homework
 21   Bessie walks back to the classroom 1 meters down the hall (at 3m)
 22   Bessie turns in her homework
 22   Bessie exits, since this also the location of the bus exit

Thus, Bessie can leave at time 22.  No better schedule exists.
*/
// dp[ last_visited_room ][ first_opposite_unvisited_room ]
// dp[a][b] either comes from the state where the first class between a and one of the ends was last visited (and its opposite was also b)
// OR from the state where the first class between b and the other end was visited (and a was its opposite)
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

#define MAXN 1024
int n,m,N,M,P,T,K,C,H,B;
PI klas[MAXN];
int dp[MAXN][MAXN]; PI come[MAXN][MAXN];

int solve(int a,int b)
{
    int &ret=dp[a][b];
    if (ret>-1) return ret;
    
    ret=INF; int tmp;
    int preva,prevb;
    if (a<=b) preva=a-1,prevb=b+1;
    else preva=a+1,prevb=b-1;
    
    if (preva>=0 && preva<C)
      {
        int tmp=max(solve(preva,b)+abs(klas[preva].x-klas[a].x),klas[a].y);
        if (tmp<ret) ret=tmp,come[a][b]=MP(preva,b);
      }
    if (prevb>=0 && prevb<C)
      {   
        int tmp=max(solve(prevb,a)+abs(klas[prevb].x-klas[a].x),klas[a].y);
        if (tmp<ret) ret=tmp,come[a][b]=MP(prevb,a);
      }
    
    return ret;
}



int main()
{freopen("turnin.in","r",stdin); freopen("turnin.out","w",stdout);
    scanf("%d%d%d",&C,&H,&B);
    Repi(C)
            scanf("%d%d",&klas[i].x,&klas[i].y);
    klas[C++]=MP(0,0);
    sort(klas,klas+C);
    
    memset(dp,-1,sizeof(dp));
    dp[0][C-1]=0;
    int ans=INF;
    Repi(C)
     ans=min(ans,solve(i,i)+abs(klas[i].x-B));
    printf("%d\n",ans);

    return 0;
}
