/*
TASK:award
LANG:C++
ID:pascala1
Problem award: Award [Chinese TST 2002, Day 2 Problem 1, 2007]

Memory Limit: 65 MB
Time Limit: 1.5 second

The award ceremony of IOI 2002 will be held in Yong-In Hall. To
make the ceremony more interesting, the organizers want to build
the stage in the shape of an I to represent Informatics. However,
many sponsors have erected displays in the hall and, of course,
they do not want to move these displays. You have been asked to
perform the task of selecting the location of this stage.

Yong-In Hall has the shape of a rectangular grid with R (1 <= R <=
150) rows and C (1 <= C <= 150) columns. The I-shaped stage will
be placed rectilinearly. The stage will be in the shape of 3
rectangles stacked on top of each other. The width of the middle
rectangle must be less than the widths of both the top and bottom
rectangles.  The upper and lower rectangles must have at least one
segment farther right and one segment farther left than the middle
segment's span (otherwise, the stage might be mistaken for T, L or
J). The widths of the top and bottom may differ as may the heights.

For example, the stage layouts below are valid (I represents part
of the stage, . represents empty space:

IIIII.      .IIIII
..II.. and  ..II..
IIIIII      IIIII.
IIIIII

The following stages are not valid:

IIII
.II.
III. (lower rectangle does not extend beyond the middle segment)

IIIII
.....
..I..
III.. (since it's not connected)

I..I
IIII
I..I (the top and bottom rectangles are not rectangles)

Your program should find the area of the largest 'I' that does not
overlap with any of the displays. Output 0 if no 'I' can be made.

PROBLEM NAME: award

INPUT FORMAT:

* Line 1: Two space-separated integers: R and C

* Lines 2..R+1: Line i+1 contains row i expressed as C space-separated
        integers. The jth integer is 1 if there is a display board in
        column j and 0 otherwise.

SAMPLE INPUT (file award.in):

6 8
1 1 1 1 1 0 0 1
1 0 0 0 0 1 1 1
1 0 0 0 0 0 1 1
1 0 1 0 1 0 1 0
1 0 0 0 0 0 0 1
1 1 0 0 0 1 0 1

INPUT DETAILS:

The grid has 6 rows and 8 columns with a total of 23 displays

OUTPUT FORMAT:

SAMPLE OUTPUT (file award.out):

15

OUTPUT DETAILS:

The maximum sized I is denoted by the Is in the following diagram:
XXXXX..X
XIIIIXXX
XIIII.XX
X.XIX.X.
X.III..X
XXIIIX.X
*/
#include <cstdio>
#include <iomanip>
#include <iostream>
#define MAXN 152
#define F(i,n) for (int i=0;i<n;i++)

int N,M;
int a[MAXN][MAXN];
int s[MAXN][MAXN];

int dp[2][MAXN][MAXN][5];
inline bool empty(int row,int a,int b)
{ return (a>b || a<0 || b>=M)?0:(a)?(s[row][b]-s[row][a-1]==b-a+1):(s[row][b]==b+1); }

int main()
{
	freopen("award.in","r",stdin);
	freopen("award.out","w",stdout);
    scanf("%d%d",&N,&M);
    F(i,N)
     F(j,M)
      scanf("%d",&a[i][j]);
    
    int at=0,ans=0;
    F(row,N)
     {
             memset(dp[at^1],0,sizeof(dp[at^1]));
             s[row][0]=!a[row][0];
             if (s[0]) dp[at^1][0][0][0]=1;
             for (int i=1;i<M;i++) 
              {
                s[row][i]=s[row][i-1]+(!a[row][i]);
                for (int j=i;j>=0 && !a[row][j];j--)
                   dp[at^1][j][i][0]=i-j+1;
             
             // from row-1 to row
             for (int j=M-1;j>=0;j--)
              for (int i=0;i<=j;i++) // i,j -> i+1,j-1   and, of course, i,j -> i,j
               {
				    if (empty(row,i,j))
				     {
					  if (dp[at][i][j][0])
					      dp[at^1][i][j][0]>?=dp[at][i][j][0]+j-i+1;
					  if (dp[at][i][j][2])
						  dp[at^1][i][j][2]>?=dp[at][i][j][2]+j-i+1;
					  if (dp[at][i][j][4])
					  	  dp[at^1][i][j][4]>?=dp[at][i][j][4]+j-i+1,ans>?=dp[at^1][i][j][4];
					 }
					if (dp[at][i][j][0] && i+1<=j-1)
						dp[at^1][i+1][j-1][1]>?=dp[at][i][j][0]+j-i-1;
			   }
			for (int j=0;j<M;j++)
			 for (int i=j;i>=0;i--)  // i,j -> i-1,j+1
			  if (empty(row,i-1,j+1) && dp[at][i][j][2])
			   dp[at^1][i-1][j+1][3]>?=dp[at][i][j][2]+j-i+3,ans>?=dp[at^1][i-1][j+1][3];
			
			at^=1;
			
			// from row to (same) row
            for (int j=M-1;j>=0;j--)
             for (int i=0;i<=j;i++) // i,j -> i+1,j-1   and, of course, i,j -> i,j
              if (dp[at][i][j][1])
               {
					if (i<j)
					 {
					   dp[at][i+1][j][1]>?=dp[at][i][j][1]-1;
					   dp[at][i][j-1][1]>?=dp[at][i][j][1]-1;
					 }
					if (empty(row,i,j))
					 dp[at][i][j][2]>?=dp[at][i][j][1];
			   }
			for (int j=0;j<M;j++)
			 for (int i=j;i>=0;i--)  // i,j -> i-1,j+1   and, of course, i,j -> i,j
			  if (dp[at][i][j][3])
			   {
					if (i && !a[row][i-1])
					 dp[at][i-1][j][3]>?=dp[at][i][j][3]+1,ans>?=dp[at][i-1][j][3];
					if (j<M-1 && !a[row][j+1])
					 dp[at][i][j+1][3]>?=dp[at][i][j][3]+1,ans>?=dp[at][i][j+1][3];
					dp[at][i][j][4]>?=dp[at][i][j][3];
			   }
	 }
    
    printf("%d\n",ans);
    return 0;
}
