/*
PROG:essay
LANG:C++
ID:pascala1
Problem essay: Last Minute Writing [Hal Burch, 2004]

Bessie forgot that her essay on the advantages of Bermuda grass
over Crab grass was due today. She now must do as well as she can
as she writes the essay on her tractor ride to Moo U. Unfortunately,
Bessie gets tractor sick when she tries to write. Bessie writes one
word per second; help her determine the longest essay she can write.

The tractor ride to Moo U is S (1 <= S <= 1,000) seconds long. Each
second, Bessie can choose whether or not to write. If she writes,
her queasiness increases. If she does not write, her queasiness
decreases. At the beginning of the tractor ride, Bessie's queasiness
is 0 (it never drops below 0, of course). If her queasiness rises
above Q (1 <= Q <= 5,000), then Bessie becomes sick and tosses her
hay, ruining the paper on which she is writing her essay.

Her queasiness increases or decreases based on many variables: speed
of the tractor, acceleration of the tractor, and the smoothness of
the road. For second #i of her ride, you are given how her queasiness
will change if she writes (0 <= W_i <= Q) or if she does not write
(0 <= N_i <= Q).

PROBLEM NAME: essay

INPUT FORMAT:

* Line 1: Two space-separated integers: S and Q

* Lines 2..S+1: Line i+1 describes second #i with two space-separated
        integers: W_i and N_i

SAMPLE INPUT (file essay.in):

5 50
10 40
45 7
25 25
1 13
39 20

OUTPUT FORMAT:

* Line 1: A single integer, the maximum number of words Bessie can
        write.

SAMPLE OUTPUT (file essay.out):

3

OUTPUT DETAILS:

Bessie should write at time 1, rest at time 2, write at times 3 and 4, and
rest at time 5.
*/
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define F(i,n) for (int i=0;i<n;i++)
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))

#define MAXN 1024
#define MAXQ 5010
int S,Q,w[MAXN],n[MAXN];
int dp[2][MAXQ];
int q[2][MAXQ],qc[2];

int main()
{
	freopen("essay.in","r",stdin); freopen("essay.out","w",stdout);
	scanf("%d%d",&S,&Q);
	Repi(S) 
	 {
			scanf("%d%d",w+i,n+i);
	 }
	 
	int at=0,ans=0;
	dp[0][0]=0; q[0][qc[0]++]=0;
	Repi(S)
	 {
			qc[at^1]=0;
			memset(dp[at^1],0,sizeof(dp[at^1]));
		//	cout<<" "<<w[i]<<" "<<n[i]<<endl;
			Repj(qc[at])
			 {
					int sick=q[at][j];
				//	cout<<"             from "<<sick<<" ("<<dp[at][sick]<<")"<<endl;
					if (sick+w[i]<=Q && dp[at^1][sick+w[i]]<dp[at][sick]+1)
					 {
							if (!dp[at^1][sick+w[i]]) q[at^1][qc[at^1]++]=sick+w[i];
							dp[at^1][sick+w[i]]=dp[at][sick]+1;
							ans>?=dp[at^1][sick+w[i]];
					 }
					int nsick=max(0,sick-n[i]);
					if (dp[at^1][nsick]<dp[at][sick])
					 {
							if (!dp[at^1][nsick]) q[at^1][qc[at^1]++]=nsick;
							dp[at^1][nsick]=dp[at][sick];
							ans>?=dp[at^1][nsick];
					 }
			 }
			at^=1;
	 }
	
	printf("%d\n",ans);
	return 0;
}

