/*
PROG:inspect
LANG:C++
ID:pascala1

Problem inspect: Inspecting the Farm [Vlad Novakovski, 2003]

The cows are in trouble. After a rowdy Hay Festival, they have
wrought havoc on the paths that connect the N (2 <= N <= 2,500)
pastures conveniently numbered 1..N on the farm, and Farmer John
has set out to investigate.  To make a somewhat thorough inspection
of his farm, he must visit at least K (1 <= K <= 500) paths.

In order to make amends for their mischievous behavior, the cows
wish to perform a favor for Farmer John. They want to plan his trip
subject to his constraints. They know that he will start his journey
from pasture 1 and end it at pasture N. They also have a list of
the the P (2 <= P <= 10,000) unidirectional inter-pasture paths,
each with starting pasture S_i and ending pasture E_i. The keenly
observant cows have even observed that there is not a single set
of directed paths on the farm that forms a cycle.

By way of example, suppose there are 4 pastures connected by paths
1->2, 2->3, 3->4, 1->3, and 1->4, and that Farmer John must travel
along at least K=2 paths when walking from pasture 1 to pasture 4.
In this case, the only two feasible routes are 1->3->4 and 1->2->3->4.

Help the cows determine the number of possible routes that Farmer
John can take.

PROBLEM NAME: inspect

INPUT FORMAT:

* Line 1: Three space-separated integers: N, K, and P

* Lines 2..P+1: Line i+1 contains two space-separated integers: S_i
        and E_i

SAMPLE INPUT (file inspect.in):

4 2 5
1 2
1 3
1 4
3 2
2 4

OUTPUT FORMAT:

* Line 1: A single integer, the number of possible journeys for Farmer
        John. The answer is guaranteed to fit into a 64-bit signed
        integer.

SAMPLE OUTPUT (file inspect.out):

2
*/
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define F(i,n) for (int i=0;i<n;i++)
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))

int N,K,P;
#define MAXN 2600
#define MAXK 512
VI adj[MAXN];
LL dp[MAXN][MAXK];
VI from[MAXN];
int longest[MAXN];

int sorted[MAXN],cnt;
bool used[MAXN];
void topsort(int v)
{
	if (used[v]) return;
	used[v]=1;
	Repi(from[v].SZ)
	 topsort(from[v][i]);
	sorted[cnt++]=v;
}

int main()
{
	freopen("inspect.in","r",stdin); freopen("inspect.out","w",stdout);
	scanf("%d%d%d",&N,&K,&P);
	Repi(P)
	 {
			int a,b;
			scanf("%d%d",&a,&b);
			adj[a].PB(b);
			from[b].PB(a);
	 }
	topsort(N);
	memset(longest,-1,sizeof(longest));
	dp[1][0]=1; longest[1]=0;
	Repi(N)
	 {
			int v=sorted[i];
		//	cout<<" in "<<v<<" - "<<longest[v]<<endl;
			Repj(adj[v].SZ)
			 {
					int to=adj[v][j];
			//		cout<<"          to "<<to<<endl;
					for (int k=0;k<=longest[v];k++)
					 {
							longest[to]>?=min(K,k+1);
							dp[to][min(K,k+1)]+=dp[v][k];
				//			cout<<"             "<<to<<" "<<k+1<<" += "<<v<<" "<<k<<" = "<<dp[to][k+1]<<endl;
					 }
			 }
	 }
	
	cout<<dp[N][K]<<"\n";
	return 0;
}

