/*
ID: pascala1
PROG: naptime
LANG: C++
Problem naptime: Naptime [Tiankai Liu, 2004]

Goneril is a very sleep-deprived cow. Her day is partitioned into
N (3 <= N <= 3,830) equal time periods but she can spend only B (2
<= B < N) not necessarily contiguous periods in bed. Due to her
bovine hormone levels, each period has its own utility U_i (0 <=
U_i <= 200,000), which is the amount of rest derived from sleeping
during that period. These utility values are fixed and are independent
of what Goneril chooses to do, including when she decides to be in
bed.

With the help of her alarm clock, she can choose exactly which
periods to spend in bed and which periods to spend doing more
critical items such as writing papers or watching baseball. However,
she can only get in or out of bed on the boundaries of a period.

She wants to choose her sleeping periods to maximize the sum of the
utilities over the periods during which she is in bed.  Unfortunately,
every time she climbs in bed, she has to spend the first period
falling asleep and gets no sleep utility from that period.

The periods wrap around in a circle; if Goneril spends both periods
N and 1 in bed, then she does get sleep utility out of period 1.

What is the maximum total sleep utility Goneril can achieve?

PROBLEM NAME: naptime

INPUT FORMAT:

* Line 1: Two space-separated integers: N and B

* Lines 2..N+1: Line i+1 contains a single integer: U_i

SAMPLE INPUT (file naptime.in):

5 3
2
0
3
1
4

INPUT DETAILS:

The day is divided into 5 periods, with utilities 2, 0, 3, 1, 4 in that
order. Goneril must pick 3 periods.

OUTPUT FORMAT:

* Line 1: A single integer, the maximum total sleep utility Goneril
        can achieve.

SAMPLE OUTPUT (file naptime.out):

6

OUTPUT DETAILS:

Goneril can get total utility 6 by being in bed during periods 4,
5, and 1, with utilities 0 [getting to sleep], 4, and 2
respectively.

*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)
#define F(i,n) for (int i=0;i<n;i++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

#define MAXN 3900
using namespace std;
int N,M;
int a[MAXN];
int dp[2][MAXN][2][2]; // pos, left, sleeping after prev interval, slept before 1st interval

int main()
{
    freopen("naptime.in","r",stdin);
    freopen("naptime.out","w",stdout);
    
    scanf("%d%d",&N,&M);
    Repi(N) scanf("%d",a+i);
    
    int at=0;
    memset(dp,-127,sizeof(dp));
    dp[0][M][0][0]=dp[0][M][1][1]=0;
    for (int i=0;i<N;i++)
     {
            memset(dp[at^1],-127,sizeof(dp[at^1]));
            int leftmax=min(M,N-i);
            //cout<<"   at "<<a[i]<<" \n";
            for (int left=0;left<=leftmax;left++)
             for (int first=0;first<2;first++)
              {
                    dp[at^1][left][0][first]>?=dp[at][left][0][first];
                   // cout<<"     first "<<first<<" :    aa  "<<left<<" 0 = "<<dp[at^1][left][0][first]<<endl;
                    dp[at^1][left][0][first]>?=dp[at][left][1][first];
                   // cout<<"     first "<<first<<" :    bb  "<<left<<" 0 = "<<dp[at^1][left][0][first]<<endl;
                    if (left)
                     {
                      dp[at^1][left-1][1][first]>?=dp[at][left][0][first];
                   //   cout<<"     first "<<first<<" :    cc  "<<left-1<<" 1 = "<<dp[at^1][left-1][1][first]<<endl;
                      dp[at^1][left-1][1][first]>?=dp[at][left][1][first]+a[i];
                    //  cout<<"     first "<<first<<" :    dd  "<<left-1<<" 1 = "<<dp[at^1][left-1][1][first]<<endl;
                     }
              }

            at^=1;
     }

    int ans=0;
    ans>?=dp[at][0][0][0];
    ans>?=dp[at][0][1][0];
    ans>?=dp[at][0][1][1];
    printf("%d\n",ans);
    return 0;
}
