/*
PROG:path
LANG:C++
ID:pascala1
Problem path: Bessie's Path [Mircea Pasoi, 2003]

Farmer John has announced he will present a lecture on Cowmputer
Science in exactly K (1 <= K <= 600) minutes. Knowing there are N
(1 <= N <= 5,000) farms conveniently numbered from 1..N in his
county, FJ decided to present the lecture in farm N.

Bessie is at farm 1 and wants to see FJ's lecture. She is so
meticulous that she wants her path to take exactly K minutes (so
that she will reach FJ's lecture exactly on time).

The cows know all about the roads. The farms are connected by M (1
<= M <= 15,000) two-way roads, and between any two different farms
with id's F1_i and F2_i, there is at most one road which Bessie
might traverse. Each road requires precisely one minute to traverse,
and each road i has its own traversal tax (0 <= T_i <= 32,000).

Help Bessie find the cheapest path (minimizing the sum of all the
taxes; see below) from farm 1 to farm N in exactly K minutes.  It
is guaranteed that such a path always exists, and that Bessie has
enough money to pay the crossing taxes.

PROBLEM NAME: path

INPUT FORMAT:

* Line 1: Three space-separated integers: N, M, and K

* Lines 2..M+1: Line i+1 describes road i with three space-separated
        integers: F1_i, F2_i, and T_i

SAMPLE INPUT (file path.in):

5 5 3
1 2 2
1 3 1
2 5 2
3 4 2
4 5 3

OUTPUT FORMAT:

* Line 1: The minimum tax that Bessie has to pay.

SAMPLE OUTPUT (file path.out):

6

OUTPUT DETAILS:

The path 1 -> 3 -> 4 -> 5 takes exactly 3 minutes to cross and its cost is
the sum of taxes: 1 + 2 + 3 = 6. There is no other cheaper path.
*/
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define F(i,n) for (int i=0;i<n;i++)
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))

int N,M,K;

struct edge{int a,b,c;};
vector<edge> edges;
int dp[2][5100];

int main()
{
	freopen("path.in","r",stdin); freopen("path.out","w",stdout);
	scanf("%d%d%d",&N,&M,&K);
	Repi(M)
	 {
			int a,b,c;
			scanf("%d%d%d",&a,&b,&c);
			edges.PB((edge){a,b,c});
	 }
	
	int at=0;
	memset(dp[at],127,sizeof(dp[at]));
	dp[0][1]=0;
	Repi(K)
	 {
			memset(dp[at^1],127,sizeof(dp[at^1]));
			Repj(edges.SZ)
			 {
			   dp[at^1][edges[j].b]<?=dp[at][edges[j].a]+edges[j].c;
			   dp[at^1][edges[j].a]<?=dp[at][edges[j].b]+edges[j].c;
			 }
			at^=1;
	 }
	
	printf("%d\n",dp[at][N]);
	return 0;
}

