/*
PROG:zoo
LANG:C++
ID:pascala1

Problem zoo: Zoo [APIO, 2007]

The pride of the Asia-Pacific region is the newly constructed Great
Circular Zoo. Situated on a small Pacific island, it comprises a
large circle of different enclosures, each containing its own exotic
animal as illustrated below.

You are in charge of public relations for the zoo, which means it
is your job to keep people as happy as possible. A bus load of
schoolchildren has just arrived, and you are eager to please them.
There are animals that some children love, and there are animals
that some children fear. For example, little Alex loves monkeys and
koalas because they are cute, but fears lions because of their sharp
teeth. On the other hand, Polly loves lions because of their beautiful
manes, but fears koalas because they are extremely smelly.

You have the option of removing some animals from their enclosures,
so that children are not afraid. However, you are worried that if
you remove too many animals then this will leave the children with
nothing to look at. Your task is to decide which animals to remove
so that as many children can be made happy as possible.

Each child is standing outside the circle, where they can see five
consecutive enclosures. You have obtained a list of which animals
each child fears, and which animals each child loves. A child will
be made happy if

* At least one animal they fear is removed from their field of
  vision

or

* At least one animal they love is not removed from their field of
  vision.

For example, consider the list of children and animals illustrated below:

 Child      Visible Enclosures     Fears                  Loves
Alex        2, 3, 4, 5, 6        Enclosure 4            Enclosures 2, 6
Polly       3, 4, 5, 6, 7        Enclosure 6            Enclosure 4
Chaitanya   6, 7, 8, 9, 10       Enclosure 9            Enclosures 6, 8
Hwan        8, 9, 10, 11, 12     Enclosure 9            Enclosure 12
Ka-Shu      12, 13, 14, 1, 2     Enclosures 12, 13, 2

Suppose you remove the animals from enclosures 4 and 12. This will
make Alex and Ka-Shu happy, because at least one animal that they
fear has gone. This will also keep Chaitanya happy, since both
enclosures 6 and 8 still contain animals that he loves. However,
both Polly and Hwan will be unhappy, since they cannot see any
animals that they love but they can still see all the animals that
they fear. This arrangement therefore gives a total of three happy
children.

Now suppose you put these animals back into their enclosures, and
instead remove the animals from enclosures 4 and 6. Alex and Polly
will be happy because the animals that they fear in enclosures 4
and 6 have gone. Chaitanya will be happy because, even though animal
6 has gone, he can still see the animal in enclosure 8 which he
loves. Likewise, Hwan will be happy because she can now see the
animal in enclosure 12, which she loves. The only person unhappy
will be Ka-Shu.

Finally, suppose you put the animals back once more and then remove
only the animal from enclosure 13. Ka-Shu will now be happy since
one animal that he fears has been removed, and Alex, Polly, Chaitanya
and Hwan will all be happy since they can all see at least one
animal that they love. Thus this arrangement gives five happy
children, the largest number possible.

The first line of input will be of the form "N C", where N is the
number of animal enclosures (10 <= N <= 10,000) and C is the number
of children (1 <= C <= 50,000). The enclosures are numbered 1, 2,
..., N clockwise around the circle.

Following this will be C additional lines of input, where each line
describes a single child.  Each of these lines will be of the form
"E F L X1 X2 ... XF Y1 Y2 ... YL" where:

* E is the first enclosure that the child can see (1 <= E <= N).
  In other words, the child can see enclosures E, E + 1, E + 2, E
  + 3 and E + 4. Note that numbers larger than N wrap back around
  the circle, so if N = 14 and E = 13 then the child can see
  enclosures 13, 14, 1, 2 and 3.

* F is the number of animals that the child fears, and L is the
  number of animals that the child loves.

* Enclosures X1, ..., XF contain the animals that the child fears
  (1 <= X1, ..., XF <= N).

* Enclosures Y1, ..., YL contain the animals that the child loves
  (1 <= Y1, ..., YL <= N).

* No two of the integers X1, ..., XF ; Y1, ..., YL are equal, and
  all of these integers describe enclosures that the child can see.
  Children will be listed in sorted order according to the first
  enclosure E (so the child with lowest E will appear first and the
  child with largest E will appear last). Note that more than one
  child may have the same first enclosure E.

PROBLEM NAME: zoo

INPUT FORMAT:

* Line 1: Two space-separated integers: N and C

* Lines 2..C+1: Line i+1 contains the following information for child
        i: Three space-separated integers: The first enclosure the
        child can see, and the number of enclosures the child fears
        and loves, respectively. After this are the enclosures the
        child fears (space-separated) and then the enclosures the
        child loves (space-separated).

SAMPLE INPUT (file zoo.in):

14 5
2 1 2 4 2 6
3 1 1 6 4
6 1 2 9 6 8
8 1 1 9 12
12 3 0 12 13 2

OUTPUT FORMAT:

* Line 1: A single integer giving the largest number of children that
        can be made happy.

SAMPLE OUTPUT (file zoo.out):

5

OUTPUT DETAILS:

The sample case is the example discussed earlier, in which all C = 5
children can be made happy.
*/
// dp[position][next four cells (used/unused) bitmask]
// do this for each configuration of first 4 cells (in order to count the last children)
// O(M*16*16*2) - BARELY passes TL
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define F(i,n) for (int i=0;i<n;i++)
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))

#define MAXN 10100
#define MAXC 50100
int N,C;
int E[MAXC],F[MAXC],L[MAXC];
int f[MAXC],l[MAXC];
int dp[MAXN][1<<5];
VI kid[MAXN];


VI fear[MAXC],love[MAXC];
int bruteforce()
{
	int ans=0,bmask=0;
	for (int mask=0;mask<(1<<N);mask++)
	 {
			int ret=0;
			Repi(C)
			 {
					//int ftot=0,ltot=0;
					//Repj(fear[i].SZ) if (mask&(1<<fear[i][j])) ftot++;
					//Repj(love[i].SZ) if (mask&(1<<love[i][j])) ltot++;					
					//if (ftot<fear[i].SZ || ltot) ret++;
					int cur=0;
					for (int j=E[i]-1,o=0;j<E[i]+4;j++,o++) cur|= ((mask>>(j%N))&1) <<o;
					ret+=((cur&l[i])>0 || ((~cur)&f[i])>0);
			 }
			if (ret>ans) ans=ret,bmask=mask;
	 }
	cout<<bitset<10>(bmask)<<endl;
	return ans;
}



int addkids(int pos,int mask)
{
	int ret=0;
	Repj(kid[pos].SZ)
	 ret+=( (mask&l[kid[pos][j]])>0 || ((~mask)&f[kid[pos][j]])>0 );
	return ret;
}

int main()
{	
	freopen("zoo.in","r",stdin); freopen("zoo.out","w",stdout);
	scanf("%d%d",&N,&C);
	Repi(C)
	 {
			scanf("%d%d%d",E+i,F+i,L+i);
			int x;
			Repj(F[i])
			   scanf("%d",&x),f[i]|=( 1<<(x+N*(x<E[i])-E[i]) );  //,fear[i].PB(x-1);
			Repj(L[i])
			   scanf("%d",&x),l[i]|=( 1<<(x+N*(x<E[i])-E[i]) );  //,love[i].PB(x-1);
		    kid[E[i]].PB(i);
	 }
	 
	int ans=0;
	for (int init=0;init<(1<<4);init++)
	 {
			memset(dp,-127,sizeof(dp));
			dp[1][init]=0;                          // tuka be6e naprail dp[0][init] i si be6e ebalo mamata ama mnogo tunko...AF+RI !!!!!!!!!!!!!!!!!
			
			for (int i=1;i<N-3;i++)
			 {
			  for (int last=0;last<(1<<4);last++)
			  {
			   if (dp[i][last]<0) continue;
			   for (int next=0;next<2;next++)
			    {
				  int cur=last+(next<<4),add=addkids(i,cur);
				  if (i==N-4)
				   {
						int hah=cur;
						for (int j=i+1,o=0;j<=N;j++,o++)
						 {
								hah>>=1; hah|=((init>>o)&1)<<4;         // a tuka be6e oakal poslednata 4etvorka (be6e edinica)
								add+=addkids(j,hah);
						 }
				   }
			      dp[i+1][cur>>1]=max(dp[i+1][cur>>1],dp[i][last] + add);
			      ans=max(dp[i+1][cur>>1],ans);
				}
			  }
			 }
	 }
	 
	printf("%d\n",ans);
	return 0;
}

