/*
PROG:around
LANG:C++
ID:pascala1

Problem around: Around the world [Dutch Championships, via Jan Kuipers, 2004]

Memory Limit: 18MB due to system change.

Over the years, FJ has made a huge number of farmer friends all
around the world.  Since he hasn't visited 'Farmer Ted' from England
and 'Boer Harms' from Holland for a while, he'd like to visit them.

He knows the longitude of the farm where each of his worldwide
friends resides.  This longitude is an angle (an integer in the
range 0..359) describing the farm's location on the Earth, which
we will consider to be a circle instead of the more complex and
traditional spherical representation. Except for the obvious
discontinuity, longitudes increase when traveling clockwise on this
circle.

FJ plans to travel by airplane to visit his N (1 <= N <= 5,000)
friends (whose farms are uniquely numbered 1..N). He knows the
schedules for M (1 <= M <= 25,000) bidirectional flights connecting
the different farms.  Airplanes always travel shortest paths on the
Earth's surface (i.e., on the shortest arc of a circle).

There will always be a unique shortest path between two farms that
are directly connected.  No pair of antipodal farms (exactly opposite
each other on the circle) is ever directly connected.

Each airplane flight can be described as traveling in clockwise or
counterclockwise direction around the Earth's surface. For example,
a flight from longitude 30 to longitude 35 would be clockwise, as
would be a flight from longitude 350 to longitude 10.  However, a
flight from longitude 350 to longitude 200 follows a shortest path
counterclockwise around the circle.

FJ would find it very cool if he could make a trip around the world,
visiting some of his friends along the way. He'd like to know if
this is possible and if so, what is the minimum number of flights
he can take to do so.

He wants to start and finish his journey at the location of his
best friend (the one listed first in the input below).  In order
to make sure he actually circles the Earth, he wants to ensure that
the clockwise distance he travels is different from the counterclockwise
distance he travels.

PROBLEM NAME: around

INPUT FORMAT:

* Line 1: Two space-separated integers: N  and M

* Lines 2..N+1: Line i+1 contains one integer: the longitude of the
        i-th farm. Line 2 contains the location of the farm of his
        best friend.

* Lines N+2..N+M+1: Line i+N+1 contains two integers giving the
        indices of two farms that are connected by a flight.

SAMPLE INPUT (file around.in):

3 3
0
120
240
1 2
2 3
1 3

INPUT DETAILS:

Farmer John has three friends at longitudes 0, 120, and 240.  There are
three flights: 0<->120, 120<->240, and 0<->240.  The journey must start and
finish at longitude 0.

OUTPUT FORMAT:

* Line 1: A single integer specifying the minimum number of flights FJ
        needs to visit to make a trip around the world. Every time FJ
        moves from one farm to another counts as one flight. If it is
        impossible to make such a trip, output the integer -1.

SAMPLE OUTPUT (file around.out):

3

OUTPUT DETAILS:

FJ must visit all 3 friends to make a full trip around the world.
*/

// hahahaha ebahti cheat-a :)))
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define F(i,n) for (int i=0;i<n;i++)
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))

#define MAXN 5002
#define MOD 227
int N,M;
int a[MAXN];
int lev[MAXN][MOD];
VI adj[MAXN];

PI q[MAXN*MOD]; int st,en,ans=-1;

void advance(int from,int diff,int to)
{
	int cw,ccw;
	int fr=a[from],t=a[to];
//	cout<<"   from "<<from<<" "<<diff<<" (lev "<<lev[from][diff]<<") to "<<to<<" (coordinates "<<fr<<" to "<<t<<")\n";
	if (fr<t)
	 cw=t-fr,ccw=-360+cw;
	else
	 ccw=t-fr,cw=360+ccw;
	int dist=(abs(cw)>abs(ccw))?ccw:cw;
//	cout<<"                 cw "<<cw<<" ccw "<<ccw<<"   dist "<<dist<<endl;
	int ndiff=diff+dist; ndiff%=MOD; ndiff+=MOD*(ndiff<0);
//	cout<<"                               new diff "<<ndiff<<endl;
	if (lev[to][ndiff]>-1) return;
	lev[to][ndiff]=lev[from][diff]+1;
	q[en++]=MP(to,ndiff);
	if (diff && to==1) ans=lev[to][ndiff];
//	cout<<"                                                                                                 OK!\n";
}

int main()
{
	freopen("around.in","r",stdin); freopen("around.out","w",stdout);
	scanf("%d%d",&N,&M);
	Repi(N)
	 {
			scanf("%d",a+i+1);
	 }
	Repj(M)
	 {
			int a,b;
			scanf("%d%d",&a,&b);
			adj[b].PB(a); adj[a].PB(b);
	 }
	 
	q[0]=MP(1,0);
	memset(lev,-1,sizeof(lev));
	lev[1][0]=0;
	for (st=0,en=1;st!=en;st++)
	 {
			int at=q[st].x,diff=q[st].y;
			Repi(adj[at].SZ)
			 {
					advance(at,diff,adj[at][i]);
					if (ans!=-1) goto finish;
			 }
	 }
	finish:;
	printf("%d\n",ans);
	return 0;
}

