/*
PROG:impster
LANG:C++
ID:pascala1

Problem impster: Cow Imposters [Hal Burch, 2002]

Farmer John no longer uses the barbaric custom of branding to mark the cows
that he owns.  Instead, he creates a binary code of B (1 <= B <= 16)
bits for each cow and embosses it onto a metal strip that is fastened
to each cow's ear.

The cows have taken in a stray and wish to create an ID strip for
it. Unknown to FJ, they have created a machine that can make a new
ID strip by combining two existing ID strips using the XOR operation
(ID strips are not consumed by this machine, and the same ID strip
can be used for both inputs).

The cows wish to create a specific ID strip for the stray or at
least get as close to a desired ID as possible -- with the smallest
possible number of bits differing between the goal ID strip and the
best possible new ID strip.

Given a set of E (1 <= E <= 100) existing ID strips, the goal ID
strip, and a large number of blank ID strips to hold intermediate
results, calculate the closest possible ID strip that can be created
from the existing ID strips.

If more than one ID is closest, choose the one that can be created
in the fewest steps. If there is still a tie, choose the `smallest'
ID (i.e., if you sorted all the IDs, the one that is first).

Of course, to get a new strip you'll have to use the machine at
least once.

PROBLEM NAME: impster

INPUT FORMAT:

* Line 1: Two space-separated integers: B and E.

* Line 2: The goal ID string, represented as a string of B 0's and 1's
        (with no spaces).

* Lines 3..E+2: Each line contains an existing ID string, represented
        as a string of B 0's and 1's (with no spaces).

SAMPLE INPUT (file impster.in):

5 3
11100
10000
01000
00100

OUTPUT FORMAT:

* Line 1: A single integer that is the minimum number of steps
        required to create the best possible ID strip.

* Line 2: A single line with the best possible ID strip that can be
        created from the E existing ID strips

SAMPLE OUTPUT (file impster.out):

2
11100
*/
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define F(i,n) for (int i=0;i<n;i++)
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))

#define MAXB (1<<16)
int B,N;
int goal;
int a[128];

int toint(char s[])
{
	int res=0;
	for (int i=0;s[i];i++)
	 res<<=1,res|=s[i]-'0';
	return res;
}

short lev[MAXB];
int q[MAXB],s,e;
int ans,mind=1000000,minlev=1000000;

inline void advance(int nlev,int n)
{
					if (lev[n]>-1) return;
					lev[n]=nlev;
					q[e++]=n;
					int diff=__builtin_popcount(n^goal);
					if (diff==mind)
					 if (minlev==lev[n])
					  { if (n<ans) ans=n; }
					 else { if (minlev>lev[n]) ans=n,minlev=lev[n]; }
					else if (mind>diff) ans=n,minlev=lev[n],mind=diff;
}

int main()
{
	freopen("impster.in","r",stdin); freopen("impster.out","w",stdout);
	scanf("%d%d",&B,&N);
	char id[19];
	scanf("%s",id); goal=toint(id);
	Repi(N)
	 scanf("%s",id),a[i]=toint(id);
	 
	memset(lev,-1,sizeof(lev));
		
	e=0;
	Repi(N)
	 Repj(N)
      advance(1,a[i]^a[j]);
    	
	for (s=0;s<e;s++)
	 {
			int at=q[s];
			Repi(N)
			   advance(lev[q[s]]+1,at^a[i]);
	 }
	
    Repi(B)
     id[B-i-1]=((ans>>i)&1)+'0';
	printf("%d\n%s\n",minlev,id);
	return 0;
}

