/*
PROG:cowfood
LANG:C++
ID:pascala1

Problem cowfood: Corn Fields [Richard Ho, 2006]

Farmer John has purchased a lush new rectangular pasture composed
of M by N (1 <= M <= 12; 1 <= N <= 12) square parcels. He wants to
grow some yummy corn for the cows on a number of squares. Regrettably,
some of the squares are infertile and can't be planted. Canny FJ
knows that the cows dislike eating close to each other, so when
choosing which squares to plant, he avoids choosing squares that
are adjacent; no two chosen squares share an edge. He has not yet
made the final choice as to which squares to plant.

Being a very open-minded man, Farmer John wants to consider all
possible options for how to choose the squares for planting. He is
so open-minded that he considers choosing no squares as a valid
option!  Please help Farmer John determine the number of ways he
can choose the squares to plant.

PROBLEM NAME: cowfood

INPUT FORMAT:

* Line 1: Two space-separated integers: M and N

* Lines 2..M+1: Line i+1 describes row i of the pasture with N
        space-separated integers indicating whether a square is
        fertile (1 for fertile, 0  for infertile)

SAMPLE INPUT (file cowfood.in):

2 3
1 1 1
0 1 0

OUTPUT FORMAT:

* Line 1: One integer: the number of ways that FJ can choose the
        squares modulo 100,000,000.

SAMPLE OUTPUT (file cowfood.out):

9

OUTPUT DETAILS:

Number the squares as follows:

1 2 3
  4

There are four ways to plant only on one squares (1, 2, 3, or 4),
three ways to plant on two squares (13, 14, or 34), 1 way to plant
on three squares (134), and one way to plant on no squares. 4+3+1+1=9.
*/
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define F(i,n) for (int i=0;i<n;i++)
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))

#define MOD 100000000
int N,M;
int a[16][16];
int dp[2][12][1<<12];

int main()
{
	freopen("cowfood.in","r",stdin); freopen("cowfood.out","w",stdout);
	scanf("%d%d",&N,&M);
	Repi(N)
	 Repj(M)
	  scanf("%d",&a[i][j]);
	 
	int at=0;
	dp[0][0][0]=1; 
	int ans=0;
	Repi(N)
	  {
		//   cout<<" row "<<i<<"\n";
		   memset(dp[at^1],0,sizeof(dp[at^1]));
 		   for (int pos=0;pos<M;pos++)
 		    {
			 int npos=pos+1; npos%=M;
			 for (int mask=0;mask<(1<<M);mask++)
			  if (dp[at][pos][mask])
			  {
			//		cout<<"   from "<<at<<" ; "<<pos<<" "<<bitset<3>(mask)<<" = "<<dp[at][pos][mask]<<"\n";
					if (a[i][pos] && !(mask&(1<<pos)) && (!pos || !(mask&(1<<pos-1))))
					 {
					//		cout<<"      to "<<(at^(!npos))<<" ; "<<npos<<" "<<bitset<3>(mask|(1<<pos))<<" (place it)\n";
							int &ret=dp[at^(!npos)][npos][mask|(1<<pos)]; ret+=dp[at][pos][mask]; ret%=MOD;
					 }
			//		cout<<"      to "<<(at^(!npos))<<" ; "<<npos<<" "<<bitset<3>(mask&(~(1<<pos)))<<" (don't place it)\n";
					int &ret=dp[at^(!npos)][npos][mask&(~(1<<pos))]; ret+=dp[at][pos][mask]; ret%=MOD;
			  }
			}
	  	   at^=1;
	  }
	  
	for (int mask=0;mask<(1<<M);mask++)
	 ans+=dp[at][0][mask],ans%=MOD;
	printf("%d\n",ans);
	return 0;
}

