/*
PROG:lazy
LANG:C++
ID:pascala1

Problem lazy: Lazy Cows [Brian Dean, 2004]

Farmer John regrets having applied high-grade fertilizer to his
pastures since the grass now grows so quickly that his cows no
longer need to move around when they graze. As a result, the cows
have grown quite large and lazy... and winter is approaching.

Farmer John wants to build a set of barns to provide shelter for
his immobile cows and believes that he needs to build his barns
around the cows based on their current locations since they won't
walk to a barn, no matter how close or comfortable.

The cows' grazing pasture is represented by a 2 x B (1 <= B <=
15,000,000) array of cells, some of which contain a cow and some
of which are empty.  N (1 <= N <= 1000) cows occupy the cells in
this pasture:

-------------------------------------------------------
|     | cow |     |     |     | cow | cow | cow | cow |
-------------------------------------------------------
|     | cow | cow | cow |     |     |     |     |     |
-------------------------------------------------------

Ever the frugal agrarian, Farmer John would like to build a set of
just K (1 <= K <= N) rectangular barns (oriented with walls parallel
to the pasture's edges) whose total area covers the minimum possible
number of cells.  Each barn covers a rectangular group of cells in
their entirety, and no two barns may overlap.  Of course, the barns
must cover all of the cells containing cows.

By way of example, in the picture above if K=2 then the optimal
solution contains a 2x3 barn and a 1x4 barn and covers a total of
10 units of area.

PROBLEM NAME: lazy

INPUT FORMAT:

* Line 1: Three space-separated integers, N, K, and B.

* Lines 2..N+1: Two space-separated integers in the range (1,1) to
        (2,B) giving the  coordinates of the cell containing each cow.
         No cell contains more than one cow.

SAMPLE INPUT (file lazy.in):

8 2 9
1 2
1 6
1 7
1 8
1 9
2 2
2 3
2 4

INPUT DETAILS:

As pictured above.

OUTPUT FORMAT:

* Line 1: The minimum area required by the K barns in order to cover
        all of the cows.

SAMPLE OUTPUT (file lazy.out):

10

OUTPUT DETAILS:

As discussed above.
*/
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define F(i,n) for (int i=0;i<n;i++)
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))

#define INF 1000000000
map<int,int> row;
int N,B,K;
int dp[2][1024][5],at;
// pos,k,mask
// mask = 0 -     1 - '    2 - .    3 - :   4 - |

int main()
{
	freopen("lazy.in","r",stdin); freopen("lazy.out","w",stdout);
	scanf("%d%d%d",&N,&K,&B);
	Repi(N)
	 {
			int a,b;
			scanf("%d%d",&a,&b);
			row[b]|=a;
	 }
	 
	at=0;
	memset(dp,127,sizeof(dp));
	dp[0][0][0]=0;
	int last;
	for (map<int,int>::iterator it=row.begin();it!=row.end();it++)
	 {
	  memset(dp[at^1],127,sizeof(dp[at^1]));
	  int dist=it->x-last;
	  for  (int k=0;k<=K;k++)
	   {
	  		//cout<<" at "<<it->x<<" : "<<it->y<<" ; "<<k<<"\n";
	  	//	cout<<"    === "<<dp[at][k][0]<<" "<<dp[at][k][1]<<" "<<dp[at][k][2]<<" "<<dp[at][k][3]<<" "<<dp[at][k][4]<<"\n";
			if (dp[at][k][0]<INF)
			 {
					int val=dp[at][k][0];
					if (it->y==1)
							dp[at^1][k+1][1]<?=val+1;
					if (it->y==2)
							dp[at^1][k+1][2]<?=val+1;
					dp[at^1][k+2][3]<?=val+2;
					dp[at^1][k+1][4]<?=val+2;
			 }
			
			if (dp[at][k][1]<INF)
			 {
					int val=dp[at][k][1];
					if (it->y==1)
					 dp[at^1][k+1][1]<?=val+1,
					 dp[at^1][k][1]<?=val+dist;
					if (it->y==2)
					 dp[at^1][k+1][2]<?=val+1;
					dp[at^1][k+1][3]<?=val+dist+1;
					dp[at^1][k+2][3]<?=val+2;
					dp[at^1][k+1][4]<?=val+2;
			 }
			 
			if (dp[at][k][2]<INF)
			 {
					int val=dp[at][k][2];
					if (it->y==1)
					 dp[at^1][k+1][1]<?=val+1;
					if (it->y==2)
					 dp[at^1][k+1][2]<?=val+1,
					 dp[at^1][k][2]<?=val+dist;
					dp[at^1][k+1][3]<?=val+dist+1;
					dp[at^1][k+2][3]<?=val+2;
					dp[at^1][k+1][4]<?=val+2;
			 }
			
			if (dp[at][k][3]<INF)
			 {
					int val=dp[at][k][3];
					if (it->y==1)
					 dp[at^1][k][1]<?=val+dist,
					 dp[at^1][k+1][1]<?=val+1;
					if (it->y==2)
					 dp[at^1][k][2]<?=val+dist,
					 dp[at^1][k+1][2]<?=val+1;
					dp[at^1][k][3]<?=val+2*dist;
					dp[at^1][k+1][3]<?=val+dist+1;
					dp[at^1][k+2][3]<?=val+2;
					dp[at^1][k+1][4]<?=val+2;
			 }
			
			if (dp[at][k][4])
			 {
					int val=dp[at][k][4];
					if (it->y==1)
					 dp[at^1][k+1][1]<?=val+1;
					if (it->y==2)
					 dp[at^1][k+1][2]<?=val+1;
					dp[at^1][k+2][3]<?=val+2;
					dp[at^1][k][4]<?=val+2*dist;
					dp[at^1][k+1][4]<?=val+2;
			 }
	   }
	  at^=1;
	  last=it->x;
     }
    
    int ans=dp[at][K][1];
    ans<?=dp[at][K][2];
    ans<?=dp[at][K][3];
    ans<?=dp[at][K][4];
    printf("%d\n",ans);
	return 0;
}

