/*
PROG:peaks
LANG:C++
ID:pascala1

Problem peaks: Landscaping [Brian Dean, 2005]

Farmer John is making the difficult transition from raising mountain
goats to raising cows.  His farm, while ideal for mountain goats,
is far too mountainous for cattle and thus needs to be flattened
out a bit. Since flattening is an expensive operation, he wants to
remove the smallest amount of earth possible.

The farm is long and narrow and is described in a sort of two-dimensional
profile by a single array of N (1 <= N <= 1000) integer elevations
(range 1..1,000,000) like this:

1 2 3 3 3 2 1 3 2 2 1 2,

which represents the farm's elevations in profile, depicted below
with asterisks indicating the heights:

    * * *     *
  * * * * *   * * *   *
* * * * * * * * * * * *
1 2 3 3 3 2 1 3 2 2 1 2

A contiguous range of one or more equal elevations in this array
is a "peak" if both the left and right hand sides of the range are
either the boundary of the array or an element that is lower in
elevation than the peak. The example above has three peaks.

Determine the minimum volume of earth (each unit elevation reduction
counts as one unit of volume) that must be removed so that the
resulting landscape has no more than K (1 <= K <= 25) peaks.  Note
well that elevations can be reduced but can never be increased.

If the example above is to be reduced to 1 peak, the optimal solution
is to remove 2 + 1 + 1 + 1 = 5 units of earth to obtain this set
of elevations:

    * * *     -
  * * * * *   - - -   -
* * * * * * * * * * * *
1 2 3 3 3 2 1 1 1 1 1 1

where '-'s indicate removed earth.

PROBLEM NAME: peaks

INPUT FORMAT:

* Line 1: Two space-separated integers: N and K

* Lines 2..N+1: Each line contains a single integer elevation. Line
        i+1 contains the elevation for index i.

SAMPLE INPUT (file peaks.in):

12 1
1
2
3
3
3
2
1
3
2
2
1
2

INPUT DETAILS:

This is the example used above.

OUTPUT FORMAT:

* Line 1: The minimum volume of earth that must be removed to reduce
        the number of peaks to K.

SAMPLE OUTPUT (file peaks.out):

5
*/
// tree rebuilding (adding dummy nodes) - see rivers, ioi 2005
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define F(i,n) for (int i=0;i<n;i++)
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))

#define MAXN 1024
int N,K;
int h[MAXN],a[MAXN];

bool cmp(int x,int y)
{	return h[x]==h[y]?x<y:h[x]>h[y]; }

int id[MAXN*2],cnt,par[MAXN*2],cost[MAXN*2]; VI chi[MAXN*2];

void dosomeshit(int at,int j)
{
					if (h[j]>h[at])
					 cost[id[j]]+=h[j]-h[at],h[j]=h[at],par[id[j]]=cnt;//cout<<"                      par "<<id[j]<<" = "<<cnt<<"  ;  cost "<<id[j]<<" = "<<cost[id[j]]<<"\n";
					id[j]=cnt;
}

void rebuild(int at)
{
	if (chi[at].SZ>2)
	 {
			int child=chi[at][chi[at].SZ-1];
			par[cnt]=at;
			chi[cnt]=chi[at];
			chi[cnt].pop_back();
			chi[at].resize(2); chi[at][0]=child; chi[at][1]=cnt;
			cnt++;
	 }	
	
	Repi(chi[at].SZ)
	 rebuild(chi[at][i]);
}

int dp[MAXN][32];
void solve(int at)
{
	Repi(chi[at].SZ) solve(chi[at][i]);
	
	if (!chi[at].SZ) { dp[at][0]=cost[at]; goto end;}
	if (chi[at].SZ==1) { memcpy(dp[at],dp[chi[at][0]],(K+1)*sizeof(int)); dp[at][0]+=cost[at]; goto end;  }
	
	memset(dp[at],127,sizeof(dp[at]));
	for (int i=0;i<=K;i++)
	 for (int j=0;i+j<=K;j++)
	  dp[at][i+j]<?=dp[chi[at][0]][i]+dp[chi[at][1]][j];
	dp[at][0]+=cost[at];
	
	end:;
}

int main()
{
	freopen("peaks.in","r",stdin); freopen("peaks.out","w",stdout);
	scanf("%d%d",&N,&K);
	Repi(N) scanf("%d",h+i+1),a[i+1]=i+1;
	a[0]=0,h[0]=0,a[N+1]=N+1,h[N+1]=0; N+=2;
	sort(a,a+N,cmp);
	
	//build tree
	memset(id,-1,sizeof(id));
	memset(par,-1,sizeof(par));
	Repi(N)
	 {
	  int at=a[i];
	  if (id[at]==-1)
	   {
			for (int j=at;j<N && h[j]>=h[at];j++)
			 dosomeshit(at,j);
			for (int j=at-1;j>=0 && h[j]>=h[at];j--)
			 dosomeshit(at,j);
			cnt++;
	   }
	 }
	Repi(cnt)if (par[i]>-1) chi[par[i]].PB(i);
	int bottom=cnt-1;
	
	//rebuild tree
	rebuild(bottom);
	
	//solve
	solve(bottom);
	printf("%d\n",dp[bottom][K]);
	
	return 0;
}

