/*
PROG:tower
LANG:C++
ID:pascala1

Problem tower: Cell Phone Network [Jeffrey Wang, 2007]

Farmer John has decided to give each of his cows a cell phone in
hopes to encourage their social interaction. This, however, requires
him to set up cell phone towers on his N (1 <= N <= 10,000) pastures
(conveniently numbered 1..N) so they can all communicate.

Exactly N-1 pairs of pastures are adjacent, and for any two pastures
A and B (1 <= A <= N; 1 <= B <= N; A != B) there is a sequence of
adjacent pastures such that A is the first pasture in the sequence
and B is the last. Farmer John can only place cell phone towers in
the pastures, and each tower has enough range to provide service
to the pasture it is on and all pastures adjacent to the pasture
with the cell tower.

Help him determine the minimum number of towers he must install to
provide cell phone service to each pasture.

PROBLEM NAME: tower

INPUT FORMAT:

* Line 1: A single integer: N

* Lines 2..N: Each line specifies a pair of adjacent pastures with two
        space-separated integers: A and B

SAMPLE INPUT (file tower.in):

5
1 3
5 2
4 3
3 5

INPUT DETAILS:

Farmer John has 5 pastures: pastures 1 and 3 are adjacent, as are pastures
5 and 2, pastures 4 and 3, and pastures 3 and 5. Geometrically, the
farm looks like this (or some similar configuration)
               4  2
               |  |
            1--3--5

OUTPUT FORMAT:

* Line 1: A single integer indicating the minimum number of towers to
        install

SAMPLE OUTPUT (file tower.out):

2

OUTPUT DETAILS:

The towers can be placed at pastures 2 and 3 or pastures 3 and 5.
*/
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define F(i,n) for (int i=0;i<n;i++)
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))

#define MAXN 10010
#define INF 1000000
VI adj[MAXN];
VI chi[MAXN];
int N;
int par[MAXN];

bool used[MAXN];
void hang(int root)
{
	used[root]=1;
	Repi(adj[root].SZ)
	 if (!used[adj[root][i]])
	  {
			chi[root].PB(adj[root][i]);
			par[adj[root][i]]=root;
			hang(adj[root][i]);
	  }
}


int dp[MAXN][4];
// 0 - taken, 1 - covered by child, 2 - uncovered
void solve(int v,int lev)
{
	memset(dp[v],63,sizeof(dp[v]));
	if (!chi[v].SZ) { dp[v][0]=1; dp[v][2]=0; return; }
	
	int d[2][4]; d[0][0]=1; d[0][1]=INF; d[0][2]=0;
	int at=0;
	Repi(chi[v].SZ)
	 {
			int c=chi[v][i];
			solve(c,lev+1);
			memset(d[at^1],63,sizeof(d[at^1]));
			
			d[at^1][0]<?=d[at][0]+dp[c][0];
			d[at^1][0]<?=d[at][0]+dp[c][1];
			d[at^1][0]<?=d[at][0]+dp[c][2];
			
			d[at^1][0]<?=d[at][1]+dp[c][0]+1;
			d[at^1][1]<?=d[at][1]+dp[c][0];
			d[at^1][0]<?=d[at][1]+dp[c][1]+1;
			d[at^1][1]<?=d[at][1]+dp[c][1];
			d[at^1][0]<?=d[at][1]+dp[c][2]+1;
			
			d[at^1][0]<?=d[at][2]+dp[c][0]+1;
			d[at^1][1]<?=d[at][2]+dp[c][0];
			d[at^1][0]<?=d[at][2]+dp[c][1]+1;
			d[at^1][2]<?=d[at][2]+dp[c][1];
			d[at^1][0]<?=d[at][2]+dp[c][2]+1;
			
		//	Repk(lev) cout<<"    "; cout<<" adding child "<<c<<" for "<<v<<" : "<<d[at][0]<<" "<<d[at][1]<<" "<<d[at][2]<<" to "<<d[at^1][0]<<" "<<d[at^1][1]<<" "<<d[at^1][2]<<"\n";
			at^=1;
	 }
	memcpy(dp[v],d[at],sizeof(dp[v]));
}


int main()
{
	freopen("tower.in","r",stdin); freopen("tower.out","w",stdout);
	scanf("%d",&N);
	int a,b;
	Repi(N-1)
	 scanf("%d%d",&a,&b),adj[a].PB(b),adj[b].PB(a);
	
	hang(1);
//	Repi(N)
//	 { cout<<i+1<<" -> ";  Repj(chi[i+1].SZ) cout<<chi[i+1][j]<<" "; cout<<endl; }
//	cout<<endl;
	
	solve(1,0);
	printf("%d\n",min(dp[1][0],dp[1][1]));
	
	return 0;
}

