/*
PROG:tselect
LANG:C++
ID:pascala1

Problem tselect: Milk Team Select [Percy Liang, 2002]

Farmer John's N (1 <= N <= 500) cows are trying to select the
milking team for the world-famous Multistate Milking Match-up (MMM)
competition. As you probably know, any team that produces at least
X (1 <= X <= 1,000,000) gallons of milk is a winner.

Each cow has the potential of contributing between -10,000 and
10,000 gallons of milk. (Sadly, some cows have a tendency to knock
over jugs containing milk produced by other cows.)

The MMM prides itself on promoting family values. FJ's cows have
no doubt that they can produce X gallons of milk and win the contest,
but to support the contest's spirit, they want to send a team with
as many parent-child relationships as possible (while still producing
at least X gallons of milk). Not surprisingly, all the cows on FJ's
farm are female.

Given the family tree of FJ's cows and the amount of milk that each
would contribute, compute the maximum number of parent-child
relationships that can exist in a winning team. Note that a set of
cows with a grandmother-mother-daughter combination has two
parent-child relationships (grandmother-mother, mother-daughter).

PROBLEM NAME: tselect

INPUT FORMAT:

* Line 1: Two space-separated integers, N and X.

* Lines 2..N+1: Line i+1 contains two space-separated integers
        describing cow i. The first integer is the number of gallons
        of milk cow i would contribute. The second integer (range
        1..N) is the index of the cow's mother. If the cow's mother is
        unknown, the second number is 0. The family information has no
        cycles: no cow is her own mother, grandmother, etc.

SAMPLE INPUT (file tselect.in):

5 8
-1 0
3 1
5 1
-3 3
2 0

INPUT DETAILS:

There are 5 cows. Cow 1 can produce -1 gallons and has two daughters, cow
2 and 3, who can produce 3 and 5 gallons, respectively. Cow 3 has a
daughter (cow 4) who can produce -3 gallons. Then there's cow 5, who can
produce 2 gallons.

OUTPUT FORMAT:

* Line 1: The maximum number of parent-child relationships possible on
        a winning team. Print -1 if no team can win.

SAMPLE OUTPUT (file tselect.out):

2

OUTPUT DETAILS:

The best team consists of cows 1, 2, 3, and 5. Together they produce
(-1)+3+5+2 = 9 >= 8 gallons and have 2 parent-child relationships
(1--2 and 1--3). Note that a team with cows 2, 3, and 5 would be
able to produce more milk (10 gallons), but would have fewer
parent-child relationships (0).
*/
// dp[node][used/unused][par-child-relationships] - max gallons from subtree
// note: advance only from used states
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define F(i,n) for (int i=0;i<n;i++)
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))

#define MAXN 512
int N,X;
VI chi[MAXN];
int par[MAXN],add[MAXN];
int dp[MAXN][2][MAXN];
int sz[MAXN][2];

void solve(int v)
{
	Repi(chi[v].SZ)
	 solve(chi[v][i]);
	 
//	cout<<" in "<<v<<endl;
	int d[2][2][MAXN],n[2][2]; memset(d,-127,sizeof(d));  d[0][0][0]=0; d[0][1][0]=add[v]; n[0][0]=n[0][1]=1; n[1][0]=n[1][1]=0;
	int at=0;
	Repi(chi[v].SZ)
	 {
			memset(d[at^1][0],-127,sizeof(int)*n[at^1][0]); n[at^1][0]=0;
			memset(d[at^1][1],-127,sizeof(int)*n[at^1][1]); n[at^1][1]=0;
			int c=chi[v][i];
//			cout<<"     from "<<c<<endl;
			Repj(sz[c][1])
			 {
					Repk(n[at][1])
					 {
							d[at^1][0][j+k]>?=d[at][0][k]+max(dp[c][1][j],dp[c][0][j]); // invalid dp[c][0][j]'s are memset -127 ... i hope...
 							d[at^1][1][j+k]>?=d[at][1][k]+dp[c][0][j];
							n[at^1][0]>?=j+k+1;
					 }
					Repk(n[at][1])
					 {
 							d[at^1][1][j+k+1]>?=d[at][1][k]+dp[c][1][j];
							n[at^1][1]>?=j+k+2;
					 }

			 }
			at^=1;			
//			cout<<"                  new dp 0 : ";			Repj(n[at][0]) cout<<d[at][0][j]<<" "; cout<<endl;			cout<<"                  new dp 1 : ";			Repj(n[at][1]) cout<<d[at][1][j]<<" "; cout<<endl;
	 }
	memcpy(dp[v],d[at],sizeof(d[at]));
	sz[v][0]=n[at][0],sz[v][1]=n[at][1];
//	cout<<"   final dp 0 : ";	Repj(n[at][0]) cout<<dp[v][0][j]<<" "; cout<<endl;	cout<<"   final dp 1 : ";	Repj(n[at][1]) cout<<dp[v][1][j]<<" "; cout<<endl;
}

int main()
{
	freopen("tselect.in","r",stdin); freopen("tselect.out","w",stdout);
	scanf("%d%d",&N,&X);
	Repi(N)
	 { 
  	   scanf("%d%d",add+i+1,par+i+1);
  	   chi[par[i+1]].PB(i+1);
	 }
	 
	memset(dp,-127,sizeof(dp));
	solve(0);
	int ans=-1;
	Repi(sz[0][0])
	 if (dp[0][0][i]>=X) ans=i;
	printf("%d\n",ans);
	
	return 0;
}

