/*
ID: pascala1
PROG: fc
LANG: C++
*/
//line sweep convex hull
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

int n,m,N,M,P,T,K;
#define MAXN 10100
PD p[MAXN];

inline double cp(PD &A,PD &B,PD &C)
{
	double dx1=B.x-A.x;
	double dy1=B.y-A.y;
	double dx2=C.x-A.x;
	double dy2=C.y-A.y;
	return dx1*dy2-dx2*dy1;
}
double dist1(PD &A,PD &B)
{ return sqr(A.x-B.x)+sqr(A.y-B.y); }



int sweephull(PD p[],int N)
{
	sort(p,p+N); int n=2;
	for (int i=2;i<N;i++)
	 {  while (n>1 && cp(p[n-2],p[n-1],p[i])>0) n--;
	    swap(p[i],p[n++]);	 }
    sort(p+n,p+N,greater<PD>());
    int m=n++; p[N]=p[0];
    for (int i=n;i<=N;i++)
     {
		while (n>m && cp(p[n-2],p[n-1],p[i])>0) n--;
	    swap(p[i],p[n++]);	 }
   return n;
}

int main()
{
	FILE *f=fopen("fc.in","r");
    fscanf(f,"%d",&N);
    Repi(N)
     fscanf(f,"%lf%lf",&p[i].x,&p[i].y);
    fclose(f);
    
    m=sweephull(p,N);
    
    double ans=0;
    Repi(m-1)
     ans+=sqrt(dist1(p[i],p[i+1]));
    ofstream of("fc.out");
    of<<setprecision(2)<<fixed<<ans<<endl;
    of.close();
    
    return 0;
}
