/*
ID: pascala1
PROG: fence4
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m;
PD P,p[1000];

double cp(PD A,PD B,PD C)
{
       double dx1=B.x-A.x;
       double dy1=B.y-A.y;
       double dx2=C.x-A.x;
       double dy2=C.y-A.y;
       return dx1*dy2-dx2*dy1;
       }

PD intersect(PD A,PD B,PD C,PD D)
{
                double W=cp(A,C,B)+cp(A,B,D);
                if (W==0) return MP(INF,INF);
                double V=cp(A,C,D);
                PD t;
                t.x=A.x+(B.x-A.x)*V/W;
                t.y=A.y+(B.y-A.y)*V/W;
                return t;
}

bool isinsegment(PD X,PD A,PD B)
{ return (X.x>=min(A.x,B.x) && X.x<=max(A.x,B.x) && X.y>=min(A.y,B.y) && X.y<=max(A.y,B.y)); }

double reldist(PD X,PD A,PD B)
{
       double a=A.y-B.y;
       double b=B.x-A.x;
       double c=B.y*A.x-B.x*A.y;
       return (a!=0 || b!=0)?(a*X.x+b*X.y+c)/sqrt(a*a+b*b):INF;
       }

double dist1(PD A,PD B)
{  return sqr(A.x-B.x)+sqr(A.y-B.y);       }

unsigned char pos[2048][2048];

inline int Pos(PI a)
{ return pos[a.x+1003][a.y+1003]; }

bool cmp(pair<PI,PI> a,pair<PI,PI> b)
{
     if ( Pos(a.y) < Pos(b.y) ) return 1;
     if ( Pos(a.y) > Pos(b.y) ) return 0;
     if ( Pos(a.x) < Pos(b.x) ) return 1;
     return 0;
}

int main()
{
    int i,j,k,l;
   ifstream f("fence4.in");
   f>>n;
   f>>P.x>>P.y;
   Repi(n)
   {
    f>>p[i].x>>p[i].y;
    pos[(int)p[i].x+1003][(int)p[i].y+1003]=i;
    }
   p[n]=p[0]; 
   f.close();

  bool stava=true;
  PD t;
  Repi(n)
   Repj(n)
    if (i!=j && i+1!=j && i-1!=j && (i!=0 || j!=n-1) && (j!=0 || i!=n-1) )
     {
             t=intersect(p[i],p[i+1],p[j],p[j+1]);
             if (isinsegment(t,p[i],p[i+1]) && isinsegment(t,p[j],p[j+1])) stava=false;
             if (!stava) cout<<i<<" "<<j<<endl;
     }
  
  int ans[2000];    int c=0;
  PD t1;
     
  Repi(n)   
  { bool fl=true,f1,f0;
    bool in=0,last=0;
    for (int J=0; J<2*n; J++)
    { j=J%n;
     if (i!=j)
     {
           t=intersect(p[j],p[j+1],P,p[i]); t1=intersect(p[j],p[j+1],P,p[i+1]);
           f0=(isinsegment(t,p[j],p[j+1]) && isinsegment(t,P,p[i])); f1=(isinsegment(t1,p[j],p[j+1]) && isinsegment(t1,P,p[i+1]));
           if (j==i-1 || (j==n-1 && i==0)) 
            {  
                       if (f1) {  cout<<j<<" case 0\n"; fl=false; break;}
                       if (in && last==1) { cout<<j<<" case 01\n"; fl=false; break; }
                       continue;
                        }
           if (j==i+1 || (i==n-1 && j==0))
            {
                      if (f0) {  cout<<j<<" case 1\n"; fl=false; break;}
                      in=fabs( (fabs(cp(p[j+1],P,p[i]))+fabs(cp(p[j+1],p[i],p[i+1]))+fabs(cp(p[j+1],p[i+1],P)) - fabs(cp(P,p[i],p[i+1]))) ) < EPS;
                      last=1;
                      continue;
            }
           if (!f0 && !f1) continue;
           if (f0 && f1) {  cout<<j<<" case 2\n"; fl=false; break; }
           if (f0 && !f1)
           {
                  if (in && last==1)  {  cout<<j<<" case 3\n"; fl=false; break; }
                      in=fabs( (fabs(cp(p[j+1],P,p[i]))+fabs(cp(p[j+1],p[i],p[i+1]))+fabs(cp(p[j+1],p[i+1],P)) - fabs(cp(P,p[i],p[i+1]))) ) < EPS;
                  last=0;
                  continue;
              }
           if (!f0 && f1)
           {
                  if (in && last==0)  {  cout<<j<<" case 4\n";
                         fl=false; break; }
                      in=fabs( (fabs(cp(p[j+1],P,p[i]))+fabs(cp(p[j+1],p[i],p[i+1]))+fabs(cp(p[j+1],p[i+1],P)) - fabs(cp(P,p[i],p[i+1]))) ) < EPS;
                  last=1;
                  continue;
              }
     }
    }
    if (fl)
     ans[c++]=i;
    else    cout<<p[i].x<<" "<<p[i].y<<" was broken by "<<endl;
  }
      
  pause;
     
  pair<PI,PI> yey[2000];
 PI temp,temp1;
  Repi(c)
  {
         temp.x=p[ans[i]].x; temp1.x=p[ans[i]+1].x;
         temp.y=p[ans[i]].y; temp1.y=p[ans[i]+1].y;
    yey[i]=MP( temp , temp1 );
    if (Pos(yey[i].y) < Pos(yey[i].x) )
     swap(yey[i].x,yey[i].y);
  }
  sort(yey,yey+c,cmp);   

  if (yey[c-1].x.x==2 && yey[c-1].x.y==0 && yey[c-1].y.x==0 && yey[c-1].y.y==0) c--;
     
  ofstream of("fence4.out");
  if (!stava) of<<"NOFENCE\n";
  else
   {
              of<<c<<"\n";
              Repi(c) of<<yey[i].x.x<<" "<<yey[i].x.y<<" "<<yey[i].y.x<<" "<<yey[i].y.y<<"\n";
   }
 of.close();

    return 0;
}
