/*
ID: pascala1
PROG: fence4
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m;
PD P,p[1000];

double cp(PD A,PD B,PD C)
{
       double dx1=B.x-A.x;
       double dy1=B.y-A.y;
       double dx2=C.x-A.x;
       double dy2=C.y-A.y;
       return dx1*dy2-dx2*dy1;
       }

PD intersect(PD A,PD B,PD C,PD D)
{
                double W=cp(A,C,B)+cp(A,B,D);
                if (W==0) return MP(INF,INF);
                double V=cp(A,C,D);
                PD t;
                t.x=A.x+(B.x-A.x)*V/W;
                t.y=A.y+(B.y-A.y)*V/W;
                return t;
}

bool isinsegment(PD X,PD A,PD B)
{ return (X.x>=min(A.x,B.x) && X.x<=max(A.x,B.x) && X.y>=min(A.y,B.y) && X.y<=max(A.y,B.y)); }

double reldist(PD X,PD A,PD B)
{
       double a=A.y-B.y;
       double b=B.x-A.x;
       double c=B.y*A.x-B.x*A.y;
       return (a!=0 || b!=0)?(a*X.x+b*X.y+c)/sqrt(a*a+b*b):INF;
       }

double dist1(PD A,PD B)
{  return sqr(A.x-B.x)+sqr(A.y-B.y);       }

unsigned char pos[2048][2048];

inline int Pos(PI a)
{ return pos[a.x+1003][a.y+1003]; }

bool cmp(pair<PI,PI> a,pair<PI,PI> b)
{
     if ( Pos(a.y) < Pos(b.y) ) return 1;
     if ( Pos(a.y) > Pos(b.y) ) return 0;
     if ( Pos(a.x) < Pos(b.x) ) return 1;
     return 0;
}

int main()
{
    int i,j,k,l;
   ifstream f("fence4.in");
   f>>n;
   f>>P.x>>P.y;
   Repi(n)
   {
    f>>p[i].x>>p[i].y;
    pos[(int)p[i].x+1003][(int)p[i].y+1003]=i;
    }
   p[n]=p[0]; 
   f.close();

  bool stava=true;
  PD t;
  Repi(n)
   Repj(n)
    if (i!=j && i+1!=j && i-1!=j && (i!=0 || j!=n-1) && (j!=0 || i!=n-1) )
     {
             t=intersect(p[i],p[i+1],p[j],p[j+1]);
             if (isinsegment(t,p[i],p[i+1]) && isinsegment(t,p[j],p[j+1])) stava=false;
             if (!stava) cout<<i<<" "<<j<<endl;
     }
  
  int ans[2000];    int c=0;
  PD t1;
     
  Repi(n)   
  { bool fl=true;
    Repj(n)
     if (i!=j)
      {
              t=intersect(P,p[i],p[j],p[j+1]); t1=intersect(P,p[i+1],p[j],p[j+1]);
            //  cout<<"   "<<i<<" "<<j<<" - "<<isinsegment(t,p[j],p[j+1])<<" "<<isinsegment(t1,p[j],p[j+1])<<"  "<<
            //  dist1(P,p[i])<<">"<<dist1(P,t)<<"  "<<dist1(t,p[i])<<"<="<<dist1(P,p[i])<<"  "<<
            //  dist1(P,p[i+1])<<">"<<dist1(P,t1)<<"  "<<dist1(t1,p[i+1])<<"<="<<dist1(P,p[i+1])<<
            //  endl;
              if ( isinsegment(t,p[j],p[j+1])  &&  isinsegment(t1,p[j],p[j+1]) &&
                   dist1(P,p[i]) >= dist1(P,t) && dist1(t,p[i])<=dist1(P,p[i]) && 
                   dist1(P,p[i+1]) >= dist1(P,t1) && dist1(t1,p[i+1])<=dist1(P,p[i+1])
              ) {
                //  cout<<i<<" broken by "<<j<<endl;
                  fl=false; break; }
      }
      
    if (fl)
     ans[c++]=i;
  }   
  //pause;
     
  pair<PI,PI> yey[2000];
 PI temp,temp1;
  Repi(c)
  {
         temp.x=p[ans[i]].x; temp1.x=p[ans[i]+1].x;
         temp.y=p[ans[i]].y; temp1.y=p[ans[i]+1].y;
    yey[i]=MP( temp , temp1 );
    if (Pos(yey[i].y) < Pos(yey[i].x) )
     swap(yey[i].x,yey[i].y);
  }
  sort(yey,yey+c,cmp);   
     
  ofstream of("fence4.out");
  if (!stava) of<<"NOFENCE\n";
  else
   {
              of<<c<<"\n";
              Repi(c) of<<yey[i].x.x<<" "<<yey[i].x.y<<" "<<yey[i].y.x<<" "<<yey[i].y.y<<"\n";
   }
 of.close();

    return 0;
}
