/*
ID: pascala1
PROG: rectbarn
LANG: C++
*/
//same as finding the largest rectangle 'cut' in the silhouette of a sequence of rectangles aligned at the bottom and 'clung' to one another:
//1. calculate maximal height for each column at each row
//2. at each row use a stack keeping rectangles (in this case - columns) in non-decreasing height ; when adding a new one, for each popped higher column
//   find the area of the largest rectangle that can be placed with its bottom at the current row and has height = the height of the column (it's top overlaps the top of the column) in O(1) time
//   since it's restricted by the newly added column (to the right) and by the column prior to it in the stack (to the left) - they are the first lower columns to the right and to the left, resp.
//3. the answer is the maximum of all these values - overall complexity O(N^2)
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

int n,m,N,M,P,T,K;

#define MAXN 3010
bool area[MAXN][MAXN];
int height[MAXN];

int stackh[MAXN],stackp[MAXN],sc;
inline int solve(int h[])
{
	sc=0;
	int ret=0,tmp;
	h[M]=0;
	Repi(M+1)
	 {
			while (sc && stackh[sc-1]>h[i])
			 {
					tmp=stackh[sc-1]*(i-(sc>1)*(stackp[sc-2]+1));
					ret=max(ret,tmp);
					sc--;
			 }
			stackh[sc]=h[i],stackp[sc++]=i; //regard newly inserted ones as higher than their equals in the stack - they are used only as a restriction to higher blocks in the future
	 }
	return ret;
}

int main()
{
    freopen("rectbarn.in","r",stdin);
    freopen("rectbarn.out","w",stdout);
    
    int x,y;
    scanf("%d%d%d",&N,&M,&T);
    Repi(T)
     {
			scanf("%d %d",&x,&y); x--; y--;
			area[x][y]=1;
	 }
	
    int ans=0;
    Repi(N)
     {
	   Repj(M)
	    height[j]=(area[i][j])?0:height[j]+1;
       ans=max(ans,solve(height));
	 }
	
	printf("%d\n",ans);

    return 0;
}
