/*
ID: pascala1
PROG: stall4
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m; int M[512][410];
int source=0,sink,maxU=1;
VI a[512];

inline void edge(int A,int B,int C)
{
    //   cout<<A<<" -> "<<B<<"  =  "<<C<<endl;
       M[A][B]=C;
       a[A].PB(B);
       a[B].PB(A);
}

int Flow1()
{
    int q[512],v,p[512],delta=maxU,j,k; bool u[512],found;
    int flow=0;
    
    while(1)
    {
            memset(u,0,sizeof(u));
            q[0]=source; p[source]=-1;
            u[source]=true; found=false;
            for (int s=0,e=1; s<e; s++)
            {
                v=q[s];
                Repi(a[v].SZ)
                 if (!u[a[v][i]] && M[v][a[v][i]]>=delta)
                 {
                             q[e++]=a[v][i];
                             u[a[v][i]]=true;
                             p[a[v][i]]=v;
                             if (a[v][i]==sink) {found=true; break;}
                 }
                if (found)  break;
            }
            
            if (!found) 
             { if (delta==1) return flow; delta/=2; continue; }
             
            j=sink; k=0;
            while (j!=-1) 
             { q[k++]=j; j=p[j]; }
            reverse(q,q+k); 
             
            j=INF;
            Repi(k-1)
             j=min(j,M[q[i]][q[i+1]]);
            
            Repi(k-1)
            {
                   M[q[i]][q[i+1]]-=j;
                   M[q[i+1]][q[i]]+=j;
            }
            
            flow+=j;
           // cout<<"flow "<<flow<<endl;
    }
}

int Flow()
{
     int p[512],q[510],d[510],j,k,v; bool u[510];
     int flow=0;
     
     memset(u,0,sizeof(u));
     memset(d,127,sizeof(d));
     q[0]=sink; u[sink]=true;
     d[sink]=0;
     for (int s=0,e=1; s<e; s++)
     {
         Repi(a[q[s]].SZ)
         {
          v=a[q[s]][i];
          if (M[q[s]][v]==0 && !u[v])
           {
                         u[v]=true;
                         q[e++]=v;
                         d[v]=d[q[s]]+1;
           }
         }
     }
     
     v=source; p[source]=-1;
     while(d[source]<=n)
     {
         //  Repi(n)   cout<<d[i+1]<<" "; cout<<endl;
          // pause;
           if (v==sink)
           {
                       k=sink; j=0;
                       while (k!=-1) { q[j++]=k; k=p[k]; }
                       reverse(q,q+j);
                       k=INF;
                       Repi(j-1) k=min(M[q[i]][q[i+1]],k);
                    //   cout<<"flow "<<source<<" ";
                       Repi(j-1)
                        {
                          //      cout<<q[i+1]<<" ";
                                M[q[i]][q[i+1]]-=k;
                                M[q[i+1]][q[i]]+=k;
                        }
                    //   cout<<" = "<<k<<endl;
                       flow+=(int)k; 
                       v=source;
                       continue;
           }
           
           k=-1;
           Repi(a[v].SZ)
            if (d[a[v][i]]==d[v]-1 && M[v][a[v][i]]) { k=a[v][i]; break; }
            
           if (k==-1)
            {
                     k=INF;
                     Repi(a[v].SZ) if (M[v][a[v][i]]) k=min(d[a[v][i]],k);
                     d[v]=k+1;
                     if (v!=source) v=p[v];
            }
           else
            {
                     p[k]=v;
                     v=k;
            } 
     }
     return flow;
}

int main()
{
    int i,j,k,l;
    ifstream f("stall4.in");
    f>>n>>m;
    sink=n+m+1;
    Repi(n) edge(source,i+1,1);
    Repi(m) edge(i+n+1,sink,1);
    Repi(n)
     {
           f>>k;
           Repj(k)
            { f>>l; edge(i+1,l+n,1); }
     } 
  //  pause;
    f.close();
    
    ofstream of("stall4.out");
    of<<Flow1()<<"\n";
    of.close();
    
    return 0;
}
