/*
ID:pascala1
TASK:twofive
LANG:C++
*/
//for some initial state of table (some letters put accordingly) find all possible ways to finish it using dp:
//1. find vacant letters 2. iterate over them in ascending order
//3. for each vacant letter for each state try to add it at an appropriate position (and advance to the corresponding next state)
//4. dp[encode{a,b,c,d,e}] = all possible ways to have a letters in column 1, b letters in column 2...e letters in column 5
//   of the table for its the current initial state (note that the dp is executed once for each new initial state)
//5. the number of ways to finish it is then in dp[encode{5,5,5,5,5}]
//note that we can know to which column it is possible to add a certain letter only by knowing the column heights and the initial setting of the table
//since each vacant letter that has been put was "smaller" than the current one and we are only restricted by the potentially "larger" letters that have been put beforehand
//note also that we can't leave any gaps while filling since we would later be forced to put a "larger" vacant letter before the current one
// ...then it's simple counting and trying until you reach the desired word or word number
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

int n,m,N,M,P,T,K;
char comm;

char let[]="ABCDEFGHIJKLMNOPQRSTUVWXY";

void gen()
{
	Repk(200)
	{
		bool valid=1;
		Repi(5) Repj(4) if (let[i*5+j]>let[i*5+j+1]) valid=0;
		Repi(5) Repj(4) if (let[j*5+i]>let[(j+1)*5+i]) valid=0;
		if (!valid) { k--; goto next; }
		 
		
		cout<<"--- "<<k+1<<":\n";
		Repi(5)		 {		  Repj(5)		   cout<<let[i*5+j];		  cout<<"\n";		 }
		cout<<endl;
		next:;
	    next_permutation(let,let+25);
	}
}



char table[8][8],lastR[8],lastC[8];
bool used[128];

void printable()
{
	for (int i=1;i<=5;i++)
	 cout<<"   "<<(table[i]+1)<<"\n";
	cout<<"   lastR "<<lastR+1<<"   lastC "<<lastC+1<<endl;
}

int dp[1<<16];
int encode(int a[])
{ int ret=0; for (int i=1;i<=5;i++) ret=(ret<<3)+a[i]; return ret; }
void decode(int ret,int a[])
{ for (int i=5;i>=1;i--) a[i]=ret&7,ret>>=3; a[0]=7; }

int q[1<<16],id[1<<16];
char vacant[26],vc;
int solve(int row,int col)
{
	vc=0; Repi(25) if (!used[i+'A']) vacant[vc++]=i+'A';
	memset(dp,0,sizeof(dp));
	int t[8],to;
	for (int i=1;i<=5;i++) t[i]=(i<=col)?row:row-1;
	q[0]=encode(t); dp[q[0]]=1; id[0]=0;
	for (int s=0,e=1;s<e;s++)
	 {
			decode(q[s],t);
			for (int i=1;i<=5;i++)
			 if (t[i]<5 && lastC[i]<vacant[id[s]] && lastR[t[i]+1]<vacant[id[s]] && t[i-1]>t[i])
			  { 
					t[i]++;
					to=encode(t);
					if (!dp[to]) id[e]=id[s]+1,q[e++]=to;
					dp[to]+=dp[q[s]];
					t[i]--;
			  }
	 }
	return dp[23405];
}



int getwhatever(int N,char s[],bool wordfromindex=1)
{
	memset(table,0,sizeof(table));
	memset(lastR,0,sizeof(lastR));
	memset(lastC,0,sizeof(lastC));
	memset(used,0,sizeof(used));
	int cnt,ret=0;
	for (int i=1;i<=5;i++)
 	 for (int j=1;j<=5;j++)
	  {
			for (table[i][j]='A';table[i][j]<='Z';table[i][j]++)
			 if (!used[table[i][j]] && table[i][j]>lastR[i] && table[i][j]>lastC[j])
			  {
					lastR[i]=lastC[j]=table[i][j];
					used[table[i][j]]=1;
					cnt=solve(i,j);
					
					if (wordfromindex)
					 {
					   if (cnt<N) N-=cnt;
					   else break;
					 }
					else
					 {
				 	   if (table[i][j]==s[(i-1)*5+j-1]) break;
					   ret+=cnt;
					 }
					
					used[table[i][j]]=0;
			  }
	  }
	  
	if (wordfromindex)
	 {
	   s[25]=0;
	   Repi(5) sprintf(s+i*5,"%s",table[i+1]+1);
	 }
	return ret+1;
}




int main()
{
//	freopen("twofive.in","r",stdin);
//	freopen("twofive.out","w",stdout);
	
    scanf("%c\n",&comm);
	char s[100];
    if (comm=='N')
     {
			int id;
			scanf("%d",&id);
			getwhatever(id,s);
			printf("%s\n",s);
	 }
	else
	 {
			scanf("%s",s);
			printf("%d\n",getwhatever(666,s,0));
	 }
    return 0;
}
