// dp[ last_visited_room ][ first_opposite_unvisited_room ]
// dp[a][b] either comes from the state where the first class between a and one of the ends was last visited (and its opposite was also b)
// OR from the state where the first class between b and the other end was visited (and a was its opposite)
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

#define MAXN 1024
int n,m,N,M,P,T,K,C,H,B;
PI klas[MAXN];
int dp[MAXN][MAXN]; PI come[MAXN][MAXN];

int solve(int a,int b)
{
    int &ret=dp[a][b];
    if (ret>-1) return ret;
    
    ret=INF; int tmp;
    int preva,prevb;
    if (a<=b) preva=a-1,prevb=b+1;
    else preva=a+1,prevb=b-1;
    
    if (preva>=0 && preva<C)
      {
        int tmp=max(solve(preva,b)+abs(klas[preva].x-klas[a].x),klas[a].y);
        if (tmp<ret) ret=tmp,come[a][b]=MP(preva,b);
      }
    if (prevb>=0 && prevb<C)
      {   
        int tmp=max(solve(prevb,a)+abs(klas[prevb].x-klas[a].x),klas[a].y);
        if (tmp<ret) ret=tmp,come[a][b]=MP(prevb,a);
      }
    
    return ret;
}



int main()
{
    scanf("%d%d%d",&C,&H,&B);
    Repi(C)
            scanf("%d%d",&klas[i].x,&klas[i].y);
    klas[C++]=MP(0,0);
    sort(klas,klas+C);
    
    memset(dp,-1,sizeof(dp));
    dp[0][C-1]=0;
    int ans=INF;
    Repi(C)
     ans=min(ans,solve(i,i)+abs(klas[i].x-B));
    printf("%d\n",ans);

    return 0;
}
